#ifndef _DONNEES_ASSEMBLEUR_COULEUR_H_
#define _DONNEES_ASSEMBLEUR_COULEUR_H_

#include <iostream>
#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Assembleur { namespace Couleur { DECL_SHARED_PTR(Couleur); DECL_SHARED_PTR(Reelle); DECL_SHARED_PTR(Frequencielle); DECL_SHARED_PTR(Complexe); } } } }

#include <src/donnees/expressions/expressionentier.h>
#include <src/donnees/expressions/expressionreel.h>
#include <src/donnees/expressions/expressioncouleurrvba.h>
#include <src/donnees/expressions/expressioncouleurhsva.h>

namespace Traceur
{
	namespace Png { class Image; }
	namespace Donnees
	{
		namespace Expression { class CouleurRVBA; }
		namespace Assembleur
		{
			class Assembleur;
			namespace Image { class Image; class Reelle; class Frequencielle; class Noyau; }
			class DrawAt;
			template<typename Couleur>
				class ArbreBitmapNoeud;
			namespace Couleur
			{
				class Couleur
				{
					friend class Traceur::Donnees::Assembleur::Assembleur;
					friend class Traceur::Donnees::Assembleur::Image::Image;
					friend class Traceur::Donnees::Assembleur::Image::Reelle;
					friend class Traceur::Donnees::Assembleur::Image::Noyau;
					friend class Traceur::Donnees::Assembleur::Image::Frequencielle;
					//friend class Traceur::Donnees::Assembleur::DrawAt;
					template<typename Couleur>
						friend class Traceur::Donnees::Assembleur::ArbreBitmapNoeud;
					friend class Traceur::Donnees::Expression::CouleurRVBA;
					//friend class Traceur::Png::Image;
					friend class Reelle;
					friend class Frequencielle;
					friend class Complexe;
					public:
					typedef Traceur::Donnees::Expression::Reel::TypeInterne Canal;
					Couleur(const Traceur::Donnees::Expression::CouleurRVBASP& couleur);
					Couleur(const Reelle& couleur);
					Couleur(const Frequencielle& couleur);
					void integre(Couleur couleur, Traceur::Donnees::Expression::Entier::TypeInterne alpha);
					void integre(Couleur couleur);
					void remplace(Couleur couleur);
					void operator+= (Couleur couleur)
					{
						_rouge += couleur._rouge;
						_vert  += couleur._vert ;
						_bleu  += couleur._bleu ;
						_alpha += couleur._alpha;
					};

					Couleur operator*(Couleur mult)
					{
						_rouge *= mult._rouge;
						_vert  *= mult._vert ;
						_bleu  *= mult._bleu ;
						_alpha *= mult._alpha;
						return *this;
					};

					bool operator==(Couleur couleur)
					{
						return (Traceur::Donnees::Expression::Reel(_rouge)==Traceur::Donnees::Expression::Reel(couleur._rouge))
							and (Traceur::Donnees::Expression::Reel(_vert )==Traceur::Donnees::Expression::Reel(couleur._vert ))
							and (Traceur::Donnees::Expression::Reel(_bleu )==Traceur::Donnees::Expression::Reel(couleur._bleu ))
							and (Traceur::Donnees::Expression::Reel(_alpha)==Traceur::Donnees::Expression::Reel(couleur._alpha));
					};
					bool operator!=(Couleur couleur)
					{
						return not (*this==couleur);
					};

					virtual void format(std::ostream& os);
					virtual ~Couleur() {};
					private:
					Couleur() :_rouge(0),_vert(0),_bleu(0),_alpha(0) {};
					Couleur(Canal rouge, Canal vert, Canal bleu, Canal alpha) :_rouge(rouge),_vert(vert),_bleu(bleu),_alpha(alpha) {};
					void alpha(Traceur::Donnees::Expression::Entier::TypeInterne& alpha) { _alpha = (_alpha*alpha)/255; };
					Canal _rouge;
					Canal _vert;
					Canal _bleu;
					Canal _alpha;
				};

				class Reelle
				{
					friend class Traceur::Donnees::Assembleur::Assembleur;
					friend class Traceur::Donnees::Assembleur::Image::Reelle;
					friend class Traceur::Donnees::Assembleur::Image::Noyau;
					friend class Traceur::Donnees::Assembleur::DrawAt;
					template<typename Couleur>
						friend class Traceur::Donnees::Assembleur::ArbreBitmapNoeud;
					friend class Traceur::Donnees::Expression::CouleurRVBA;
					friend class Traceur::Png::Image;
					friend class Couleur;
					friend class Frequencielle;
					friend class Complexe;
					public:
					typedef unsigned char Canal;
					Reelle(const Traceur::Donnees::Expression::CouleurRVBASP& couleur);
					Reelle(const Couleur& couleur);
					void integre(Reelle couleur, Traceur::Donnees::Expression::Entier::TypeInterne alpha);
					void integre(Reelle couleur);
					void remplace(Reelle couleur);
					virtual void format(std::ostream& os);
					virtual ~Reelle() {};
					private:
					Reelle() :_rouge(0),_vert(0),_bleu(0),_alpha(0) {};
					Reelle(Canal rouge, Canal vert, Canal bleu, Canal alpha) :_rouge(rouge),_vert(vert),_bleu(bleu),_alpha(alpha) {};
					void alpha(Traceur::Donnees::Expression::Entier::TypeInterne& alpha) { _alpha = (_alpha*alpha)/255; };
					Canal _rouge;
					Canal _vert;
					Canal _bleu;
					Canal _alpha;
				};

				class Frequencielle
				{
					friend class Traceur::Donnees::Assembleur::Assembleur;
					friend class Traceur::Donnees::Assembleur::Image::Image;
					friend class Traceur::Donnees::Assembleur::Image::Reelle;
					friend class Traceur::Donnees::Assembleur::Image::Frequencielle;
					friend class Traceur::Donnees::Assembleur::Image::Noyau;
					friend class Traceur::Donnees::Assembleur::DrawAt;
					template<typename Couleur>
						friend class Traceur::Donnees::Assembleur::ArbreBitmapNoeud;
					friend class Traceur::Donnees::Expression::CouleurRVBA;
					friend class Couleur;
					friend class Reelle;
					friend class Complexe;
					public:
					typedef Traceur::Donnees::Expression::Reel::TypeInterne Canal;
					Frequencielle(const Traceur::Donnees::Expression::CouleurRVBASP& couleur);
					Frequencielle(const Couleur& couleur);
					void integre(Frequencielle , Traceur::Donnees::Expression::Entier::TypeInterne alpha);
					void integre(Frequencielle couleur);
					void remplace(Frequencielle couleur);
					virtual void format(std::ostream& os);
					virtual ~Frequencielle() {};
					private:
					Frequencielle() :_rouge(0),_vert(0),_bleu(0),_alpha(0) {};
					Frequencielle(Canal rouge, Canal vert, Canal bleu, Canal alpha) :_rouge(rouge),_vert(vert),_bleu(bleu),_alpha(alpha) {};
					void alpha(Traceur::Donnees::Expression::Entier::TypeInterne& alpha) { _alpha = (_alpha*alpha)/255; };
					Canal _rouge;
					Canal _vert;
					Canal _bleu;
					Canal _alpha;
					Canal _phase_rouge;
					Canal _phase_vert;
					Canal _phase_bleu;
					Canal _phase_alpha;
				};

				class Complexe // utilisee uniquement
				{
					friend class Traceur::Donnees::Assembleur::Image::Reelle;
					friend class Traceur::Donnees::Assembleur::Image::Frequencielle;
					private:
						typedef double Canal;
						Complexe()
							:_reel_rouge(0), _reel_vert(0), _reel_bleu(0), _reel_alpha(0),
							 _imag_rouge(0), _imag_vert(0), _imag_bleu(0), _imag_alpha(0) {};
						Complexe(Couleur& couleur)
							:_reel_rouge(couleur._rouge), _reel_vert(couleur._vert), _reel_bleu(couleur._bleu), _reel_alpha(couleur._alpha),
							 _imag_rouge(0), _imag_vert(0), _imag_bleu(0), _imag_alpha(0) {};
						Complexe(Frequencielle& couleur)
							:_reel_rouge(couleur._rouge*::cos(couleur._phase_rouge)),
							 _reel_vert (couleur._vert *::cos(couleur._phase_vert )),
							 _reel_bleu (couleur._bleu *::cos(couleur._phase_bleu )),
							 _reel_alpha(couleur._alpha*::cos(couleur._phase_alpha)),
							 _imag_rouge(couleur._rouge*::sin(couleur._phase_rouge)),
							 _imag_vert (couleur._vert *::sin(couleur._phase_vert )),
							 _imag_bleu (couleur._bleu *::sin(couleur._phase_bleu )),
							 _imag_alpha(couleur._alpha*::sin(couleur._phase_alpha))
							{};
						operator Couleur ()
						{
							Couleur couleur(_reel_rouge,_reel_vert,_reel_bleu,_reel_alpha);
							return couleur;
						};
						operator Frequencielle ()
						{
							Frequencielle couleur;
							couleur._rouge = ::sqrt(_reel_rouge*_reel_rouge+_imag_rouge*_imag_rouge);
							couleur._phase_rouge = ::atan2(_imag_rouge,_reel_rouge);
							
							couleur._vert  = ::sqrt(_reel_vert *_reel_vert +_imag_vert *_imag_vert );
							couleur._phase_vert  = ::atan2(_imag_vert ,_reel_vert );
							
							couleur._bleu  = ::sqrt(_reel_bleu *_reel_bleu +_imag_bleu *_imag_bleu );
							couleur._phase_bleu  = ::atan2(_imag_bleu ,_reel_bleu );
							
							couleur._alpha = ::sqrt(_reel_alpha*_reel_alpha+_imag_alpha*_imag_alpha);
							couleur._phase_alpha = ::atan2(_imag_alpha,_reel_alpha);
							
							return couleur;
						};

						void operator+= (Complexe complexe)
						{
							_reel_rouge += complexe._reel_rouge;
							_reel_vert  += complexe._reel_vert ;
							_reel_bleu  += complexe._reel_bleu ;
							_reel_alpha += complexe._reel_alpha;
							_imag_rouge += complexe._imag_rouge;
							_imag_vert  += complexe._imag_vert ;
							_imag_bleu  += complexe._imag_bleu ;
							_imag_alpha += complexe._imag_alpha;
						};

						Complexe operator*(Couleur mult)
						{
							_reel_rouge *= mult._rouge;
							_reel_vert  *= mult._vert ;
							_reel_bleu  *= mult._bleu ;
							_reel_alpha *= mult._alpha;
							_imag_rouge *= mult._rouge;
							_imag_vert  *= mult._vert ;
							_imag_bleu  *= mult._bleu ;
							_imag_alpha *= mult._alpha;
							return *this;
						};

						Complexe operator*(Complexe mult)
						{
							_reel_rouge = _reel_rouge*mult._reel_rouge-_imag_rouge*mult._imag_rouge;
							_reel_vert  = _reel_vert *mult._reel_vert -_imag_vert *mult._imag_vert ;
							_reel_bleu  = _reel_bleu *mult._reel_bleu -_imag_bleu *mult._imag_bleu ;
							_reel_alpha = _reel_alpha*mult._reel_alpha-_imag_alpha*mult._imag_alpha;
							_imag_rouge = _reel_rouge*mult._imag_rouge+_imag_rouge*mult._reel_rouge;
							_imag_vert  = _reel_vert *mult._imag_vert +_imag_vert *mult._reel_vert ;
							_imag_bleu  = _reel_bleu *mult._imag_bleu +_imag_bleu *mult._reel_bleu ;
							_imag_alpha = _reel_alpha*mult._imag_alpha+_imag_alpha*mult._reel_alpha;
							return *this;
						};

						Complexe operator*(Canal mult)
						{
							_reel_rouge *= mult;
							_reel_vert  *= mult;
							_reel_bleu  *= mult;
							_reel_alpha *= mult;
							_imag_rouge *= mult;
							_imag_vert  *= mult;
							_imag_bleu  *= mult;
							_imag_alpha *= mult;
							return *this;
						};

						static Complexe exp_2i_pi(Canal frequence)
						{
							Complexe complexe;
							complexe._reel_rouge = complexe._reel_vert = complexe._reel_bleu = complexe._reel_alpha = ::cos(2*M_PI*frequence);
							complexe._imag_rouge = complexe._imag_vert = complexe._imag_bleu = complexe._imag_alpha = ::sin(2*M_PI*frequence);
							return complexe;
						};

						void format(std::ostream& os)
						{
							os << "COMPLEX[("<< _reel_rouge << "," << _imag_rouge << ") ; ("
							                 << _reel_vert  << "," << _imag_vert  << ") ; ("
							                 << _reel_bleu  << "," << _imag_bleu  << ") ; ("
							                 << _reel_alpha << "," << _imag_alpha << ")]   ";
						};

						Canal _reel_rouge;
						Canal _reel_vert ;
						Canal _reel_bleu ;
						Canal _reel_alpha;
						Canal _imag_rouge;
						Canal _imag_vert ;
						Canal _imag_bleu ;
						Canal _imag_alpha;
				};

			}
		}
	}
}

#endif
