#include <src/donnees/assembleur/drawcircle.h>
using namespace Traceur::Donnees::Assembleur;

template<typename ModeTrace>
void DrawCircle::trace(Image::Image& image, ModeTrace mode_trace)
{
	Coordonnee delta = 1-_rayon;
	mode_trace.trace(image,_centre.translate(Point(      0, _rayon)));
	mode_trace.trace(image,_centre.translate(Point(      0,-_rayon)));
	mode_trace.trace(image,_centre.translate(Point( _rayon,0      )));
	mode_trace.trace(image,_centre.translate(Point(-_rayon,0      )));
	Coordonnee ligne = 1;
	Coordonnee colonne = _rayon;
	while(ligne<colonne)
	{
		bool remplissage;
		if(delta<0)
		{
			delta += 2*ligne+3;
			remplissage = false;
		}
		else
		{
			delta += 2*(ligne-colonne)+5;
			colonne--;
			remplissage = _options._remplissage;
		}
		mode_trace.trace(image,_centre.translate(Point( ligne, colonne)));
		mode_trace.trace(image,_centre.translate(Point( ligne,-colonne)));
		mode_trace.trace(image,_centre.translate(Point(-ligne, colonne)));
		mode_trace.trace(image,_centre.translate(Point(-ligne,-colonne)));
		if(ligne!=colonne)
		{
			mode_trace.trace(image,_centre.translate(Point( colonne, ligne)));
			mode_trace.trace(image,_centre.translate(Point( colonne,-ligne)));
			mode_trace.trace(image,_centre.translate(Point(-colonne, ligne)));
			mode_trace.trace(image,_centre.translate(Point(-colonne,-ligne)));
		}
		if(remplissage)
		{
			for(Coordonnee remplir = -ligne+1 ; remplir<ligne ; ++remplir)
			{
				mode_trace.trace(image,_centre.translate(Point( remplir, colonne)));
				mode_trace.trace(image,_centre.translate(Point( remplir,-colonne)));
				mode_trace.trace(image,_centre.translate(Point( colonne, remplir)));
				mode_trace.trace(image,_centre.translate(Point(-colonne, remplir)));
			}
		}
		ligne++;
	}
	if(_options._remplissage)
	{
		for(Coordonnee x = -colonne+1 ; x<colonne ; ++x)
			for(Coordonnee y = -colonne+1 ; y<colonne ; ++y)
				mode_trace.trace(image,_centre.translate(Point(x,y)));

	}
}

void DrawCircle::trace(Image::Image& image)
{
	switch(_options)
	{
		case Image::ModeTrace::NORMAL:
			trace(image,TraceSurImage<Image::ModeTrace::NORMAL>());
			break;
		case Image::ModeTrace::SOLIDE:
			trace(image,TraceSurImage<Image::ModeTrace::SOLIDE>());
			break;
		case Image::ModeTrace::GOMME:
			trace(image,TraceSurImage<Image::ModeTrace::GOMME>());
			break;
	}
}

void DrawCircle::format(std::ostream& os)
{
	os << "draw CIRCLE[";
	_centre.format(os);
	os << ";" << _rayon;
	_options.format(os);
	os << "] // asm" << std::endl;
}

