#ifndef _DONNEES_ASSEMBLEUR_DRAWCIRCLE_H_
#define _DONNEES_ASSEMBLEUR_DRAWCIRCLE_H_

#include <iostream>
#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Assembleur { DECL_SHARED_PTR(DrawCircle); } } }

#include <src/donnees/assembleur/draw.h>
#include <src/donnees/assembleur/point.h>
#include <src/donnees/assembleur/systemecoordonnees.h>
#include <src/donnees/assembleur/optionssurface.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Assembleur
		{
			class DrawCircle : public Draw
			{
				public:
					DrawCircle(Point centre, Coordonnee rayon, OptionsSurface options)
						:_centre(centre), _rayon(rayon), _options(options) {};
					virtual void trace(Image::Image& image);
					template<typename ModeTrace>
						void trace(Image::Image& image, ModeTrace mode_trace);
					virtual void format(std::ostream& os);
					virtual ~DrawCircle() {};
				private:
					Point _centre;
					Coordonnee _rayon;
					OptionsSurface _options;
			};
		}
	}
}

#endif
