#include <src/donnees/assembleur/drawellipse.h>
#include <src/donnees/assembleur/segment.h>
#include <src/donnees/expressions/expressionreel.h>
using namespace Traceur::Donnees::Assembleur;

void DrawEllipse::trace(Point point)
{
	if(_symetrie)
	{
		!point;
	}
	_ellipse.insert(_centre.translate(point));
	-point;
	_ellipse.insert(_centre.translate(point));
}

template<typename ModeTrace>
void DrawEllipse::trace(Image::Image& image, ModeTrace mode_trace)
{
	//mode_trace.trace(image,_grand_axe);
	mode_trace.trace(image,_petit_axe);
	Point grand_axe=_grand_axe-_centre;
	Point petit_axe=_petit_axe-_centre;

	_symetrie=false;
	_ellipse.clear();
	if(grand_axe._x<0)
	{
#ifdef TRACEUR_DEBUG
		TRACEUR_TRACE << "SYM CENTRALE" << std::endl;
#endif
		-grand_axe;
		-petit_axe;
	}
	if(grand_axe._y<0)
	{
#ifdef TRACEUR_DEBUG
		TRACEUR_TRACE << "SYM AXIALE" << std::endl;
#endif
		!grand_axe;
		*petit_axe;
		_symetrie=true;
	}
	if(grand_axe._x*petit_axe._y-grand_axe._y*petit_axe._x<0)
	{
#ifdef TRACEUR_DEBUG
		TRACEUR_TRACE << "SENS TRIGO" << std::endl;
#endif
		-petit_axe;
	}
#ifdef TRACEUR_DEBUG
		TRACEUR_TRACE << "Grand axe : ";
		grand_axe.format(std::cerr);
		std::cerr << " Petit axe : ";
		petit_axe.format(std::cerr);
		std::cerr << std::endl;
#endif
	// TODO a convertir en entiers longs GMP
	Traceur::Donnees::Expression::Reel::TypeInterne norme_carree_grand_axe = grand_axe._x*grand_axe._x+grand_axe._y*_grand_axe._y;
	Traceur::Donnees::Expression::Reel::TypeInterne norme_carree_petit_axe = petit_axe._x*petit_axe._x+petit_axe._y*_petit_axe._y;
	Traceur::Donnees::Expression::Reel::TypeInterne fonction_x2 = grand_axe._y*grand_axe._y+petit_axe._y*petit_axe._y;
	Traceur::Donnees::Expression::Reel::TypeInterne fonction_y2 = grand_axe._x*grand_axe._x+petit_axe._x*petit_axe._x;
	Traceur::Donnees::Expression::Reel::TypeInterne fonction_xy = (2*(norme_carree_petit_axe-norme_carree_grand_axe)*grand_axe._x*grand_axe._y)/(norme_carree_grand_axe);
	Traceur::Donnees::Expression::Reel::TypeInterne fonction_x = 0;
	Traceur::Donnees::Expression::Reel::TypeInterne fonction_y = 0;
	Traceur::Donnees::Expression::Reel::TypeInterne fonction_c = -norme_carree_grand_axe*norme_carree_petit_axe;

	Point point = grand_axe;
	Traceur::Donnees::Expression::Reel::TypeInterne erreur=0;
#ifdef TRACEUR_DEBUG
	TRACEUR_TRACE << "octant 1" << std::endl;
#endif
	while(erreur+ecart<-2,1,2>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point)<=0)
	{ // octant 1
		trace(point);
#ifdef TRACEUR_DEBUG
		TRACEUR_TRACE << point << ": " << erreur << "| " << erreur+ecart<-2,1,2>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point) << std::endl;
#endif
		if((erreur+ecart<-1,2,2>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point))<=0)
		{ //Exterieur
			erreur += 4*(ecart<0,1>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point));
			point.translate(0,1);
		}
		else
		{ //Interieur
			erreur += 4*(ecart<-1,1>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point));
			point.translate(-1,1);
		}
	}
#ifdef TRACEUR_DEBUG
	TRACEUR_TRACE << "octant 2" << std::endl;
#endif
	while(erreur+ecart<-2,-1,2>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point)<=0)
	{ // octant 2
		trace(point);
#ifdef TRACEUR_DEBUG
		TRACEUR_TRACE << point << ": " << erreur << "| " << erreur+ecart<-2,-1,2>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point) << std::endl;
#endif
		if((erreur+ecart<-2,1,2>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point))<=0)
		{ //Exterieur
			erreur += 4*(ecart<-1,1>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point));
			point.translate(-1,1);
		}
		else
		{ //Interieur
			erreur += 4*(ecart<-1,0>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point));
			point.translate(-1,0);
		}
	}
#ifdef TRACEUR_DEBUG
	TRACEUR_TRACE << "octant 3" << std::endl;
#endif
	while(erreur+ecart<-1,-2,2>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point)<=0)
	{ // octant 3
		trace(point);
#ifdef TRACEUR_DEBUG
		TRACEUR_TRACE << point << ": " << erreur << "| " << erreur+ecart<-1,-2,2>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point) << std::endl;
#endif
		if((erreur+ecart<-2,-1,2>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point))<=0)
		{ //Exterieur
			erreur += 4*(ecart<-1,0>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point));
			point.translate(-1,0);
		}
		else
		{ //Interieur
			erreur += 4*(ecart<-1,-1>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point));
			point.translate(-1,-1);
		}
	}
#ifdef TRACEUR_DEBUG
	TRACEUR_TRACE << "octant 4" << std::endl;
#endif
	while(erreur+ecart<1,-2,2>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point)<=0)
	{ // octant 4
		trace(point);
#ifdef TRACEUR_DEBUG
		TRACEUR_TRACE << point << ": " << erreur << "| " << erreur+ecart<1,-2,2>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point) << std::endl;
#endif
		if((erreur+ecart<-1,-2,2>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point))<=0)
		{ //Exterieur
			erreur += 4*(ecart<-1,-1>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point));
			point.translate(-1,-1);
		}
		else
		{ //Interieur
			erreur += 4*(ecart<0,-1>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point));
			point.translate(0,-1);
		}
	}
#ifdef TRACEUR_DEBUG
	TRACEUR_TRACE << "octant 5" << std::endl;
#endif
	while(erreur+ecart<2,-1,2>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point)<=0)
	{ // octant 5
		trace(point);
#ifdef TRACEUR_DEBUG
		TRACEUR_TRACE << point << ": " << erreur << "| " << erreur+ecart<2,-1,2>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point) << std::endl;
#endif
		if((erreur+ecart<1,-2,2>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point))<=0)
		{ //Exterieur
			erreur += 4*(ecart<0,-1>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point));
			point.translate(0,-1);
		}
		else
		{ //Interieur
			erreur += 4*(ecart<1,-1>(fonction_x2,fonction_y2,fonction_xy,fonction_x,fonction_y,fonction_c,point));
			point.translate(1,-1);
		}
	}

	if(_options._remplissage)
	{
		if(_ellipse.empty())
			return;
		Point bas  =*(_ellipse.begin());
		Point haut =*(_ellipse.begin());
		for(auto it=_ellipse.cbegin() ; it!=_ellipse.cend(); ++it)
		{
			if(it->_x==bas._x)
			{
				haut=*it;
			}
			else
			{
				for(Coordonnee y=bas._y ; y<haut._y ; ++y)
				{
					mode_trace.trace(image,Point(bas._x,y));
				}
				bas=*it;
				haut=*it;
			}
		}
		for(Coordonnee y=bas._y ; y<haut._y ; ++y)
		{
			mode_trace.trace(image,Point(bas._x,y));
		}
	}
	else
	{
		for(auto it=_ellipse.cbegin() ; it!=_ellipse.cend(); ++it)
		{
			mode_trace.trace(image,*it);
		}
	}
}

void DrawEllipse::trace(Image::Image& image)
{
	switch(_options)
	{
		case Image::ModeTrace::NORMAL:
			trace(image,TraceSurImage<Image::ModeTrace::NORMAL>());
			break;
		case Image::ModeTrace::SOLIDE:
			trace(image,TraceSurImage<Image::ModeTrace::SOLIDE>());
			break;
		case Image::ModeTrace::GOMME:
			trace(image,TraceSurImage<Image::ModeTrace::GOMME>());
			break;
	}
}

void DrawEllipse::format(std::ostream& os)
{
	os << "draw ELLIPSE[";
	_centre.format(os);
	os << ";" ;
	_grand_axe.format(os);
	os << ";" ;
	_petit_axe.format(os);
	_options.format(os);
	os << "] // asm" << std::endl;
}

