#ifndef _DONNEES_ASSEMBLEUR_DRAWELLIPSE_H_
#define _DONNEES_ASSEMBLEUR_DRAWELLIPSE_H_

#include <iostream>
#include <set>
#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Assembleur { DECL_SHARED_PTR(DrawEllipse); } } }

#include <src/donnees/assembleur/draw.h>
#include <src/donnees/assembleur/point.h>
#include <src/donnees/assembleur/systemecoordonnees.h>
#include <src/donnees/assembleur/optionssurface.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Assembleur
		{
			class DrawEllipse : public Draw
			{
				public:
					DrawEllipse(Point centre, Point grand_axe, Point petit_axe, OptionsSurface options)
						:_centre(centre), _grand_axe(grand_axe), _petit_axe(petit_axe), _options(options), _symetrie(false), _ellipse() {};
					virtual void trace(Image::Image& image);
					template<typename ModeTrace>
						void trace(Image::Image& image, ModeTrace mode_trace);
					virtual void format(std::ostream& os);
					virtual ~DrawEllipse() {};
				private:
					void trace(Point point);
					//4*ecart<dx,dy>() ou ecart<2*dx,2*dy,2>()
					template<Coordonnee dx,Coordonnee dy, int coeff=1>
					static Traceur::Donnees::Expression::Reel::TypeInterne ecart(Traceur::Donnees::Expression::Reel::TypeInterne fonction_x2, Traceur::Donnees::Expression::Reel::TypeInterne fonction_y2, Traceur::Donnees::Expression::Reel::TypeInterne fonction_xy, Traceur::Donnees::Expression::Reel::TypeInterne fonction_x, Traceur::Donnees::Expression::Reel::TypeInterne fonction_y, Traceur::Donnees::Expression::Reel::TypeInterne fonction_c, Point p)
{
	return fonction_x2*(dx*dx+2*coeff*p._x*dx)+fonction_y2*(dy*dy+2*coeff*p._y*dy)+fonction_xy*(coeff*p._x*dy+coeff*p._y*dx+dx*dy)+coeff*fonction_x*dx+coeff*fonction_y*dy;
}

					Point _centre;
					Point _grand_axe;
					Point _petit_axe;
					OptionsSurface _options;
					bool _symetrie;
					std::set<Point> _ellipse;
			};
		}
	}
}

#endif
