#include <src/donnees/assembleur/drawline.h>
using namespace Traceur::Donnees::Assembleur;

template<typename ModeTrace>
void DrawLine::trace(Image::Image& image, ModeTrace mode_trace)
{
	Coordonnee deltaligne;
	Coordonnee deltacolonne;
	Coordonnee delta;
	Coordonnee incrementligne;
	Coordonnee incrementcolonne;
	Coordonnee incrementdeltanegatif;
	Coordonnee incrementdeltapositif;
	Coordonnee ligne;
	Coordonnee colonne;
	std::vector<bool> discontinu;
	for(Coordonnee indice = 0 ; indice<_options._ecart_trace ; ++indice)
		discontinu.push_back(true);
	for(Coordonnee indice = 0 ; indice<_options._ecart_non_trace ; ++indice)
		discontinu.push_back(false);
	if(_gauche._x<_droite._x)
		incrementligne=+1;
	else
		incrementligne=-1;
	if(_gauche._y<_droite._y)
		incrementcolonne=+1;
	else
		incrementcolonne=-1;
	deltaligne=_droite._x-_gauche._x;
	if(deltaligne<0)
		deltaligne=-deltaligne;
	deltacolonne=_droite._y-_gauche._y;
	if(deltacolonne<0)
		deltacolonne=-deltacolonne;
	if(deltacolonne<deltaligne)
	{
		delta=2*deltacolonne-deltaligne;
		incrementdeltanegatif=2*deltacolonne;
		incrementdeltapositif=2*(deltacolonne-deltaligne);
		for(ligne=_gauche._x,colonne=_gauche._y ; (incrementligne>0)?(ligne<=_droite._x):(ligne>=_droite._x) ; ligne+=incrementligne)
		{
			if(not ((_options._sans_debut and ((incrementligne>0)?(ligne<=_gauche._x):(ligne>=_gauche._x)))
				or (_options._sans_fin and ((incrementligne>0)?(ligne>=_droite._x):(ligne<=_droite._x)))
				or (_options._discontinue and not discontinu[(ligne-_gauche._x)%discontinu.size()])))
				mode_trace.trace(image,Point(ligne,colonne));
			if(delta<0)
				delta+=incrementdeltanegatif;
			else
			{
				delta+=incrementdeltapositif;
				colonne+=incrementcolonne;
			}
		}
	}
	else
	{
		delta=2*deltaligne-deltacolonne;
		incrementdeltanegatif=2*deltaligne;
		incrementdeltapositif=2*(deltaligne-deltacolonne);
		for(ligne=_gauche._x,colonne=_gauche._y ; (incrementcolonne>0)?(colonne<=_droite._y):(colonne>=_droite._y) ; colonne+=incrementcolonne)
		{
			if(not ((_options._sans_debut and ((incrementcolonne>0)?(colonne<=_gauche._y):(colonne>=_gauche._y)))
				or (_options._sans_fin and ((incrementcolonne>0)?(colonne>=_droite._y):(colonne<=_droite._y)))
				or (_options._discontinue and not discontinu[(colonne-_gauche._y)%discontinu.size()])))
				mode_trace.trace(image,Point(ligne,colonne));
			if(delta<0)
				delta+=incrementdeltanegatif;
			else
			{
				delta+=incrementdeltapositif;
				ligne+=incrementligne;
			}
		}
	}
}

void DrawLine::trace(Image::Image& image)
{
	switch(_options)
	{
		case Image::ModeTrace::NORMAL:
			trace(image,TraceSurImage<Image::ModeTrace::NORMAL>());
			break;
		case Image::ModeTrace::SOLIDE:
			trace(image,TraceSurImage<Image::ModeTrace::SOLIDE>());
			break;
		case Image::ModeTrace::GOMME:
			trace(image,TraceSurImage<Image::ModeTrace::GOMME>());
			break;
	}
}

void DrawLine::format(std::ostream& os)
{
	os << "draw LINE[";
	_gauche.format(os);
	os << ";";
	_droite.format(os);
	os << "] // asm" << std::endl;
}

