#ifndef _DONNEES_ASSEMBLEUR_DRAWPOINT_H_
#define _DONNEES_ASSEMBLEUR_DRAWPOINT_H_

#include <iostream>
#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Assembleur { DECL_SHARED_PTR(DrawLine); } } }

#include <src/donnees/assembleur/draw.h>
#include <src/donnees/assembleur/point.h>
#include <src/donnees/assembleur/systemecoordonnees.h>
#include <src/donnees/assembleur/optionsligne.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Assembleur
		{
			class DrawLine : public Draw
			{
				public:
					DrawLine(Point gauche, Point droite, OptionsLigne options)
						:_gauche(gauche), _droite(droite), _options(options) {};
					virtual void trace(Image::Image& image);
					template<typename ModeTrace>
						void trace(Image::Image& image, ModeTrace mode_trace);
					virtual void format(std::ostream& os);
					virtual ~DrawLine() {};
				private:
					Point _gauche;
					Point _droite;
					OptionsLigne _options;
			};
		}
	}
}

#endif
