#ifndef _DONNEES_ASSEMBLEUR_DRAWRECTANGLE_H_
#define _DONNEES_ASSEMBLEUR_DRAWRECTANGLE_H_

#include <iostream>
#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Assembleur { DECL_SHARED_PTR(DrawRectangle); } } }

#include <src/donnees/assembleur/draw.h>
#include <src/donnees/assembleur/point.h>
#include <src/donnees/assembleur/systemecoordonnees.h>
#include <src/donnees/assembleur/optionssurface.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Assembleur
		{
			class DrawRectangle : public Draw
			{
				public:
					DrawRectangle(Point sommet1, Point sommet2, Point sommet3, Point sommet4, OptionsSurface options)
						:_sommet1(sommet1), _sommet2(sommet2), _sommet3(sommet3), _sommet4(sommet4), _options(options) {};
					virtual void trace(Image::Image& image);
					template<typename ModeTrace>
						void trace(Image::Image& image, ModeTrace mode_trace);
					virtual void format(std::ostream& os);
					virtual ~DrawRectangle() {};
				private:
					Point _sommet1;
					Point _sommet2;
					Point _sommet3;
					Point _sommet4;
					OptionsSurface _options;
			};
		}
	}
}

#endif
