#include <set>
#include <src/donnees/assembleur/drawtriangle.h>
#include <src/donnees/assembleur/segment.h>
using namespace Traceur::Donnees::Assembleur;

template<typename ModeTrace>
void DrawTriangle::trace(Image::Image& image, ModeTrace mode_trace)
{
	std::multiset<Point> ordre;
	ordre.insert(_sommet1);
	ordre.insert(_sommet2);
	ordre.insert(_sommet3);
	auto iter = ordre.cbegin();
	_sommet1 = *iter++;
	_sommet2 = *iter++;
	_sommet3 = *iter;
	Segment cote_long(_sommet1,_sommet3);
	Segment cote_court(_sommet1,_sommet2);
	for(Coordonnee x=_sommet1._x ; x<=_sommet3._x ; ++x)
	{
		Coordonnee min_long;
		Coordonnee max_long;
		Coordonnee min_court;
		Coordonnee max_court;

		cote_long.points(min_long,max_long);
		cote_court.points(min_court,max_court);

		if(x==_sommet2._x)
		{
			Coordonnee nouveau_min;
			Coordonnee nouveau_max;
			bool inutile;
			cote_court = Segment(_sommet2,_sommet3);
			cote_court.points(nouveau_min,nouveau_max);
			Segment::fusion(true,min_court,max_court,nouveau_min,nouveau_max,inutile);
		}
		
		bool double_segment;
		Segment::fusion(_options._remplissage,min_long,max_long,min_court,max_court,double_segment);
		for(Coordonnee y=min_long ; y<=max_long ; ++y)
		{
			Point point(x,y);
			mode_trace.trace(image,point);
		}
		if(double_segment)
		{
			for(Coordonnee y=min_court ; y<=max_court ; ++y)
			{
				Point point(x,y);
				mode_trace.trace(image,point);
			}
		}
	}
	
}

void DrawTriangle::trace(Image::Image& image)
{
	switch(_options)
	{
		case Image::ModeTrace::NORMAL:
			trace(image,TraceSurImage<Image::ModeTrace::NORMAL>());
			break;
		case Image::ModeTrace::SOLIDE:
			trace(image,TraceSurImage<Image::ModeTrace::SOLIDE>());
			break;
		case Image::ModeTrace::GOMME:
			trace(image,TraceSurImage<Image::ModeTrace::GOMME>());
			break;
	}
}

void DrawTriangle::format(std::ostream& os)
{
	os << "draw TRIANGLE[";
	_sommet1.format(os);
	os << ";" ;
	_sommet2.format(os);
	os << ";" ;
	_sommet3.format(os);
	_options.format(os);
	os << "] // asm" << std::endl;
}

