#ifndef _DONNEES_ASSEMBLEUR_OPTIONSLIGNE_H_
#define _DONNEES_ASSEMBLEUR_OPTIONSLIGNE_H_

#include <iostream>
#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Assembleur { DECL_SHARED_PTR(OptionsLigne); } } }

#include <src/donnees/assembleur/image.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Assembleur
		{
			class DrawLine;
			class OptionsLigne
			{
				friend class DrawLine;
				public:
					OptionsLigne(bool sans_debut, bool sans_fin, bool solide, bool gomme, bool discontinue, Coordonnee ecart_trace, Coordonnee ecart_non_trace)
					:_sans_debut(sans_debut), _sans_fin(sans_fin), _solide(solide), _gomme(gomme),
					 _discontinue(discontinue), _ecart_trace(ecart_trace), _ecart_non_trace(ecart_non_trace) {};
					void format(std::ostream& os);
					operator Image::ModeTrace ()
					{
						if(_solide)
							return Image::ModeTrace::SOLIDE;
						if(_gomme)
							return Image::ModeTrace::GOMME;
						return Image::ModeTrace::NORMAL;
					};
					~OptionsLigne() {};
				private:
					bool _sans_debut;
					bool _sans_fin;
					bool _solide;
					bool _gomme;
					bool _discontinue;
					Coordonnee _ecart_trace;
					Coordonnee _ecart_non_trace;
			};
		}
	}
}

#endif
