#ifndef _DONNEES_ASSEMBLEUR_OPTIONSSURFACE_H_
#define _DONNEES_ASSEMBLEUR_OPTIONSSURFACE_H_

#include <iostream>
#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Assembleur { DECL_SHARED_PTR(OptionsSurface); } } }

#include <src/donnees/assembleur/image.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Assembleur
		{
			class DrawCircle;
			class DrawFill;
			class DrawTriangle;
			class DrawRectangle;
			class DrawEllipse;
			class OptionsSurface
			{
				friend class DrawCircle;
				friend class DrawFill;
				friend class DrawTriangle;
				friend class DrawRectangle;
				friend class DrawEllipse;
				public:
					OptionsSurface(bool remplissage, bool solide, bool gomme) :_remplissage(remplissage), _solide(solide), _gomme(gomme) {};
					void format(std::ostream& os);
					operator Image::ModeTrace ()
					{
						if(_solide)
							return Image::ModeTrace::SOLIDE;
						if(_gomme)
							return Image::ModeTrace::GOMME;
						return Image::ModeTrace::NORMAL;
					};
					~OptionsSurface() {};
				private:
					bool _remplissage;
					bool _solide;
					bool _gomme;
			};
		}
	}
}

#endif
