#include <src/donnees/assembleur/point.h>
using namespace Traceur::Donnees::Assembleur;

Point::Point(const Traceur::Donnees::Expression::PointSP& point, const SystemeCoordonnees& coordonnees)
{
	coordonnees.transforme_point(point,_x,_y);
}

Coordonnee Point::distance(Point& point) const
{
	return Traceur::Donnees::Expression::Entier(::ceil(::sqrt((_x-point._x)*(_x-point._x)+(_y-point._y)*(_y-point._y))-0.5))._entier;
}

Coordonnee Point::norme_carree(Point point1, Point point2)
{
	return (point2._x-point1._x)*(point2._x-point1._x)+(point2._y-point1._y)*(point2._y-point1._y);
}

void Point::format(std::ostream& os) const
{
	os << "POINT[" << _x << ";" << _y << "]" ;
}

namespace Traceur
{
	namespace Donnees
	{
		namespace Assembleur
		{
std::ostream& operator<<(std::ostream& os, const Point point)
{
	point.format(os);
	return os;
}
		}
	}
}
