#ifndef _DONNEES_ASSEMBLEUR_POINT_H_
#define _DONNEES_ASSEMBLEUR_POINT_H_

#include <iostream>
#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Assembleur { DECL_SHARED_PTR(Point); } } }

#include <src/donnees/expressions/expressionpoint.h>
#include <src/donnees/assembleur/systemecoordonnees.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Expression { class Triangle; class Rectangle; class Ellipse; }
		namespace Assembleur
		{
			namespace Image { class Image; class Reelle; class Frequencielle; class Noyau; }
			class DrawPoint;
			class DrawCircle;
			class DrawLine;
			class DrawTriangle;
			class DrawRectangle;
			class DrawEllipse;
			class DrawFill;
			class DrawAt;
			class Segment;
			template <typename Couleur>
				class ArbreBitmapNoeud;
			template <typename Couleur>
				class CacheBitmap;
			class Point
			{
				friend class Traceur::Donnees::Expression::Triangle;
				friend class Traceur::Donnees::Expression::Rectangle;
				friend class Traceur::Donnees::Expression::Ellipse;
				friend class Image::Image;
				friend class Image::Reelle;
				friend class Image::Frequencielle;
				friend class Image::Noyau;
				friend class DrawPoint;
				friend class DrawCircle;
				friend class DrawLine;
				friend class DrawTriangle;
				friend class DrawRectangle;
				friend class DrawEllipse;
				friend class DrawFill;
				friend class DrawAt;
				friend class Segment;
				template <typename Couleur>
					friend class ArbreBitmapNoeud;
				template <typename Couleur>
					friend class CacheBitmap;
				public:
					Point(const Traceur::Donnees::Expression::PointSP& point, const SystemeCoordonnees& coordonnees);
					virtual void format(std::ostream& os) const;
					virtual ~Point() {};
					Coordonnee distance(Point& point) const;
					static Coordonnee norme_carree(Point point1, Point point2);
					bool operator!=(Point point) { return (_x!=point._x) or (_y!=point._y); };
					Point operator-(Point point) { return Point(_x-point._x,_y-point._y); };
					void operator-() { _x *= -1; _y *= -1; };
					void operator!() { _y *= -1; };
					void operator*() { _x *= -1; };
					bool operator<(const Point point) const { return (_x<point._x) or ((_x==point._x) and (_y<point._y)); };
				private:
					Point() :_x(0), _y(0) {};
					Point(Coordonnee x, Coordonnee y) :_x(x), _y(y) {};
					Point translate(Point point) { return Point(_x+point._x,_y+point._y); };
					void translate(Coordonnee x, Coordonnee y) { _x += x; _y += y; };
					Coordonnee _x;
					Coordonnee _y;
			};
			std::ostream& operator<<(std::ostream& os, const Point point);
		}
	}
}

#endif
