#include <src/donnees/assembleur/segment.h>
using namespace Traceur::Donnees::Assembleur;

Segment::Segment(Point depart, Point arrivee)
	:_depart(depart), _arrivee(arrivee)
{
	TRACEUR_TEST(depart._x<=arrivee._x);
	if(depart._y<=arrivee._y)
		_incrementordonnee=1;
	else
		_incrementordonnee=-1;
	Coordonnee deltaabscisse = arrivee._x-depart._x;
	Coordonnee deltaordonnee = arrivee._y-depart._y;
	if(deltaordonnee<0)
		deltaordonnee *= -1;
	
	if(deltaordonnee<deltaabscisse)
	{
		_sens = Sens::NORMAL;
		_delta = 2*deltaordonnee-deltaabscisse;
		_incrementdeltanegatif = 2*deltaordonnee;
		_incrementdeltapositif = 2*(deltaordonnee-deltaabscisse);
	}
	else
	{
		_sens = Sens::INVERSE;
		_delta = 2*deltaabscisse-deltaordonnee;
		_incrementdeltanegatif = 2*deltaabscisse;
		_incrementdeltapositif = 2*(deltaabscisse-deltaordonnee);
	}
	_ordonnee = depart._y;
#ifdef TRACEUR_DEBUG
	std::cerr << "Segment : ";
	_depart.format(std::cerr);
	std::cerr << "-";
	_arrivee.format(std::cerr);
	std::cerr << " " << _incrementordonnee << " " << deltaordonnee << " " << deltaabscisse << std::endl;
#endif
}

void Segment::points(Coordonnee& min, Coordonnee& max)
{
	if(_sens==Sens::NORMAL)
	{
		min = _ordonnee;
		max = _ordonnee;
		if(_delta<0)
		{
			_delta += _incrementdeltanegatif;
		}
		else
		{
			_delta += _incrementdeltapositif;
			_ordonnee += _incrementordonnee;
		}
	}
	else
	{
		min = _ordonnee;
		while(_delta<0)
		{
#ifdef TRACEUR_DEBUG
			std::cerr << _delta << " ";
#endif
			_delta += _incrementdeltanegatif;
			_ordonnee += _incrementordonnee;
			if(_incrementordonnee>0)
			{
				if(_arrivee._y<_ordonnee)
				{
					max = _arrivee._y;
					return;
				}
			}
			else
			{
				if(_arrivee._y>_ordonnee)
				{
					max = min;
					min = _arrivee._y;
					return;
				}
			}
		}
#ifdef TRACEUR_DEBUG
		std::cerr << _delta << std::endl;
#endif
		_delta += _incrementdeltapositif;
		max = _ordonnee;
		_ordonnee += _incrementordonnee;
		if(max<min)
		{
			Coordonnee temp;
			temp=min;
			min=max;
			max=temp;
		}
	}
}

void Segment::fusion(bool remplissage, Coordonnee& min1, Coordonnee& max1, Coordonnee& min2, Coordonnee& max2, bool& double_segment)
{
	if(remplissage)
	{
		double_segment=false;
		if(min2<min1)
			min1=min2;
		if(max2>max1)
			max1=max2;
	}
	else
	{
		if(min2<min1)
		{
			Coordonnee min = min2;
			min2 = min1;
			min1 = min;
		}
		if(max2<max1)
		{
			Coordonnee max = max2;
			max2 = max1;
			max1 = max;
		}
		if(min2<=max1)
		{
			double_segment = false;
			max1 = max2;
		}
		else
		{
			double_segment = true;
		}
	}
}
