#include <src/donnees/expressions/expressionaleatoire.h>

#include <src/donnees/types/types.h>
#include <src/donnees/expressions/expressionentier.h>

using namespace Traceur::Donnees::Expression;
Aleatoire::Aleatoire()
{
	_type = Traceur::Donnees::Type::Integer::SP();
}

Traceur::Donnees::Instruction::ValeurSP Aleatoire::evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur)
{
	Traceur::Donnees::Instruction::ValeurSP valeur(new Traceur::Donnees::Instruction::Valeur(Entier::aleatoire()));
	return valeur;
}

void Aleatoire::format(std::ostream& os) const
{
	os << "rand";
}

ExpressionSP Aleatoire::clone(Traceur::Donnees::Global::ClonesInstances& clones_instances)
{
	AleatoireSP clone(new Aleatoire());
	return clone;
}
