#ifndef _DONNEES_EXPRESSIONS_APPELFONCTION_H_
#define _DONNEES_EXPRESSIONS_APPELFONCTION_H_


#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(AppelFonction); } } }

#include <src/donnees/expressions/expression.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Expression
		{
			class AppelFonction: public Expression
			{
				public:
					AppelFonction() = default;
					AppelFonction(const Traceur::Donnees::Type::TypeSP& type) { _type=type; };
					virtual ~AppelFonction() {};
				private:
			};
		}
	}
}

namespace Traceur
{
	namespace Exception
	{
		class TypeIncorrectAppelFonction : public TypeIncorrect
		{
			protected:
				TypeIncorrectAppelFonction(Traceur::Donnees::Source::PositionSP position, std::string message)
					:TypeIncorrect(position,std::string("Function call ")+message+" does not match any function.") {};
		};

		class TypeIncorrectAppelFonctionPrefixe : public TypeIncorrectAppelFonction
		{
			public:
				TypeIncorrectAppelFonctionPrefixe(Traceur::Donnees::Source::PositionSP position, std::string nom,Traceur::Donnees::Expression::ExpressionSP expression)
					:TypeIncorrectAppelFonction(position,nom+" "+std::string(*(expression->type()))) {};
		};

		class TypeIncorrectAppelFonctionAutour : public TypeIncorrectAppelFonction
		{
			public:
				TypeIncorrectAppelFonctionAutour(Traceur::Donnees::Source::PositionSP position, std::string gauche, Traceur::Donnees::Expression::ExpressionSP expression, std::string droite)
					:TypeIncorrectAppelFonction(position,gauche+std::string(*(expression->type()))+droite) {};
		};

		class TypeIncorrectAppelFonctionInfixe : public TypeIncorrectAppelFonction
		{
			public:
				TypeIncorrectAppelFonctionInfixe(Traceur::Donnees::Source::PositionSP position, Traceur::Donnees::Expression::ExpressionSP gauche,std::string nom,Traceur::Donnees::Expression::ExpressionSP droite)
					:TypeIncorrectAppelFonction(position,std::string(*(gauche->type()))+" "+nom+" "+std::string(*(droite->type()))) {};
		};

		class TypeIncorrectAppelFonctionPostfixe : public TypeIncorrectAppelFonction
		{
			public:
				TypeIncorrectAppelFonctionPostfixe(Traceur::Donnees::Source::PositionSP position, std::string nom,Traceur::Donnees::Expression::ExpressionSP expression)
					:TypeIncorrectAppelFonction(position,std::string(*(expression->type()))+" "+nom) {};
		};

		class TypeIncorrectAppelFonctionConversionUn : public TypeIncorrectAppelFonction
		{
			public:
				TypeIncorrectAppelFonctionConversionUn(Traceur::Donnees::Source::PositionSP position, std::string nom,Traceur::Donnees::Expression::ExpressionSP expression)
					:TypeIncorrectAppelFonction(position,nom+"["+std::string(*(expression->type()))+"]") {};
		};

		class TypeIncorrectAppelFonctionConversionUnPlusChaine : public TypeIncorrectAppelFonction
		{
			public:
				TypeIncorrectAppelFonctionConversionUnPlusChaine(Traceur::Donnees::Source::PositionSP position, std::string nom,Traceur::Donnees::Expression::ExpressionSP expression, std::string chaine)
					:TypeIncorrectAppelFonction(position,nom+"["+std::string(*(expression->type()))+";~"+chaine+"]") {};
		};

		class TypeIncorrectAppelFonctionConversionDeux : public TypeIncorrectAppelFonction
		{
			public:
				TypeIncorrectAppelFonctionConversionDeux(Traceur::Donnees::Source::PositionSP position, std::string nom,Traceur::Donnees::Expression::ExpressionSP gauche,
					Traceur::Donnees::Expression::ExpressionSP droite)
					:TypeIncorrectAppelFonction(position,nom+"["+std::string(*(gauche->type()))+";"+std::string(*(droite->type()))+"]") {};
		};

		class TypeIncorrectAppelFonctionConversionTrois : public TypeIncorrectAppelFonction
		{
			public:
				TypeIncorrectAppelFonctionConversionTrois(Traceur::Donnees::Source::PositionSP position, std::string nom,Traceur::Donnees::Expression::ExpressionSP valeur1,
					Traceur::Donnees::Expression::ExpressionSP valeur2,Traceur::Donnees::Expression::ExpressionSP valeur3)
					:TypeIncorrectAppelFonction(position,nom+"["+std::string(*(valeur1->type()))+";"+
					std::string(*(valeur2->type()))+";"+std::string(*(valeur3->type()))+"]") {};
		};

		class TypeIncorrectAppelFonctionConversionQuatre : public TypeIncorrectAppelFonction
		{
			public:
				TypeIncorrectAppelFonctionConversionQuatre(Traceur::Donnees::Source::PositionSP position, std::string nom,Traceur::Donnees::Expression::ExpressionSP valeur1,
					Traceur::Donnees::Expression::ExpressionSP valeur2,Traceur::Donnees::Expression::ExpressionSP valeur3,Traceur::Donnees::Expression::ExpressionSP valeur4)
					:TypeIncorrectAppelFonction(position,nom+"["+std::string(*(valeur1->type()))+";"+
					std::string(*(valeur2->type()))+";"+std::string(*(valeur3->type()))+";"+std::string(*(valeur4->type()))+"]") {};
		};

	}
}
#endif
