#ifndef _DONNEES_EXPRESSIONS_APPELFONCTIONINTERNEBINAIRE_H_
#define _DONNEES_EXPRESSIONS_APPELFONCTIONINTERNEBINAIRE_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(AppelFonctionInterneBinaire); } } }

#include <src/donnees/expressions/expressionappelfonctioninterne.h>
#include <src/donnees/expressions/expressionerreur.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Expression
		{
			class AppelFonctionInterneBinaire: public AppelFonctionInterne
			{
				public:
					AppelFonctionInterneBinaire() = default;
					virtual void edition_liens(Traceur::Donnees::Instruction::InstructionSP instruction);
					virtual void definition_fonction();
					virtual bool est_constante() { return _gauche->est_constante() and _droite->est_constante(); };

					virtual ExpressionSP simplification()
					{
#ifdef TRACEUR_DEBUG
						TRACEUR_TRACE; format(std::cerr); std::cerr << std::endl;
#endif
						_gauche = _gauche->simplification();
						_droite = _droite->simplification();
						if(est_constante())
						{
							Traceur::Donnees::Assembleur::AssembleurSP assembleur;
							ExpressionSP resultat = *(evaluation(assembleur));
							if(resultat->est_de_nature<Erreur>())
								return this->shared_from_this();
							return resultat;
						}
						return this->shared_from_this();
					};

					virtual ~AppelFonctionInterneBinaire() {};
				protected:
					AppelFonctionInterneBinaire(ExpressionSP gauche, ExpressionSP droite);
					ExpressionSP _gauche;
					ExpressionSP _droite;
			};
		}
	}
}

#endif
