#ifndef _DONNEES_EXPRESSIONS_APPELFONCTIONINTERNETERNAIRE_H_
#define _DONNEES_EXPRESSIONS_APPELFONCTIONINTERNETERNAIRE_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(AppelFonctionInterneTernaire); } } }

#include <src/donnees/expressions/expressionappelfonctioninterne.h>
#include <src/donnees/expressions/expressionerreur.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Expression
		{
			class AppelFonctionInterneTernaire: public AppelFonctionInterne
			{
				public:
					AppelFonctionInterneTernaire() = default;
					virtual void edition_liens(Traceur::Donnees::Instruction::InstructionSP instruction);
					virtual void definition_fonction();
					virtual bool est_constante() { return _valeur1->est_constante() and _valeur2->est_constante() and _valeur3->est_constante(); };
					virtual ExpressionSP simplification()
					{
#ifdef TRACEUR_DEBUG
						std::cerr << __FILE__ << " "; format(std::cerr); std::cerr << std::endl;
#endif
						_valeur1 = _valeur1->simplification();
						_valeur2 = _valeur2->simplification();
						_valeur3 = _valeur3->simplification();
						if(est_constante())
						{
							Traceur::Donnees::Assembleur::AssembleurSP assembleur;
							ExpressionSP resultat = *(evaluation(assembleur));
							if(resultat->est_de_nature<Erreur>())
								return this->shared_from_this();
							return resultat;
						}
						return this->shared_from_this();
					};
					virtual ~AppelFonctionInterneTernaire() {};
				protected:
					AppelFonctionInterneTernaire(ExpressionSP valeur1, ExpressionSP valeur2, ExpressionSP valeur3);
					ExpressionSP _valeur1;
					ExpressionSP _valeur2;
					ExpressionSP _valeur3;
			};
		}
	}
}

#endif
