#ifndef _DONNEES_EXPRESSIONS_APPELFONCTIONINTERNEUNAIRE_H_
#define _DONNEES_EXPRESSIONS_APPELFONCTIONINTERNEUNAIRE_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(AppelFonctionInterneUnaire); } } } 

#include <src/donnees/expressions/expressionappelfonctioninterne.h>
#include <src/donnees/expressions/expressionerreur.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Expression
		{
			class AppelFonctionInterneUnaire: public AppelFonctionInterne
			{
				public:
					AppelFonctionInterneUnaire() = default;
					virtual void edition_liens(Traceur::Donnees::Instruction::InstructionSP instruction);
					virtual void definition_fonction();
					virtual bool est_constante() { return _valeur->est_constante(); };
					virtual ExpressionSP simplification()
					{
#ifdef TRACEUR_DEBUG
						std::cerr << __FILE__ << " "; format(std::cerr); std::cerr << std::endl;
#endif
						_valeur = _valeur->simplification();
						if(est_constante())
						{
							Traceur::Donnees::Assembleur::AssembleurSP assembleur;
							ExpressionSP resultat = *(evaluation(assembleur));
							if(resultat->est_de_nature<Erreur>())
								return this->shared_from_this();
							return resultat;
						}
						return this->shared_from_this();
					};
					virtual ~AppelFonctionInterneUnaire() {};
				protected:
					AppelFonctionInterneUnaire(ExpressionSP valeur);
					ExpressionSP _valeur;
			};
		}
	}
}

#endif
