#ifndef _DONNEES_EXPRESSIONS_APPELFONCTIONUTILISATEUR_H_
#define _DONNEES_EXPRESSIONS_APPELFONCTIONUTILISATEUR_H_
#include <vector>

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(AppelFonctionUtilisateur); DECL_WEAK_PTR(AppelFonctionUtilisateur); } } } 

#include <src/donnees/expressions/expressionappelfonction.h>
#include <src/donnees/types/type.h>
#include <src/donnees/fonctions/fonctionimaginaire.h>
#include <src/donnees/fonctions/fonctionidentifiant.h>
#include <src/donnees/fonctions/instance.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Instruction { class LetFunc; }
		namespace Expression
		{
			class AppelFonctionUtilisateur: public AppelFonction
			{
				friend class Traceur::Donnees::Instruction::LetFunc;
				public:
					typedef std::vector<ExpressionSP> ListeParametres;
					AppelFonctionUtilisateur(const Traceur::Donnees::Type::TypeSP type_retour,const ListeParametres gauche, const Traceur::Donnees::Fonction::Identifiant nom_fonction, const ListeParametres droite,Traceur::Donnees::Source::PositionSP position = Traceur::Donnees::Source::PositionSP())
						:AppelFonction(type_retour),_parametres_gauche(gauche),_nom_fonction(nom_fonction),_parametres_droite(droite),_position(position) {};
					virtual void edition_liens(Traceur::Donnees::Instruction::InstructionSP instruction);
					virtual void definition_fonction();
					virtual ExpressionSP simplification();
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					void disp(std::ostream& os) const;
					virtual void format(std::ostream& os) const;
					virtual ~AppelFonctionUtilisateur() {};
				private:
					AppelFonctionUtilisateur() {};
					AppelFonctionUtilisateur(Traceur::Donnees::Source::PositionSP position, Traceur::Donnees::Instruction::InstructionSP instruction)
						:_position(position),_instruction(instruction) {};
					ListeParametres _parametres_gauche;
					Traceur::Donnees::Fonction::Identifiant _nom_fonction;
					ListeParametres _parametres_droite;
					Traceur::Donnees::Fonction::InstanceSP _instance;
					//Traceur::Donnees::Fonction::InstanceWP _instance; // l'edition de liens assure la perennite de ce pointeur
											//(si SP mem leak sur let Int a:=Int a+1)
					Traceur::Donnees::Fonction::FonctionSP _valeur_dynamique;
					Traceur::Donnees::Source::PositionSP _position;
					Traceur::Donnees::Instruction::InstructionWP _instruction;
			};
		}
	}
}

#endif
