#ifndef _DONNEES_EXPRESSIONS_CATCH_H_
#define _DONNEES_EXPRESSIONS_CATCH_H_


#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(Catch);} } }

#include <src/donnees/expressions/expressionappelfonctioninternebinaire.h>
#include <src/donnees/types/type.h>

// TODO definition des objets fonctions qui mappent le +
// => pour les exceptions, mais aussi pour les fonctions d'encapsulation
// Integer fonction(func Integer (Integer gauche)+(Integer droite))
// pb avec let func ?
namespace Traceur
{
	namespace Donnees
	{
		namespace Expression
		{
			class Catch: public AppelFonctionInterne
			{
				public:
					Catch(ExpressionSP essai, Traceur::Donnees::Fonction::Identifiant nom_erreur,ExpressionSP clause_catch,Traceur::Donnees::Source::PositionSP position);
					Catch(ExpressionSP essai, ExpressionSP clause_catch,Traceur::Donnees::Source::PositionSP position);
					virtual ~Catch() {};
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual void edition_liens(Traceur::Donnees::Instruction::InstructionSP instruction);
					virtual void definition_fonction();
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual void format(std::ostream& os) const;
				private:
					ExpressionSP _essai;
					Traceur::Donnees::Fonction::Identifiant _nom_erreur;
					ExpressionSP _clause_catch;
					Traceur::Donnees::Source::PositionSP _position;
					CatchSP _evaluateur;
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Fonction::Identifiant,
							const Traceur::Donnees::Instruction::ValeurSP) const;
					void aide_construction();
				protected:
					Catch() {};
			};

		}
	}
}

namespace Traceur
{
	namespace Exception
	{
		class TypeIncorrectCatch : public TypeIncorrectAppelFonction
		{
			public:
				TypeIncorrectCatch(Traceur::Donnees::Source::PositionSP position, Traceur::Donnees::Expression::ExpressionSP essai,Traceur::Donnees::Expression::ExpressionSP clause_catch)
					:TypeIncorrectAppelFonction(position,std::string("CATCH[")+std::string(*(essai->type()))+";error;"+std::string(*(clause_catch->type()))+"]") {};
		};
	}
}
#endif
