#ifndef _DONNEES_EXPRESSIONS_CERCLE_H_
#define _DONNEES_EXPRESSIONS_CERCLE_H_


#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(Cercle);} } }

#include <src/donnees/expressions/expressionappelfonctioninternebinaire.h>
#include <src/donnees/types/type.h>
#include <src/donnees/expressions/optionssurface.h>

// TODO definition des objets fonctions qui mappent le +
// => pour les exceptions, mais aussi pour les fonctions d'encapsulation
// Integer fonction(func Integer (Integer gauche)+(Integer droite))
// pb avec let func ?
namespace Traceur
{
	namespace Donnees
	{
		namespace Expression
		{
			template<typename Gauche, typename OperateurBinaire,typename Droite>
				class EvaluateurOperateurBinaire;
			class Cercle: public AppelFonctionInterneBinaire
			{
				template<typename Gauche, typename OperateurBinaire,typename Droite>
					friend class EvaluateurOperateurBinaire;
				public:
					Cercle(ExpressionSP centre, ExpressionSP rayon, OptionsSurfaceSP options,
						Traceur::Donnees::Source::PositionSP position = Traceur::Donnees::Source::PositionSP());
					virtual ~Cercle() {};
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual Traceur::Donnees::Assembleur::InstructionSP draw(Traceur::Donnees::Assembleur::Assembleur& assembleur);
					virtual void format(std::ostream& os) const;
				private:
					CercleSP _evaluateur;
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Instruction::ValeurSP) const;
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Instruction::ValeurSP, const OptionsSurfaceSP) const;
					Cercle() {};
					Cercle(ExpressionSP centre, ExpressionSP rayon)
						:AppelFonctionInterneBinaire(centre,rayon) {};
				protected:
					OptionsSurfaceSP _options;
			};

		}
	}
}

#endif
