#ifndef _DONNEES_EXPRESSIONS_CONVERSIONCHAINE_H_
#define _DONNEES_EXPRESSIONS_CONVERSIONCHAINE_H_

#include <string>
#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(ConversionChaine); } } }

#include <src/donnees/expressions/expressionappelfonctioninterneunaire.h>
#include <src/donnees/types/type.h>

// TODO definition des objets fonctions qui mappent le et logique
// => pour les exceptions, mais aussi pour les fonctions d'encapsulation
// Integer fonction(func Integer (Integer gauche)+(Integer droite))
// pb avec let func ?
namespace Traceur
{
	namespace Donnees
	{
		namespace Expression
		{
			template<typename OperateurUnaire,typename Valeur>
				class EvaluateurOperateurUnaire;
			class ConversionChaine: public AppelFonctionInterneUnaire
			{
				template<typename OperateurUnaire,typename Valeur>
					friend class EvaluateurOperateurUnaire;
				public:
					ConversionChaine(ExpressionSP valeur, std::string format,Traceur::Donnees::Source::PositionSP position = Traceur::Donnees::Source::PositionSP());
					virtual ~ConversionChaine() {};
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual void format(std::ostream& os) const;
				private:
					ConversionChaineSP _evaluateur;
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP) const;
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP,std::string format) const;
					ConversionChaine(ExpressionSP valeur):AppelFonctionInterneUnaire(valeur) {};
				protected:
					ConversionChaine() {};
					std::string _format;
			};

		}
	}
}

#endif
