#ifndef _DONNEES_EXPRESSIONS_COULEURHSVA_H_
#define _DONNEES_EXPRESSIONS_COULEURHSVA_H_


#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(CouleurHSVA);} } }

#include <src/donnees/expressions/expressionappelfonctioninternequaternaire.h>
#include <src/donnees/types/type.h>

// TODO definition des objets fonctions qui mappent le +
// => pour les exceptions, mais aussi pour les fonctions d'encapsulation
// Integer fonction(func Integer (Integer gauche)+(Integer droite))
// pb avec let func ?
namespace Traceur
{
	namespace Donnees
	{
		namespace Expression
		{
			DECL_SHARED_PTR(Nombre);
			DECL_SHARED_PTR(CouleurRVBA);
			class CouleurHSVA: public AppelFonctionInterneQuaternaire
			{
				friend class CouleurRVBA;
				public:
					CouleurHSVA(ExpressionSP teinte, ExpressionSP saturation, ExpressionSP valeur, ExpressionSP alpha,Traceur::Donnees::Source::PositionSP position = Traceur::Donnees::Source::PositionSP());
					CouleurHSVA(CouleurHSVASP couleur, NombreSP alpha);
					CouleurHSVA(const CouleurRVBA& couleur);
					bool operator==(const CouleurRVBA& couleur);
					bool operator==(const CouleurHSVA& couleur);
					bool operator!=(const CouleurRVBA& couleur);
					bool operator!=(const CouleurHSVA& couleur);
					NombreSP operator-(CouleurHSVA& couleur);
					NombreSP operator-(CouleurRVBA& couleur);
					CouleurHSVASP augmente_teinte(NombreSP valeur);
					CouleurHSVASP augmente_saturation(NombreSP valeur);
					CouleurHSVASP diminue_saturation(NombreSP valeur);
					CouleurHSVASP augmente_valeur(NombreSP valeur);
					CouleurHSVASP diminue_valeur(NombreSP valeur);
					CouleurHSVASP augmente_alpha(NombreSP valeur);
					CouleurRVBASP sur(const CouleurRVBASP couleur);
					CouleurRVBASP sur(const CouleurHSVASP couleur);
					CouleurHSVASP gris_equivalent();
					ExpressionSP rouge();
					ExpressionSP vert();
					ExpressionSP bleu();
					ExpressionSP alpha();
					ExpressionSP teinte();
					ExpressionSP saturation();
					ExpressionSP valeur();
					virtual ~CouleurHSVA() {};
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual void format(std::ostream& os) const;
				private:
					CouleurHSVASP _evaluateur;
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Instruction::ValeurSP) const;
				protected:
					CouleurHSVA() {};
			};

		}
	}
}

#endif
