#ifndef _DONNEES_EXPRESSIONS_COULEURRVBA_H_
#define _DONNEES_EXPRESSIONS_COULEURRVBA_H_


#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(CouleurRVBA);} } }

#include <src/donnees/expressions/expressionappelfonctioninternequaternaire.h>
#include <src/donnees/types/type.h>

// TODO definition des objets fonctions qui mappent le +
// => pour les exceptions, mais aussi pour les fonctions d'encapsulation
// Integer fonction(func Integer (Integer gauche)+(Integer droite))
// pb avec let func ?
namespace Traceur
{
	namespace Donnees
	{
		namespace Assembleur { namespace Couleur { class Couleur; } }
		namespace Expression
		{
			DECL_SHARED_PTR(Nombre);
			DECL_SHARED_PTR(CouleurHSVA);
			class CouleurRVBA: public AppelFonctionInterneQuaternaire
			{
				friend class CouleurHSVA;
				public:
					CouleurRVBA(ExpressionSP rouge, ExpressionSP vert, ExpressionSP bleu, ExpressionSP alpha,Traceur::Donnees::Source::PositionSP position = Traceur::Donnees::Source::PositionSP());
					CouleurRVBA(CouleurRVBASP couleur, NombreSP alpha);
					CouleurRVBA(const CouleurHSVA& couleur);
					CouleurRVBA(const Traceur::Donnees::Assembleur::Couleur::Couleur& couleur);
					bool operator==(const CouleurRVBA& couleur);
					bool operator==(const CouleurHSVA& couleur);
					bool operator!=(const CouleurRVBA& couleur);
					bool operator!=(const CouleurHSVA& couleur);
					NombreSP operator-(CouleurHSVA& couleur);
					NombreSP operator-(CouleurRVBA& couleur);
					CouleurRVBASP augmente_teinte(NombreSP valeur);
					CouleurRVBASP augmente_saturation(NombreSP valeur);
					CouleurRVBASP diminue_saturation(NombreSP valeur);
					CouleurRVBASP augmente_valeur(NombreSP valeur);
					CouleurRVBASP diminue_valeur(NombreSP valeur);
					CouleurRVBASP augmente_alpha(NombreSP valeur);
					CouleurRVBASP sur(const CouleurRVBASP couleur);
					CouleurRVBASP sur(const CouleurHSVASP couleur);
					CouleurRVBASP gris_equivalent();
					ExpressionSP rouge();
					ExpressionSP vert();
					ExpressionSP bleu();
					ExpressionSP alpha();
					ExpressionSP teinte();
					ExpressionSP saturation();
					ExpressionSP valeur();
					virtual ~CouleurRVBA() {};
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual void format(std::ostream& os) const;
				private:
					CouleurRVBASP _evaluateur;
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Instruction::ValeurSP) const;
					void memes_types_que(const CouleurRVBA& couleur);
				protected:
					CouleurRVBA() {};
			};

			namespace Couleur
			{
				class Hexa : public CouleurRVBA
				{
					public:
					Hexa(std::string hexa);
				};
				class Noir : public CouleurRVBA
				{
					public:
					Noir();
				};
				class Gris : public CouleurRVBA
				{
					public:
					Gris();
				};
				class Blanc : public CouleurRVBA
				{
					public:
					Blanc();
				};
				class Rouge : public CouleurRVBA
				{
					public:
					Rouge();
				};
				class Vert : public CouleurRVBA
				{
					public:
					Vert();
				};
				class Bleu : public CouleurRVBA
				{
					public:
					Bleu();
				};
				class Magenta : public CouleurRVBA
				{
					public:
					Magenta();
				};
				class Cyan : public CouleurRVBA
				{
					public:
					Cyan();
				};
				class Jaune : public CouleurRVBA
				{
					public:
					Jaune();
				};
				class Transparent : public CouleurRVBA
				{
					public:
					Transparent();
				};
			}
		}
	}
}

#endif
