#ifndef _DONNEES_EXPRESSIONS_EGALITE_H_
#define _DONNEES_EXPRESSIONS_EGALITE_H_


#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(Egalite);} } }

#include <src/donnees/expressions/expressionappelfonctioninternebinaire.h>
#include <src/donnees/types/type.h>

// TODO definition des objets fonctions qui mappent le +
// => pour les exceptions, mais aussi pour les fonctions d'encapsulation
// Integer fonction(func Integer (Integer gauche)+(Integer droite))
// pb avec let func ?
namespace Traceur
{
	namespace Donnees
	{
		namespace Assembleur { DECL_SHARED_PTR(Assembleur); }
		namespace Expression
		{
			template<typename TypeGauche, typename OperateurBinaire, typename TypeDroite>
				class EvaluateurOperateurBinaire;
			class Egalite: public AppelFonctionInterneBinaire
			{
				template<typename TypeGauche, typename OperateurBinaire, typename TypeDroite>
					friend class EvaluateurOperateurBinaire;
				public:
					Egalite(ExpressionSP gauche, ExpressionSP droite,Traceur::Donnees::Source::PositionSP position = Traceur::Donnees::Source::PositionSP());
					virtual ~Egalite() {};
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual void format(std::ostream& os) const;
				private:
					EgaliteSP _evaluateur;
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Instruction::ValeurSP) const;
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Instruction::ValeurSP,
							Traceur::Donnees::Assembleur::AssembleurSP& assembleur) const;
					Traceur::Donnees::Assembleur::AssembleurSP _assembleur;
				protected:
					Egalite() {};
			};

		}
	}
}

#endif
