#ifndef _DONNEES_EXPRESSIONS_ERREUR_H_
#define _DONNEES_EXPRESSIONS_ERREUR_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(Erreur); } } }

#include <src/donnees/expressions/expressionconstante.h>
#include <src/donnees/fonctions/fonctionidentifiant.h>
#include <src/donnees/types/typeerror.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Expression
		{
			template<typename OperateurCatch, typename TypeGauche, typename TypeDroite>
				class EvaluateurOperateurCatch;
			class Erreur: public Constante
			{
				template<typename OperateurCatch, typename TypeGauche, typename TypeDroite>
					friend class EvaluateurOperateurCatch;
				public:
					typedef Traceur::Donnees::Fonction::Identifiant TypeInterne;
					Erreur(Erreur::TypeInterne erreur)
						:_erreur(erreur) { _type=Traceur::Donnees::Type::Error::SP(); };
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual void format(std::ostream& os) const;
					virtual ~Erreur() {};
				private:
					Erreur::TypeInterne _erreur;
			};
		}
	}
}

#endif
