#include <src/donnees/expressions/expressionfonctionimaginaire.h>
#include <src/donnees/types/type.h>
using namespace Traceur::Donnees::Expression;

FonctionImaginaire::FonctionImaginaire(const Traceur::Donnees::Fonction::FonctionImaginaireSP& fonction)
	:_fonction(fonction)
{
	Traceur::Donnees::Type::TypeSP type(new Traceur::Donnees::Type::Fonction(fonction->prototype()));
	_type = type;
}

void FonctionImaginaire::edition_liens(Traceur::Donnees::Instruction::InstructionSP instruction)
{
	_fonction->edition_liens(instruction->parent());
}

void FonctionImaginaire::definition_fonction()
{
	_fonction->definition_fonction();
}

ExpressionSP FonctionImaginaire::clone(Traceur::Donnees::Global::ClonesInstances& clones_instances)
{
	Traceur::Donnees::Fonction::FonctionSP fonction = _fonction->clone(clones_instances);
	Traceur::Donnees::Fonction::FonctionImaginaireSP fonction_imaginaire = std::dynamic_pointer_cast<Traceur::Donnees::Fonction::FonctionImaginaire>(fonction);
	TRACEUR_TEST(fonction_imaginaire);
	FonctionImaginaireSP clone(new FonctionImaginaire());
	Traceur::Donnees::Type::TypeSP type = _type->clone(clones_instances);
	clone->_type=type;
	clone->_fonction=fonction_imaginaire;
	return clone;
}
