#ifndef _DONNEES_EXPRESSIONS_FONCTIONIMAGINAIRE_H_
#define _DONNEES_EXPRESSIONS_FONCTIONIMAGINAIRE_H_


#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(FonctionImaginaire); } } }

#include <src/donnees/expressions/expression.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Instruction { class LetFunc; }
		namespace Expression
		{
#ifdef TRACEUR_DEBUG
			class AppelFonctionUtilisateur;
#endif
			class FonctionImaginaire: public Expression
			{
#ifdef TRACEUR_DEBUG
				friend class AppelFonctionUtilisateur;
#endif
				friend class Traceur::Donnees::Instruction::LetFunc;
				friend class Traceur::Donnees::Fonction::FonctionImaginaire;
				public:
					FonctionImaginaire(const Traceur::Donnees::Fonction::FonctionImaginaireSP& fonction);
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur) // faut definir les fonctions virtuelles ici, sinon, ca ne linke plus
					{
						_fonction->evaluation(assembleur);
						Traceur::Donnees::Instruction::ValeurSP valeur(new Traceur::Donnees::Instruction::Valeur(this->shared_from_this()));
						return valeur;
					};
					virtual void format(std::ostream& os) const
					{
						_fonction->format(os);
					};
					virtual void edition_liens(Traceur::Donnees::Instruction::InstructionSP instruction);
					virtual void definition_fonction();
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual ~FonctionImaginaire() {};
				private:
					FonctionImaginaire() {};
					Traceur::Donnees::Fonction::FonctionImaginaireSP _fonction;
			};
		}
	}
}

#endif
