#ifndef _DONNEES_EXPRESSIONS_IMAGE_H_
#define _DONNEES_EXPRESSIONS_IMAGE_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(Image); } } }

#include <src/donnees/instructions/valeur.h>
#include <src/donnees/expressions/expression.h>
#include <src/donnees/instructions/bloc.h>
#include <src/donnees/types/type.h>
#include <src/donnees/expressions/systemecoordonnees.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Expression
		{
			class Image: public Expression
			{
				public:
					Image(ExpressionSP taille_x, ExpressionSP taille_y, SystemeCoordonneesSP coordonnees, ExpressionSP couleur_fond,
						Traceur::Donnees::Instruction::BlocSP contenu,
						Traceur::Donnees::Source::PositionSP position = Traceur::Donnees::Source::PositionSP());
					virtual ~Image() {};
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual void edition_liens(Traceur::Donnees::Instruction::InstructionSP instruction);
					virtual void definition_fonction();
					virtual ExpressionSP simplification();
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual void format(std::ostream& os) const;
				private:
					ExpressionSP _taille_x;
					ExpressionSP _taille_y;
					SystemeCoordonneesSP _coordonnees;
					ExpressionSP _couleur_fond;
					Traceur::Donnees::Instruction::BlocSP _contenu;
			};

		}
	}
}

namespace Traceur
{
	namespace Exception
	{
		class TypeIncorrectImage : public Compilation
		{
			public:
				TypeIncorrectImage(Traceur::Donnees::Source::PositionSP position, const Traceur::Donnees::Expression::ExpressionSP& taille_x,
					const Traceur::Donnees::Expression::ExpressionSP& taille_y,
					const Traceur::Donnees::Expression::SystemeCoordonneesSP coords,
					const Traceur::Donnees::Expression::ExpressionSP couleur_fond)
					:Compilation(position,std::string("Function call IMAGE[")+std::string(*(taille_x->type()))+std::string(";")+
						std::string(*(taille_y->type()))+std::string("] ")+std::string(*(coords))+std::string(" ")+
						std::string(*(couleur_fond->type()))+std::string(" {...} does not match any function."))
					{};
		};
	}
}
#endif
