#include <src/donnees/expressions/expressionimageevaluee.h>

#include <src/donnees/types/types.h>
#include <src/donnees/assembleur/assembleur.h>
#include <src/donnees/expressions/expressionpoint.h>
#include <src/donnees/expressions/expressionvecteur.h>
#include <src/donnees/expressions/expressioncouleurrvba.h>

using namespace Traceur::Donnees::Expression;

ImageEvaluee::ImageEvaluee(const Traceur::Donnees::Assembleur::Image::ImageSP image)
:_image(image)
{
	_type = Traceur::Donnees::Type::Image::SP();
}

Traceur::Donnees::Instruction::ValeurSP ImageEvaluee::evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur)
{
	Traceur::Donnees::Instruction::ValeurSP valeur(new Traceur::Donnees::Instruction::Valeur(this->shared_from_this()));
	return valeur;
}

void ImageEvaluee::format(std::ostream& os) const
{
	_image->format(os);
}

void ImageEvaluee::edition_liens(Traceur::Donnees::Instruction::InstructionSP instruction)
{
}

void ImageEvaluee::definition_fonction()
{
}

ExpressionSP ImageEvaluee::clone(Traceur::Donnees::Global::ClonesInstances& clones_instances)
{
	ImageEvalueeSP clone(new ImageEvaluee(_image));
	return clone;
}
