#ifndef _DONNEES_EXPRESSIONS_IMAGEEVALUEE_H_
#define _DONNEES_EXPRESSIONS_IMAGEEVALUEE_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(ImageEvaluee); } } }

#include <src/donnees/instructions/valeur.h>
#include <src/donnees/expressions/expression.h>
#include <src/donnees/types/type.h>
#include <src/donnees/assembleur/image.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Assembleur { class Assembleur; }
		namespace Expression
		{
			class ImageEvaluee: public Expression
			{
				friend class Traceur::Donnees::Assembleur::Assembleur;
				public:
					ImageEvaluee(const Traceur::Donnees::Assembleur::Image::ImageSP _image);
					virtual ~ImageEvaluee() {};
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual void edition_liens(Traceur::Donnees::Instruction::InstructionSP instruction);
					virtual void definition_fonction();
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual void format(std::ostream& os) const;
				private:
					Traceur::Donnees::Assembleur::Image::ImageSP _image;
			};

		}
	}
}
#endif
