#ifndef _DONNEES_EXPRESSIONS_LIGNE_H_
#define _DONNEES_EXPRESSIONS_LIGNE_H_


#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(Ligne);} } }

#include <src/donnees/expressions/expressionappelfonctioninternebinaire.h>
#include <src/donnees/types/type.h>
#include <src/donnees/expressions/optionsligne.h>

// TODO definition des objets fonctions qui mappent le +
// => pour les exceptions, mais aussi pour les fonctions d'encapsulation
// Integer fonction(func Integer (Integer gauche)+(Integer droite))
// pb avec let func ?
namespace Traceur
{
	namespace Donnees
	{
		namespace Expression
		{
			template<typename Gauche, typename OperateurBinaire,typename Droite>
				class EvaluateurOperateurBinaire;
			class Ligne: public AppelFonctionInterneBinaire
			{
				template<typename Gauche, typename OperateurBinaire,typename Droite>
					friend class EvaluateurOperateurBinaire;
				public:
					Ligne(ExpressionSP gauche, ExpressionSP droite, OptionsLigneSP options,
						Traceur::Donnees::Source::PositionSP position = Traceur::Donnees::Source::PositionSP());
					virtual ~Ligne() {};
					virtual ExpressionSP simplification()
					{
#ifdef TRACEUR_DEBUG
						std::cerr << __FILE__ << " "; format(std::cerr); std::cerr << std::endl;
#endif
						_gauche = _gauche->simplification();
						_droite = _droite->simplification();
						_options = _options->simplification();
						if(est_constante())
						{
							Traceur::Donnees::Assembleur::AssembleurSP assembleur;
							ExpressionSP resultat = *(evaluation(assembleur));
							if(resultat->est_de_nature<Erreur>())
								return this->shared_from_this();
							return resultat;
						}
						return this->shared_from_this();
					};
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual Traceur::Donnees::Assembleur::InstructionSP draw(Traceur::Donnees::Assembleur::Assembleur& assembleur);
					virtual void format(std::ostream& os) const;
				private:
					LigneSP _evaluateur;
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Instruction::ValeurSP) const;
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Instruction::ValeurSP, const OptionsLigneSP) const;
					Ligne() {};
					Ligne(ExpressionSP gauche, ExpressionSP droite)
						:AppelFonctionInterneBinaire(gauche,droite) {};
				protected:
					OptionsLigneSP _options;
			};

		}
	}
}

#endif
