#ifndef _DONNEES_EXPRESSIONS_NOMBRE_H_
#define _DONNEES_EXPRESSIONS_NOMBRE_H_


#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(Nombre); } } }

#include <src/donnees/expressions/expressionconstante.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Expression
		{
			class Entier;
			class Reel;
			class Nombre: public Constante
			{
				public:
					virtual ~Nombre() {};
					static NombreSP zero();
					static NombreSP un();
					static NombreSP deux();
					static NombreSP med_canal_couleur();
					static NombreSP max_canal_couleur();
					static NombreSP pi_sur_deux();
					Reel reel();
					Entier entier();
					Reel reel_borne(const Reel& inf, const Reel& sup);
					Entier entier_borne(const Entier& inf, const Entier& sup);
			};
			/* Fonctions pour simplifier les calculs internes sur les nombres.
			 * Elles sont la surtout pour Point et Vecteur.
			 * En l'etat, elles dupliquent la logique des operateurs,
			 * mais elles permettent d'avoir des operateurs non virtuels.
			 */
			NombreSP operator+(NombreSP gauche, NombreSP droite);
			NombreSP operator-(NombreSP valeur);
			NombreSP operator-(NombreSP gauche, NombreSP droite);
			NombreSP operator*(NombreSP gauche, NombreSP droite);
			NombreSP operator/(NombreSP gauche, NombreSP droite);
			NombreSP operator%(NombreSP gauche, NombreSP droite);
			bool operator==(NombreSP gauche, NombreSP droite);
			bool operator!=(NombreSP gauche, NombreSP droite);
			bool operator<(NombreSP gauche, NombreSP droite);
			bool operator>(NombreSP gauche, NombreSP droite);
			bool operator<=(NombreSP gauche, NombreSP droite);
			bool operator>=(NombreSP gauche, NombreSP droite);
			bool est_nul(NombreSP valeur);
			NombreSP cosinus(NombreSP valeur);
			NombreSP sinus(NombreSP valeur);
			NombreSP racine_carree(NombreSP valeur);
			NombreSP argument(NombreSP gauche, NombreSP droite);
			NombreSP partie_entiere(NombreSP valeur);
			NombreSP valeur_absolue(NombreSP valeur);
		}
	}
}

#endif
