#ifndef _DONNEES_EXPRESSIONS_NOYAU_H_
#define _DONNEES_EXPRESSIONS_NOYAU_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(Noyau); } } }

#include <src/donnees/instructions/valeur.h>
#include <src/donnees/expressions/expression.h>
#include <src/donnees/instructions/bloc.h>
#include <src/donnees/types/type.h>
#include <src/donnees/expressions/systemecoordonnees.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Expression
		{
			class Noyau: public Expression
			{
				public:
					Noyau(ExpressionSP taille_x, ExpressionSP taille_y, SystemeCoordonneesSP coordonnees,
						Traceur::Donnees::Instruction::BlocSP contenu,
						Traceur::Donnees::Source::PositionSP position = Traceur::Donnees::Source::PositionSP());
					virtual ~Noyau() {};
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual void edition_liens(Traceur::Donnees::Instruction::InstructionSP instruction);
					virtual void definition_fonction();
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual ExpressionSP simplification();
					virtual void format(std::ostream& os) const;
				private:
					ExpressionSP _taille_x;
					ExpressionSP _taille_y;
					SystemeCoordonneesSP _coordonnees;
					Traceur::Donnees::Instruction::BlocSP _contenu;
			};

		}
	}
}

namespace Traceur
{
	namespace Exception
	{
		class TypeIncorrectNoyau : public Compilation
		{
			public:
				TypeIncorrectNoyau(Traceur::Donnees::Source::PositionSP position, const Traceur::Donnees::Expression::ExpressionSP& taille_x,
					const Traceur::Donnees::Expression::ExpressionSP& taille_y)
					:Compilation(position,std::string("Function call KERNEL[")+std::string(*(taille_x->type()))+std::string(";")+
						std::string(*(taille_y->type()))+std::string("] {...} does not match any function."))
					{};
		};
	}
}
#endif
