#include <src/donnees/expressions/expressionpi.h>

#include <src/donnees/types/types.h>
#include <src/donnees/expressions/expressionreel.h>

using namespace Traceur::Donnees::Expression;
Pi::Pi()
{
	_type = Traceur::Donnees::Type::Real::SP();
}

Traceur::Donnees::Instruction::ValeurSP Pi::evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur)
{
	Traceur::Donnees::Instruction::ValeurSP valeur(new Traceur::Donnees::Instruction::Valeur(Reel::pi()));
	return valeur;
}

void Pi::format(std::ostream& os) const
{
	os << "pi";
}

ExpressionSP Pi::clone(Traceur::Donnees::Global::ClonesInstances& clones_instances)
{
	PiSP clone(new Pi());
	return clone;
}
