#ifndef _DONNEES_EXPRESSIONS_POINT_H_
#define _DONNEES_EXPRESSIONS_POINT_H_


#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(Point);} } }

#include <src/donnees/expressions/expressionappelfonctioninternebinaire.h>
#include <src/donnees/types/type.h>

// TODO definition des objets fonctions qui mappent le +
// => pour les exceptions, mais aussi pour les fonctions d'encapsulation
// Integer fonction(func Integer (Integer gauche)+(Integer droite))
// pb avec let func ?
namespace Traceur
{
	namespace Donnees
	{
		namespace Assembleur { class SystemeCoordonnees; }
		namespace Instruction { class For; }
		namespace Expression
		{
			DECL_SHARED_PTR(Nombre);
			DECL_SHARED_PTR(CouleurRVBA);
			class Vecteur;
			class SystemeMathematique;
			class Point: public AppelFonctionInterneBinaire
			{
				friend class Traceur::Donnees::Assembleur::SystemeCoordonnees;
				friend class Traceur::Donnees::Instruction::For;
				friend class Vecteur;
				friend class SystemeMathematique;
				public:
					Point(ExpressionSP gauche, ExpressionSP droite,Traceur::Donnees::Source::PositionSP position = Traceur::Donnees::Source::PositionSP());
					Point(const Vecteur& vecteur);
					virtual ~Point() {};
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual Traceur::Donnees::Assembleur::InstructionSP draw(Traceur::Donnees::Assembleur::Assembleur& assembleur);
					virtual void format(std::ostream& os) const;
					NombreSP abscisse() const;
					NombreSP ordonnee() const;
					NombreSP module() const;
					NombreSP argument() const;
					CouleurRVBASP couleur(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					Point translation(Vecteur& vecteur) const;
					Point translation_opposee(Vecteur& vecteur) const;
					Vecteur decalage(Point& point) const;
				private:
					PointSP _evaluateur;
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Instruction::ValeurSP) const;
					ExpressionSP gauche() { return _gauche; };
					ExpressionSP droite() { return _droite; };
				protected:
					Point() {};
					void en_cartesien(NombreSP& abscisse, NombreSP& ordonnee) const;
					void en_polaire(NombreSP& module, NombreSP& argument) const;
			};

		}
	}
}

#endif
