#ifndef _DONNEES_EXPRESSIONS_RECTANGLE_H_
#define _DONNEES_EXPRESSIONS_RECTANGLE_H_


#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(Rectangle);} } }

#include <src/donnees/expressions/expressionappelfonctioninterneternaire.h>
#include <src/donnees/types/type.h>
#include <src/donnees/expressions/optionssurface.h>

// TODO definition des objets fonctions qui mappent le +
// => pour les exceptions, mais aussi pour les fonctions d'encapsulation
// Integer fonction(func Integer (Integer gauche)+(Integer droite))
// pb avec let func ?
namespace Traceur
{
	namespace Donnees
	{
		namespace Expression
		{
			template<typename OperateurTernaire, typename Valeur1, typename Valeur2, typename Valeur3>
				class EvaluateurOperateurTernaire;
			class Rectangle: public AppelFonctionInterneTernaire
			{
				template<typename OperateurTernaire, typename Valeur1, typename Valeur2, typename Valeur3>
					friend class EvaluateurOperateurTernaire;
				public:
					Rectangle(ExpressionSP sommet1, ExpressionSP sommet2, OptionsSurfaceSP options,
						Traceur::Donnees::Source::PositionSP position = Traceur::Donnees::Source::PositionSP());
					Rectangle(ExpressionSP sommet1, ExpressionSP sommet2, ExpressionSP sommet3, OptionsSurfaceSP options,
						Traceur::Donnees::Source::PositionSP position = Traceur::Donnees::Source::PositionSP());
					virtual ~Rectangle() {};
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual Traceur::Donnees::Assembleur::InstructionSP draw(Traceur::Donnees::Assembleur::Assembleur& assembleur);
					virtual void format(std::ostream& os) const;
				private:
					RectangleSP _evaluateur;
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Instruction::ValeurSP, const Traceur::Donnees::Instruction::ValeurSP) const;
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Instruction::ValeurSP, const Traceur::Donnees::Instruction::ValeurSP, const OptionsSurfaceSP) const;
					Rectangle() {};
					Rectangle(ExpressionSP sommet1, ExpressionSP sommet2, ExpressionSP sommet3)
						:AppelFonctionInterneTernaire(sommet1,sommet2,sommet3) {};
				protected:
					OptionsSurfaceSP _options;
			};

		}
	}
}

#endif
