#ifndef _DONNEES_EXPRESSIONS_REMPLISSAGE_H_
#define _DONNEES_EXPRESSIONS_REMPLISSAGE_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(Remplissage); } } }

#include <src/donnees/expressions/expressionappelfonctioninterneunaire.h>
#include <src/donnees/types/type.h>
#include <src/donnees/types/typepoint.h>
#include <src/donnees/expressions/optionssurface.h>

// TODO definition des objets fonctions qui mappent le et logique
// => pour les exceptions, mais aussi pour les fonctions d'encapsulation
// Integer fonction(func Integer (Integer gauche)+(Integer droite))
// pb avec let func ?
namespace Traceur
{
	namespace Donnees
	{
		namespace Expression
		{
			template<typename OperateurBinaire,typename Valeur>
				class EvaluateurOperateurUnaire;
			class Remplissage: public AppelFonctionInterneUnaire
			{
				template<typename OperateurBinaire,typename Valeur>
					friend class EvaluateurOperateurUnaire;
				public:
					Remplissage(ExpressionSP valeur, OptionsSurfaceSP options, Traceur::Donnees::Source::PositionSP position = Traceur::Donnees::Source::PositionSP());
					virtual ~Remplissage() {};
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual bool est_constante() { return (not _valeur->est_de_type<Traceur::Donnees::Type::Point>()) and AppelFonctionInterneUnaire::est_constante(); };
					virtual Traceur::Donnees::Assembleur::InstructionSP draw(Traceur::Donnees::Assembleur::Assembleur& assembleur);
					virtual void format(std::ostream& os) const;
				private:
					RemplissageSP _evaluateur;
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP);
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP, const OptionsSurfaceSP);
					Remplissage(ExpressionSP valeur) :AppelFonctionInterneUnaire(valeur) {};
				protected:
					Remplissage() {};
					Traceur::Donnees::Assembleur::AssembleurSP _assembleur;
					OptionsSurfaceSP _options;
			};

		}
	}
}

#endif
