#ifndef _DONNEES_EXPRESSIONS_SOLIDE_H_
#define _DONNEES_EXPRESSIONS_SOLIDE_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(Solide); } } }

#include <src/donnees/expressions/expressionappelfonctioninterneunaire.h>
#include <src/donnees/types/type.h>
#include <src/donnees/types/typepoint.h>

// TODO definition des objets fonctions qui mappent le et logique
// => pour les exceptions, mais aussi pour les fonctions d'encapsulation
// Integer fonction(func Integer (Integer gauche)+(Integer droite))
// pb avec let func ?
namespace Traceur
{
	namespace Donnees
	{
		namespace Expression
		{
			class Solide: public AppelFonctionInterneUnaire
			{
				public:
					Solide(ExpressionSP valeur,Traceur::Donnees::Source::PositionSP position = Traceur::Donnees::Source::PositionSP());
					virtual ~Solide() {};
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual bool est_constante() { return (not _valeur->est_de_type<Traceur::Donnees::Type::Point>()) and AppelFonctionInterneUnaire::est_constante(); };
					virtual Traceur::Donnees::Assembleur::InstructionSP draw(Traceur::Donnees::Assembleur::Assembleur& assembleur);
					virtual void format(std::ostream& os) const;
				private:
					SolideSP _evaluateur;
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP);
				protected:
					Solide() {};
					Traceur::Donnees::Assembleur::AssembleurSP _assembleur;
			};

		}
	}
}

#endif
