#ifndef _DONNEES_EXPRESSIONS_VECTEUR_H_
#define _DONNEES_EXPRESSIONS_VECTEUR_H_


#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(Vecteur);} } }

#include <src/donnees/expressions/expressionappelfonctioninternebinaire.h>
#include <src/donnees/types/type.h>

// TODO definition des objets fonctions qui mappent le +
// => pour les exceptions, mais aussi pour les fonctions d'encapsulation
// Integer fonction(func Integer (Integer gauche)+(Integer droite))
// pb avec let func ?
namespace Traceur
{
	namespace Donnees
	{
		namespace Instruction { class For; }
		namespace Expression
		{
			DECL_SHARED_PTR(Nombre);
			class Point;
			class VecteurPolaire;
			class Vecteur: public AppelFonctionInterneBinaire
			{
				friend class Traceur::Donnees::Instruction::For;
				friend class Point;
				friend class VecteurPolaire;
				public:
					Vecteur(ExpressionSP gauche, ExpressionSP droite,Traceur::Donnees::Source::PositionSP position = Traceur::Donnees::Source::PositionSP());
					Vecteur(const Point& point);
					Vecteur(const VecteurPolaire& vecteur_polaire);
					virtual ~Vecteur() {};
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual void format(std::ostream& os) const;
					virtual Vecteur en_cartesien() const { return *this; };
					virtual VecteurPolaire en_polaire() const;
					virtual bool est_le_vecteur_nul() const;
					Vecteur operator+() const { return *this; };
					Vecteur operator-() const;
					Vecteur operator+(Vecteur& vecteur) const;
					Vecteur operator-(Vecteur& vecteur) const;
					NombreSP operator*(Vecteur& vecteur) const;
					NombreSP operator^(Vecteur& vecteur) const;
					Vecteur operator*(NombreSP nombre) const;
					Vecteur operator/(NombreSP nombre) const;
					bool operator==(Vecteur& vecteur) const;
					bool operator!=(Vecteur& vecteur) const;
					Vecteur projection(Vecteur& vecteur) const;
					Vecteur symetrie(Vecteur& vecteur) const;
					Vecteur rotation(NombreSP angle) const;
					NombreSP abscisse() const;
					NombreSP ordonnee() const;
					NombreSP module() const;
					NombreSP argument() const;
				private:
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Instruction::ValeurSP) const;
				protected:
					void en_cartesien(NombreSP& abscisse, NombreSP& ordonnee) const;
					void en_polaire(NombreSP& module, NombreSP& argument) const;
					VecteurSP _evaluateur;
					Vecteur() {};
					Vecteur(ExpressionSP gauche, ExpressionSP droite, VecteurSP evaluateur)
						:AppelFonctionInterneBinaire(gauche,droite), _evaluateur(evaluateur) {};
			};

		}
	}
}

#endif
