#ifndef _DONNEES_EXPRESSIONS_VECTEURPOLAIRE_H_
#define _DONNEES_EXPRESSIONS_VECTEURPOLAIRE_H_


#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Expression { DECL_SHARED_PTR(VecteurPolaire);} } }

#include <src/donnees/expressions/expressionvecteur.h>
#include <src/donnees/types/type.h>

// TODO definition des objets fonctions qui mappent le +
// => pour les exceptions, mais aussi pour les fonctions d'encapsulation
// Integer fonction(func Integer (Integer gauche)+(Integer droite))
// pb avec let func ?
namespace Traceur
{
	namespace Donnees
	{
		namespace Expression
		{
			class VecteurPolaire: public Vecteur
			{
				public:
					VecteurPolaire(ExpressionSP gauche, ExpressionSP droite,Traceur::Donnees::Source::PositionSP position = Traceur::Donnees::Source::PositionSP());
					VecteurPolaire(const Vecteur& vecteur);
					virtual ~VecteurPolaire() {};
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual ExpressionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual void format(std::ostream& os) const;
					virtual Vecteur en_cartesien() const { return Vecteur(*this); };
					virtual VecteurPolaire en_polaire() const { return *this; };
					virtual bool est_le_vecteur_nul() const;
					VecteurPolaire operator+() const { return *this; };
					VecteurPolaire operator-() const;
					VecteurPolaire operator*(NombreSP nombre) const;
					VecteurPolaire operator/(NombreSP nombre) const;
					VecteurPolaire rotation(NombreSP& angle) const;
				private:
					virtual Traceur::Donnees::Instruction::ValeurSP evaluation(const Traceur::Donnees::Instruction::ValeurSP,
							const Traceur::Donnees::Instruction::ValeurSP) const;
				protected:
					VecteurPolaire() {};
			};

		}
	}
}

#endif
