#include <src/donnees/expressions/expressionxmax.h>

#include <src/donnees/types/types.h>
#include <src/donnees/expressions/expressionentier.h>

#include <src/donnees/assembleur/assembleur.h>
#include <src/donnees/assembleur/systemecoordonnees.h>

using namespace Traceur::Donnees::Expression;
Xmax::Xmax()
{
	_type = Traceur::Donnees::Type::Number::SP();
}

Traceur::Donnees::Instruction::ValeurSP Xmax::evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur)
{
	try
	{
		Traceur::Donnees::Assembleur::SystemeCoordonnees coords = assembleur->coordonnees(Traceur::Donnees::Instruction::Valeur::coordonnee_hors_image());
		Traceur::Donnees::Instruction::ValeurSP valeur(new Traceur::Donnees::Instruction::Valeur(coords._xmax));
		return valeur;
	}
	catch(Traceur::Donnees::Instruction::ValeurSP valeur)
	{
		return valeur;
	}
}

void Xmax::format(std::ostream& os) const
{
	os << "xmax";
}

ExpressionSP Xmax::clone(Traceur::Donnees::Global::ClonesInstances& clones_instances)
{
	XmaxSP clone(new Xmax());
	return clone;
}
