#include <src/donnees/expressions/expressionxmin.h>

#include <src/donnees/types/types.h>
#include <src/donnees/expressions/expressionentier.h>

#include <src/donnees/assembleur/assembleur.h>
#include <src/donnees/assembleur/systemecoordonnees.h>

using namespace Traceur::Donnees::Expression;
Xmin::Xmin()
{
	_type = Traceur::Donnees::Type::Number::SP();
}

Traceur::Donnees::Instruction::ValeurSP Xmin::evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur)
{
	try
	{
		Traceur::Donnees::Assembleur::SystemeCoordonnees coords = assembleur->coordonnees(Traceur::Donnees::Instruction::Valeur::coordonnee_hors_image());
		Traceur::Donnees::Instruction::ValeurSP valeur(new Traceur::Donnees::Instruction::Valeur(coords._xmin));
		return valeur;
	}
	catch(Traceur::Donnees::Instruction::ValeurSP valeur)
	{
		return valeur;
	}
}

void Xmin::format(std::ostream& os) const
{
	os << "xmin";
}

ExpressionSP Xmin::clone(Traceur::Donnees::Global::ClonesInstances& clones_instances)
{
	XminSP clone(new Xmin());
	return clone;
}
