#include <src/donnees/expressions/expressionxsiz.h>

#include <src/donnees/types/types.h>
#include <src/donnees/expressions/expressionentier.h>

#include <src/donnees/assembleur/assembleur.h>
#include <src/donnees/assembleur/systemecoordonnees.h>

using namespace Traceur::Donnees::Expression;
Xsiz::Xsiz()
{
	_type = Traceur::Donnees::Type::Integer::SP();
}

Traceur::Donnees::Instruction::ValeurSP Xsiz::evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur)
{
	try
	{
		Traceur::Donnees::Assembleur::SystemeCoordonnees coords = assembleur->coordonnees(Traceur::Donnees::Instruction::Valeur::coordonnee_hors_image());
		Traceur::Donnees::Instruction::ValeurSP valeur(new Traceur::Donnees::Instruction::Valeur(coords._xsiz));
		return valeur;
	}
	catch(Traceur::Donnees::Instruction::ValeurSP valeur)
	{
		return valeur;
	}
}

void Xsiz::format(std::ostream& os) const
{
	os << "xsiz";
}

ExpressionSP Xsiz::clone(Traceur::Donnees::Global::ClonesInstances& clones_instances)
{
	XsizSP clone(new Xsiz());
	return clone;
}
