#include <src/donnees/expressions/expressionymax.h>

#include <src/donnees/types/types.h>
#include <src/donnees/expressions/expressionentier.h>

#include <src/donnees/assembleur/assembleur.h>
#include <src/donnees/assembleur/systemecoordonnees.h>

using namespace Traceur::Donnees::Expression;
Ymax::Ymax()
{
	_type = Traceur::Donnees::Type::Number::SP();
}

Traceur::Donnees::Instruction::ValeurSP Ymax::evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur)
{
	try
	{
		Traceur::Donnees::Assembleur::SystemeCoordonnees coords = assembleur->coordonnees(Traceur::Donnees::Instruction::Valeur::coordonnee_hors_image());
		Traceur::Donnees::Instruction::ValeurSP valeur(new Traceur::Donnees::Instruction::Valeur(coords._ymax));
		return valeur;
	}
	catch(Traceur::Donnees::Instruction::ValeurSP valeur)
	{
		return valeur;
	}
}

void Ymax::format(std::ostream& os) const
{
	os << "ymax";
}

ExpressionSP Ymax::clone(Traceur::Donnees::Global::ClonesInstances& clones_instances)
{
	YmaxSP clone(new Ymax());
	return clone;
}
