#include <src/donnees/expressions/expressionymin.h>

#include <src/donnees/types/types.h>
#include <src/donnees/expressions/expressionentier.h>

#include <src/donnees/assembleur/assembleur.h>
#include <src/donnees/assembleur/systemecoordonnees.h>

using namespace Traceur::Donnees::Expression;
Ymin::Ymin()
{
	_type = Traceur::Donnees::Type::Number::SP();
}

Traceur::Donnees::Instruction::ValeurSP Ymin::evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur)
{
	try
	{
		Traceur::Donnees::Assembleur::SystemeCoordonnees coords = assembleur->coordonnees(Traceur::Donnees::Instruction::Valeur::coordonnee_hors_image());
		Traceur::Donnees::Instruction::ValeurSP valeur(new Traceur::Donnees::Instruction::Valeur(coords._ymin));
		return valeur;
	}
	catch(Traceur::Donnees::Instruction::ValeurSP valeur)
	{
		return valeur;
	}
}

void Ymin::format(std::ostream& os) const
{
	os << "ymin";
}

ExpressionSP Ymin::clone(Traceur::Donnees::Global::ClonesInstances& clones_instances)
{
	YminSP clone(new Ymin());
	return clone;
}
