#include <src/donnees/expressions/expressionyscl.h>

#include <src/donnees/types/types.h>
#include <src/donnees/expressions/expressionentier.h>

#include <src/donnees/assembleur/assembleur.h>
#include <src/donnees/assembleur/systemecoordonnees.h>

using namespace Traceur::Donnees::Expression;
Yscl::Yscl()
{
	_type = Traceur::Donnees::Type::Number::SP();
}

Traceur::Donnees::Instruction::ValeurSP Yscl::evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur)
{
	try
	{
		Traceur::Donnees::Assembleur::SystemeCoordonnees coords = assembleur->coordonnees(Traceur::Donnees::Instruction::Valeur::coordonnee_hors_image());
		Traceur::Donnees::Instruction::ValeurSP valeur(new Traceur::Donnees::Instruction::Valeur(coords._yscl));
		return valeur;
	}
	catch(Traceur::Donnees::Instruction::ValeurSP valeur)
	{
		return valeur;
	}
}

void Yscl::format(std::ostream& os) const
{
	os << "yscl";
}

ExpressionSP Yscl::clone(Traceur::Donnees::Global::ClonesInstances& clones_instances)
{
	YsclSP clone(new Yscl());
	return clone;
}
