#include <src/donnees/expressions/expressionysiz.h>

#include <src/donnees/types/types.h>
#include <src/donnees/expressions/expressionentier.h>

#include <src/donnees/assembleur/assembleur.h>
#include <src/donnees/assembleur/systemecoordonnees.h>

using namespace Traceur::Donnees::Expression;
Ysiz::Ysiz()
{
	_type = Traceur::Donnees::Type::Integer::SP();
}

Traceur::Donnees::Instruction::ValeurSP Ysiz::evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur)
{
	try
	{
		Traceur::Donnees::Assembleur::SystemeCoordonnees coords = assembleur->coordonnees(Traceur::Donnees::Instruction::Valeur::coordonnee_hors_image());
		Traceur::Donnees::Instruction::ValeurSP valeur(new Traceur::Donnees::Instruction::Valeur(coords._ysiz));
		return valeur;
	}
	catch(Traceur::Donnees::Instruction::ValeurSP valeur)
	{
		return valeur;
	}
}

void Ysiz::format(std::ostream& os) const
{
	os << "ysiz";
}

ExpressionSP Ysiz::clone(Traceur::Donnees::Global::ClonesInstances& clones_instances)
{
	YsizSP clone(new Ysiz());
	return clone;
}
