#ifndef _DONNEES_FONCTIONS_FONCTION_H_
#define _DONNEES_FONCTIONS_FONCTION_H_
#include <iostream>

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Fonction { DECL_SHARED_PTR(Fonction); DECL_WEAK_PTR(Fonction); } } }

#include <src/donnees/sources/position.h>
#include <src/donnees/fonctions/fonctionprototype.h>
#include <src/donnees/global/clonesinstances.h>
#include <src/donnees/instructions/bloc.h>
namespace Traceur
{
	namespace Donnees
	{
		namespace Expression { DECL_SHARED_PTR(Expression); DECL_SHARED_PTR(AppelFonctionUtilisateur); }
		namespace Assembleur { DECL_SHARED_PTR(Assembleur); }
		namespace Instruction { class Let; DECL_SHARED_PTR(InstructionInterruption); }
		namespace Fonction
		{
			DECL_SHARED_PTR(FonctionImaginaire);
			class Fonction
			{
				friend class Traceur::Donnees::Instruction::Let;
				friend class FonctionImaginaire;
				friend class Traceur::Donnees::Expression::AppelFonctionUtilisateur;
				public:
					typedef std::vector<FonctionImaginaireSP> ListeParametres;
					Fonction(const PrototypeSP& prototype, const Traceur::Donnees::Source::PositionSP& position)
						:_prototype(prototype),_position(position) {};
					virtual void edition_liens(Traceur::Donnees::Instruction::BlocSP bloc) =0;
					virtual void definition_fonction() = 0;
					virtual FonctionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances) = 0;
					virtual Traceur::Donnees::Instruction::InstructionInterruptionSP appel(
						ListeParametres gauche, ListeParametres droite, Traceur::Donnees::Assembleur::AssembleurSP& assembleur,
						Traceur::Donnees::Expression::AppelFonctionUtilisateurSP appel) = 0;
					virtual Traceur::Donnees::Expression::ExpressionSP substitution(ListeParametres gauche, ListeParametres droite) = 0;
					virtual void format_disp(std::ostream& os) const = 0;
					virtual void disp(std::ostream& os) const = 0;
					virtual void format(std::ostream& os) const = 0;
					virtual ~Fonction() {};
				protected:
					Fonction() {};
					PrototypeSP _prototype;
					Traceur::Donnees::Source::PositionSP _position;
				private:
					virtual bool recursive() const { return false; };
					virtual PrototypeSP& prototype() { return _prototype; };
			};
		}
	}
}
#ifdef TRACEUR_DEBUG
void debug_fonction(Traceur::Donnees::Fonction::FonctionSP f);
#endif
#endif
