#ifndef _DONNEES_FONCTIONS_FONCTIONIMAGINAIRE_H_
#define _DONNEES_FONCTIONS_FONCTIONIMAGINAIRE_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Fonction { DECL_SHARED_PTR(FonctionImaginaire); DECL_WEAK_PTR(FonctionImaginaire); } } }

#include <src/donnees/expressions/expression.h>
#include <src/donnees/fonctions/fonction.h>
#include <src/donnees/fonctions/instance.h>
namespace Traceur
{
	namespace Donnees
	{
		namespace Expression { class FonctionImaginaire; class AppelFonctionUtilisateur; struct TransformationPrototype; }
		namespace Instruction { class Let; class LetFunc; }
		namespace Fonction
		{
			class FonctionImaginaire : public Fonction
			{
				friend class Traceur::Donnees::Expression::FonctionImaginaire;
				friend class Traceur::Donnees::Expression::AppelFonctionUtilisateur;
				friend class Traceur::Donnees::Expression::TransformationPrototype;
				friend class Traceur::Donnees::Instruction::Let;
				friend class Traceur::Donnees::Instruction::LetFunc;
				public:
					FonctionImaginaire(const PrototypeSP& prototype, Traceur::Donnees::Source::PositionSP position)
						:Fonction(prototype,position) {};
					FonctionImaginaire(const PrototypeSP& prototype, const FonctionSP& fonction, const InstanceSP& instance, Traceur::Donnees::Source::PositionSP position)
						:Fonction(prototype,position), _valeur_statique(fonction), _instance(instance) {};
					FonctionImaginaire(const PrototypeSP& prototype, const FonctionSP& fonction, Traceur::Donnees::Source::PositionSP position);
					FonctionImaginaire(const Traceur::Donnees::Expression::ExpressionSP& expression, const Traceur::Donnees::Source::PositionSP& position,
						const Traceur::Donnees::Type::TypeSP& type_attendu = Traceur::Donnees::Type::TypeSP());
					virtual void edition_liens(Traceur::Donnees::Instruction::BlocSP bloc);
					virtual void definition_fonction();
					virtual FonctionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual Traceur::Donnees::Instruction::InstructionInterruptionSP appel(
							ListeParametres gauche, ListeParametres droite, Traceur::Donnees::Assembleur::AssembleurSP& assembleur,
						Traceur::Donnees::Expression::AppelFonctionUtilisateurSP appel);
					virtual Traceur::Donnees::Expression::ExpressionSP substitution(ListeParametres gauche, ListeParametres droite);
					void evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur)
					{
						definition_fonction();
					};
					virtual void format_disp(std::ostream& os) const;
					virtual void disp(std::ostream& os) const;
					virtual void format(std::ostream& os) const;
					virtual ~FonctionImaginaire() {};
				private:
					virtual PrototypeSP& prototype() { return _prototype; };
					FonctionSP _valeur_statique;
					InstanceSP _instance; // qui contient la valeur dynamique
			};
		}
	}
}
#ifdef TRACEUR_DEBUG
void debug_instance(Traceur::Donnees::Fonction::Instance *i);
void debug_fonctionimaginaire(Traceur::Donnees::Fonction::Fonction *fi);
#endif
#endif
