#ifndef _DONNEES_FONCTIONS_INSTANCE_H_
#define _DONNEES_FONCTIONS_INSTANCE_H_
#include <iostream>
#include <map>

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Fonction { DECL_SHARED_PTR(Instance); DECL_WEAK_PTR(Instance); } } }

#include <src/donnees/fonctions/fonction.h>
#include <src/donnees/global/clonesinstances.h>
namespace Traceur
{
	namespace Donnees
	{
		namespace Expression { class AppelFonctionUtilisateur; class FonctionImaginaire; }
		namespace Instruction { class Let; class LetFunc; class For; }
		namespace Fonction
		{
			class Declarations;
			class FonctionReelle;
			class FonctionImaginaire;
			class SauvegardeParametres;
			class Declarations;
			struct DispDeclaration;
			class Instance
			{
				friend struct DispDeclaration;
				friend class Declarations;
				friend class FonctionReelle;
				friend class FonctionImaginaire;
				friend class SauvegardeParametres;
				friend class Traceur::Donnees::Expression::AppelFonctionUtilisateur;
				friend class Traceur::Donnees::Expression::FonctionImaginaire;
				friend class Traceur::Donnees::Instruction::Let;
				friend class Traceur::Donnees::Instruction::LetFunc;
				friend class Traceur::Donnees::Instruction::For;
				public:
					Instance() = default;
					virtual InstanceSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances) = 0;
					virtual void format(std::ostream& os) const = 0;
					virtual ~Instance() {};
				private:
					virtual void valeur_dynamique(FonctionSP fonction) = 0;
					virtual FonctionSP valeur_dynamique() =0;
					virtual FonctionSP valeur_appel() = 0;
			};
		}
	}
}
#endif
