#include <src/donnees/fonctions/instancenormale.h>
using namespace Traceur::Donnees::Fonction;

void InstanceNormale::format(std::ostream& os) const
{
	os << "instance " << this ;
	if(_valeur_dynamique)
	{
		os << "(dynamic " << _valeur_dynamique.get() << ")";
#ifdef TRACEUR_DEBUG
		std::cerr << std::endl;
		TRACEUR_TRACE << _valeur_dynamique << std::endl;
		TRACEUR_TRACE << "Valeur statique :" << std::endl;
#endif
	}
}

InstanceSP InstanceNormale::clone(Traceur::Donnees::Global::ClonesInstances& clones_instances)
{
	InstanceSP clone_ptetre = clones_instances[this];
	if(clone_ptetre)
		return clone_ptetre;
	FonctionSP dynamique;
	if(_valeur_dynamique)
	{
		dynamique = _valeur_dynamique->clone(clones_instances);
	}
	InstanceSP clone(new InstanceNormale(dynamique));
	clones_instances.ajout(this,clone);
	return clone;
}
