#ifndef _DONNEES_FONCTIONS_INSTANCERECURSIVE_H_
#define _DONNEES_FONCTIONS_INSTANCERECURSIVE_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Fonction { DECL_SHARED_PTR(InstanceRecursive); } } }

#include <src/donnees/fonctions/fonction.h>
#include <src/donnees/fonctions/instance.h>
namespace Traceur
{
	namespace Donnees
	{
		namespace Fonction
		{
			class InstanceRecursive : public Instance
			{
				public:
					InstanceRecursive(const FonctionSP& fonction)
						:_valeur_dynamique(fonction) {};
					virtual InstanceSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual void format(std::ostream& os) const;
					virtual ~InstanceRecursive() {};
				protected:
					FonctionWP _valeur_dynamique;
				private:
					virtual void valeur_dynamique(FonctionSP fonction) { throw; };
					virtual FonctionSP valeur_dynamique() { return FonctionSP(); }
					virtual FonctionSP valeur_appel()
					{
						Traceur::Donnees::Global::ClonesInstances clones_instances;
						FonctionSP clone = _valeur_dynamique.lock()->clone(clones_instances);
						return clone;
					};
			};
		}
	}
}
#endif
