#ifndef _DONNEES_INSTRUCTIONS_INSTRUCTIONCONV_H_
#define _DONNEES_INSTRUCTIONS_INSTRUCTIONCONV_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Instruction { DECL_SHARED_PTR(Conv); } } }

#include <src/donnees/instructions/instruction.h>
#include <src/donnees/expressions/expression.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Instruction
		{
			class Conv : public Instruction
			{
				public:
					Conv(const Traceur::Donnees::Expression::ExpressionSP& expression,
						const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP());
					virtual void edition_liens(BlocSP bloc);
					virtual void definition_fonction();
					virtual InstructionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual InstructionInterruptionSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					bool teste_retour_fonction(const Traceur::Donnees::Type::TypeSP& type) const { return false; };
					virtual void disp(std::ostream& os) const;
					virtual void format(std::ostream& os) const;
					virtual ~Conv() {};
				private:
					Conv(const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP())
						:Instruction(position) {};
					Traceur::Donnees::Expression::ExpressionSP _expression;
			};
		}
	}
}
#endif
