#ifndef _DONNEES_INSTRUCTIONS_INSTRUCTIONDISP_H_
#define _DONNEES_INSTRUCTIONS_INSTRUCTIONDISP_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Instruction { DECL_SHARED_PTR(Disp); } } }

#include <src/donnees/instructions/instruction.h>
#include <src/donnees/expressions/expression.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Instruction
		{
			class Disp : public Instruction
			{
				public:
					Disp(const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP()) :Instruction(position) {}; // mode debug : affichera toute la pile d'appel avec toutes les fonctions connues et leurs valeurs
					Disp(const Traceur::Donnees::Expression::ExpressionSP& expression,
						const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP())
						:Instruction(position), _expression(expression) {};
					virtual void edition_liens(BlocSP bloc);
					virtual void definition_fonction();
					virtual InstructionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual InstructionInterruptionSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					bool teste_retour_fonction(const Traceur::Donnees::Type::TypeSP& type) const { return false; };
					virtual void disp(std::ostream& os) const;
					virtual void format(std::ostream& os) const;
					virtual ~Disp() {};
				private:
					Traceur::Donnees::Expression::ExpressionSP _expression;
			};
		}
	}
}
#endif
