#include <src/donnees/instructions/instructiondo.h>
using namespace Traceur::Donnees::Instruction;

void Do::disp(std::ostream& os) const
{
	Instruction::disp(os);
	format(os);
}

void Do::format(std::ostream& os) const
{
	os << "do " << std::endl;
	_bloc->format(os);
	os << "end" << std::endl;
}

void Do::edition_liens(BlocSP bloc)
{
	Instruction::edition_liens(bloc);
	_bloc->edition_liens(bloc,this->shared_from_this());
}

InstructionInterruptionSP Do::evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur)
{
	return _bloc->evaluation(assembleur);
}

void Do::definition_fonction()
{
	_bloc->definition_fonction();
}

InstructionSP Do::clone(Traceur::Donnees::Global::ClonesInstances& clones_instances)
{
	BlocSP parent = clones_instances[_parent.lock().get()];
	if(not parent)
		parent = _parent.lock();
	DoSP clone(new Do(_position));
	clones_instances.ajout(this,clone);
	BlocSP clone_bloc = _bloc->clone(clones_instances);
	clone->_bloc = clone_bloc;
	clone->_parent = parent;
	return clone;
}
