#ifndef _DONNEES_INSTRUCTIONS_INSTRUCTIONDO_H_
#define _DONNEES_INSTRUCTIONS_INSTRUCTIONDO_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Instruction { DECL_SHARED_PTR(Do); } } }

#include <src/donnees/instructions/instruction.h>
#include <src/donnees/instructions/bloc.h>
#include <src/donnees/fonctions/fonctionreelle.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Instruction
		{
			class Do : public Instruction
			{
				friend class Traceur::Donnees::Fonction::FonctionReelle;
				public:
					Do(const BlocSP& bloc,
						const Traceur::Donnees::Source::PositionSP position = Traceur::Donnees::Source::PositionSP())
						:Instruction(position),_bloc(bloc) { };
					bool teste_retour_fonction(const Traceur::Donnees::Type::TypeSP& type) const { return _bloc->teste_retour_fonction(type); };
					virtual void edition_liens(BlocSP bloc);
					virtual void definition_fonction();
					virtual InstructionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual InstructionInterruptionSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual void disp(std::ostream& os) const;
					virtual void format(std::ostream& os) const;
					virtual ~Do() {};
				private:
					Do(const Traceur::Donnees::Source::PositionSP position) :Instruction(position) {};
					BlocSP _bloc;
			};
		}
	}
}
#endif
