#include <src/donnees/instructions/instructiondpt.h>
#include <src/donnees/assembleur/assembleur.h>
#include <src/donnees/instructions/valeur.h>
#include <src/donnees/types/typepoint.h>
#include <src/donnees/types/typevoid.h>

using namespace Traceur::Donnees::Instruction;

Dpt::Dpt(const Traceur::Donnees::Source::PositionSP& position)
:Instruction(position)
{
}

void Dpt::edition_liens(BlocSP bloc)
{
	Instruction::edition_liens(bloc);
}

InstructionInterruptionSP Dpt::evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur)
{
	try
	{
		assembleur->dpt();
	}
	catch(ValeurSP valeur)
	{
		InstructionInterruptionSP interruption = *valeur;
		interruption->ajoute_position(_position);
		return interruption;
	}
	return InstructionInterruptionSP();
}

void Dpt::disp(std::ostream& os) const
{
	Instruction::disp(os);
	format(os);
}

void Dpt::format(std::ostream& os) const
{
	os << "dpt " << std::endl;
}

void Dpt::definition_fonction()
{
}

InstructionSP Dpt::clone(Traceur::Donnees::Global::ClonesInstances& clones_instances)
{
	BlocSP parent = clones_instances[_parent.lock().get()];
	if(not parent)
		parent = _parent.lock();
	DptSP clone(new Dpt(_position));
	clones_instances.ajout(this,clone);
	clone->_parent = parent;
	return clone;
}
