#ifndef _DONNEES_INSTRUCTIONS_INSTRUCTIONDRAWAT_H_
#define _DONNEES_INSTRUCTIONS_INSTRUCTIONDRAWAT_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Instruction { DECL_SHARED_PTR(DrawAt); } } }

#include <src/donnees/instructions/instruction.h>
#include <src/donnees/expressions/expression.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Instruction
		{
			class DrawAt : public Instruction
			{
				public:
					DrawAt(const Traceur::Donnees::Expression::ExpressionSP& image, const Traceur::Donnees::Expression::ExpressionSP& point, 
						const Traceur::Donnees::Expression::ExpressionSP& alpha, 
						const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP());
					virtual void edition_liens(BlocSP bloc);
					virtual void definition_fonction();
					virtual InstructionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual InstructionInterruptionSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					bool teste_retour_fonction(const Traceur::Donnees::Type::TypeSP& type) const { return false; };
					virtual void disp(std::ostream& os) const;
					virtual void format(std::ostream& os) const;
					virtual ~DrawAt() {};
				private:
					DrawAt(const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP())
						:Instruction(position) {};
					Traceur::Donnees::Expression::ExpressionSP _image;
					Traceur::Donnees::Expression::ExpressionSP _point;
					Traceur::Donnees::Expression::ExpressionSP _alpha;
			};
		}
	}
}
#endif
