#ifndef _DONNEES_INSTRUCTIONS_INSTRUCTIONERROR_H_
#define _DONNEES_INSTRUCTIONS_INSTRUCTIONERROR_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Instruction { DECL_SHARED_PTR(Error); } } }

#include <src/donnees/instructions/instructioninterruption.h>
#include <src/exceptions/exceptions.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Instruction
		{
			class Valeur;
			class Try;
			class Error : public InstructionInterruption
			{
				friend class Valeur;
				friend class Try;
				public:
					Error(const Traceur::Donnees::Fonction::Identifiant nom,
						const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP())
						:InstructionInterruption(position),_nom(nom) {};
					virtual bool teste_retour_fonction(const Traceur::Donnees::Type::TypeSP& type) const;
					virtual void edition_liens(BlocSP bloc);
					virtual void definition_fonction();
					virtual InstructionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual InstructionInterruptionSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual Traceur::Donnees::Expression::ExpressionSP expression_equivalente() const;
					virtual std::pair<InstructionInterruption::Action,InstructionInterruptionSP> comportement_boucle();
					virtual std::pair<InstructionInterruption::Action,InstructionInterruptionSP> comportement_image();
					virtual void disp(std::ostream& os) const;
					virtual void format(std::ostream& os) const;
					Traceur::Exception::Execution exception();
					static ErrorSP condition_peut_etre_trouvee(Traceur::Donnees::Source::PositionSP position);
					static ErrorSP boucle_for_infinie_detectee(Traceur::Donnees::Source::PositionSP position);
					virtual ~Error() {};
				private:
					Traceur::Donnees::Fonction::Identifiant _nom;
					Error(const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP());

			};
		}
	}
}
#endif
