#include <src/donnees/instructions/instructionidpt.h>
#include <src/donnees/assembleur/assembleur.h>
#include <src/donnees/instructions/valeur.h>
#include <src/donnees/types/typepoint.h>
#include <src/donnees/types/typevoid.h>

using namespace Traceur::Donnees::Instruction;

Idpt::Idpt(const Traceur::Donnees::Source::PositionSP& position)
:Instruction(position)
{
}

void Idpt::edition_liens(BlocSP bloc)
{
	Instruction::edition_liens(bloc);
}

InstructionInterruptionSP Idpt::evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur)
{
	try
	{
		assembleur->idpt();
	}
	catch(ValeurSP valeur)
	{
		InstructionInterruptionSP interruption = *valeur;
		interruption->ajoute_position(_position);
		return interruption;
	}
	return InstructionInterruptionSP();
}

void Idpt::disp(std::ostream& os) const
{
	Instruction::disp(os);
	format(os);
}

void Idpt::format(std::ostream& os) const
{
	os << "idpt " << std::endl;
}

void Idpt::definition_fonction()
{
}

InstructionSP Idpt::clone(Traceur::Donnees::Global::ClonesInstances& clones_instances)
{
	BlocSP parent = clones_instances[_parent.lock().get()];
	if(not parent)
		parent = _parent.lock();
	IdptSP clone(new Idpt(_position));
	clones_instances.ajout(this,clone);
	clone->_parent = parent;
	return clone;
}
