#ifndef _DONNEES_INSTRUCTIONS_INSTRUCTIONIF_H_
#define _DONNEES_INSTRUCTIONS_INSTRUCTIONIF_H_
#include <deque>

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Instruction { DECL_SHARED_PTR(If); } } }

#include <src/donnees/instructions/instructioncontrole.h>
#include <src/donnees/expressions/expression.h>
#include <src/exceptions/exceptions.h>
namespace Traceur
{
	namespace Donnees
	{
		namespace Instruction
		{
			class If : public InstructionControle
			{
				public:
					typedef std::pair<Traceur::Donnees::Expression::ExpressionSP, BlocSP> ClauseVraie;
					typedef std::deque<ClauseVraie> ClausesVraies;
					If(ClausesVraies clauses_vraies, const BlocSP& clause_fausse,
						const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP());
					virtual bool teste_retour_fonction(const Traceur::Donnees::Type::TypeSP& type) const;
					virtual void edition_liens(BlocSP bloc);
					virtual void definition_fonction();
					virtual InstructionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual InstructionInterruptionSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual void disp(std::ostream& os) const;
					virtual void format(std::ostream& os) const;
					virtual ~If() {};
				private:
					If(const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP()):InstructionControle(position) {};
					ClausesVraies _clauses_vraies;
					BlocSP _clause_fausse;
			};
		}
	}
}

namespace Traceur
{
	namespace Exception
	{
		class ConditionNonBooleenne : public Compilation
		{
			public:
				ConditionNonBooleenne(Traceur::Donnees::Source::PositionSP position, const Traceur::Donnees::Type::TypeSP& type)
					:Compilation(position,std::string("Condition of type ")+std::string(*type)+std::string(" instead of Boolean.")) {};
				virtual ~ConditionNonBooleenne() {};
		};
	}
}
#endif
