#ifndef _DONNEES_INSTRUCTIONS_INSTRUCTIONINTERRUPTION_H_
#define _DONNEES_INSTRUCTIONS_INSTRUCTIONINTERRUPTION_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Instruction { DECL_SHARED_PTR(InstructionInterruption); } } }

#include <src/donnees/instructions/instructioncontrole.h>
#include <src/donnees/expressions/expression.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Instruction
		{
			class InstructionInterruption : public InstructionControle
			{
				public:
					enum class Action {RIEN,SORTIE,SUIVANT} ;
					InstructionInterruption(const Traceur::Donnees::Source::PositionSP& position) :InstructionControle(position) {};
					void ajoute_position(Traceur::Donnees::Source::PositionSP position)
					{
						if(not _position and position)
							_position=position;
					};
					virtual Traceur::Donnees::Expression::ExpressionSP expression_equivalente() const = 0;
					virtual std::pair<Action,InstructionInterruptionSP> comportement_boucle() = 0;
					virtual std::pair<Action,InstructionInterruptionSP> comportement_image() = 0;
					virtual ~InstructionInterruption() {};
			};
		}
	}
}

#endif
