#ifndef _DONNEES_INSTRUCTIONS_INSTRUCTIONLET_H_
#define _DONNEES_INSTRUCTIONS_INSTRUCTIONLET_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Instruction { DECL_SHARED_PTR(Let); DECL_SHARED_PTR(LetFunc); } } }

#include <src/donnees/instructions/instruction.h>
#include <src/donnees/fonctions/fonctionimaginaire.h>
#include <src/donnees/global/clonesinstances.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Instruction
		{
			class Let : public Instruction
			{
				public:
					Let(const Traceur::Donnees::Fonction::PrototypeSP& prototype,
						const Traceur::Donnees::Fonction::FonctionSP& fonction,
						const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP())
						:Instruction(position), _fonction(new Traceur::Donnees::Fonction::FonctionImaginaire(prototype,fonction,position)) {};
					virtual bool teste_retour_fonction(const Traceur::Donnees::Type::TypeSP& type) const { return false; };
					virtual void edition_liens(BlocSP bloc);
					virtual void definition_fonction() {/* non recursif sur les definitions de fonctions. sera fait lors de l'appel a la fonction en cours de definition */};
					virtual InstructionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual InstructionInterruptionSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual void disp(std::ostream& os) const;
					virtual void format(std::ostream& os) const;
					virtual ~Let() {};
				protected:
					Traceur::Donnees::Fonction::FonctionImaginaireSP _fonction;
					bool _definition_locale;
					Let(const Traceur::Donnees::Source::PositionSP& position,
						const Traceur::Donnees::Fonction::PrototypeSP& prototype)
						:Instruction(position), _fonction(new Traceur::Donnees::Fonction::FonctionImaginaire(prototype,position)) {};
			};

			class LetFunc : public Let
			{
				public:
					LetFunc(const Traceur::Donnees::Fonction::PrototypeSP& prototype,
						const Traceur::Donnees::Instruction::InstructionSP& instruction,
						const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP());
					virtual InstructionInterruptionSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual InstructionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual void disp(std::ostream& os) const;
					virtual void format(std::ostream& os) const;
					virtual ~LetFunc() {};
				private:
					LetFunc(const Traceur::Donnees::Fonction::PrototypeSP& prototype, const Traceur::Donnees::Source::PositionSP& position)
						:Let(position,prototype) {};

			};
		}
	}
}
#endif
