#include <src/donnees/instructions/instructionnext.h>
#include <src/donnees/expressions/expressionvide.h>
#include <src/donnees/assembleur/assembleur.h>
#include <algorithm>
#include <locale>
using namespace Traceur::Donnees::Instruction;

bool Next::teste_retour_fonction(const Traceur::Donnees::Type::TypeSP& type) const
{
	return true;
}

Traceur::Donnees::Expression::ExpressionSP Next::expression_equivalente() const
{
	return Traceur::Donnees::Expression::Vide::SP();
}

void Next::disp(std::ostream& os) const
{
	Instruction::disp(os);
	format(os);
}

void Next::format(std::ostream& os) const
{
	os << "next " << _niveau << std::endl;
}

void Next::edition_liens(BlocSP bloc)
{
}

InstructionInterruptionSP Next::evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur)
{
	InstructionInterruptionSP interruption = std::static_pointer_cast<InstructionInterruption>(this->shared_from_this());
	return interruption;
}

void Next::definition_fonction()
{
}

InstructionSP Next::clone(Traceur::Donnees::Global::ClonesInstances& clones_instances)
{
	BlocSP parent = clones_instances[_parent.lock().get()];
	if(not parent)
		parent = _parent.lock();
	NextSP clone(new Next(_niveau,_position));
	clones_instances.ajout(this,clone);
	clone->_parent = parent;
	return clone;
}

std::pair<InstructionInterruption::Action,InstructionInterruptionSP> Next::comportement_boucle()
{
	switch(_niveau)
	{
		case 0:
			{
				InstructionInterruptionSP interruption(new Next(_niveau));
				return std::make_pair(InstructionInterruption::Action::SORTIE,interruption);
			}
		case 1:
			return std::make_pair(InstructionInterruption::Action::SUIVANT,InstructionInterruptionSP());
		default:
			{
				InstructionInterruptionSP interruption(new Next(_niveau-1));
				return std::make_pair(InstructionInterruption::Action::SORTIE,interruption);
			}
	}
}

std::pair<InstructionInterruption::Action,InstructionInterruptionSP> Next::comportement_image()
{
	switch(_niveau)
	{
		case 0:
			{
				return std::make_pair(InstructionInterruption::Action::SORTIE,InstructionInterruptionSP());
			}
		default:
			{
				InstructionInterruptionSP interruption(new Next(_niveau));
				return std::make_pair(InstructionInterruption::Action::SORTIE,interruption);
			}
	}
}
