#ifndef _DONNEES_INSTRUCTIONS_INSTRUCTIONNEXT_H_
#define _DONNEES_INSTRUCTIONS_INSTRUCTIONNEXT_H_

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Instruction { DECL_SHARED_PTR(Next); } } }

#include <src/donnees/instructions/instructioninterruption.h>
#include <src/exceptions/exceptions.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Instruction
		{
			class Valeur;
			class Next : public InstructionInterruption
			{
				friend class Valeur;
				public:
					Next(const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP())
						:InstructionInterruption(position),_niveau(1) {};
					Next(const size_t niveau,
						const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP())
						:InstructionInterruption(position),_niveau(niveau) {};
					virtual bool teste_retour_fonction(const Traceur::Donnees::Type::TypeSP& type) const;
					virtual void edition_liens(BlocSP bloc);
					virtual void definition_fonction();
					virtual InstructionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual InstructionInterruptionSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual Traceur::Donnees::Expression::ExpressionSP expression_equivalente() const;
					virtual std::pair<InstructionInterruption::Action,InstructionInterruptionSP> comportement_boucle();
					virtual std::pair<InstructionInterruption::Action,InstructionInterruptionSP> comportement_image();
					virtual void disp(std::ostream& os) const;
					virtual void format(std::ostream& os) const;
					virtual ~Next() {};
				private:
					size_t _niveau;

			};
		}
	}
}
#endif
