#ifndef _DONNEES_INSTRUCTIONS_INSTRUCTIONTRY_H_
#define _DONNEES_INSTRUCTIONS_INSTRUCTIONTRY_H_
#include <deque>

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Instruction { DECL_SHARED_PTR(Try); } } }

#include <src/donnees/instructions/instructioncontrole.h>
#include <src/donnees/expressions/expression.h>
#include <src/exceptions/exceptions.h>
namespace Traceur
{
	namespace Donnees
	{
		namespace Instruction
		{
			class Try : public InstructionControle
			{
				public:
					typedef std::deque<Traceur::Donnees::Fonction::Identifiant> ListeErreur;
					typedef std::pair<ListeErreur, BlocSP> ClauseCatch;
					typedef std::deque<ClauseCatch> ClausesCatch;
					Try(BlocSP essai, ClausesCatch clauses_catch,
						const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP());
					virtual bool teste_retour_fonction(const Traceur::Donnees::Type::TypeSP& type) const;
					virtual void edition_liens(BlocSP bloc);
					virtual void definition_fonction();
					virtual InstructionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual InstructionInterruptionSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual void disp(std::ostream& os) const;
					virtual void format(std::ostream& os) const;
					virtual ~Try() {};
				private:
					Try(const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP()):InstructionControle(position) {};
					BlocSP _essai;
					ClausesCatch _clauses_catch;
					BlocSP _clause_totale;
			};
		}
	}
}

#endif
