#ifndef _DONNEES_INSTRUCTIONS_INSTRUCTIONWHILE_H_
#define _DONNEES_INSTRUCTIONS_INSTRUCTIONWHILE_H_
#include <deque>

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Instruction { DECL_SHARED_PTR(While); } } }

#include <src/donnees/instructions/instructioncontrole.h>
#include <src/donnees/expressions/expression.h>
#include <src/exceptions/exceptions.h>
namespace Traceur
{
	namespace Donnees
	{
		namespace Instruction
		{
			class While : public InstructionControle
			{
				public:
					While(const Traceur::Donnees::Expression::ExpressionSP condition, const BlocSP& bloc,
						const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP());
					virtual bool teste_retour_fonction(const Traceur::Donnees::Type::TypeSP& type) const;
					virtual void edition_liens(BlocSP bloc);
					virtual void definition_fonction();
					virtual InstructionSP clone(Traceur::Donnees::Global::ClonesInstances& clones_instances);
					virtual InstructionInterruptionSP evaluation(Traceur::Donnees::Assembleur::AssembleurSP& assembleur);
					virtual void disp(std::ostream& os) const;
					virtual void format(std::ostream& os) const;
					virtual ~While() {};
				private:
					While(const Traceur::Donnees::Source::PositionSP& position = Traceur::Donnees::Source::PositionSP()):InstructionControle(position) {};
					Traceur::Donnees::Expression::ExpressionSP _condition;
					BlocSP _bloc;
			};
		}
	}
}
#endif
