#ifndef __DONEEES_SOURCES_POSITION_H_
#define __DONEEES_SOURCES_POSITION_H_
#include <string>
#include <sstream>

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Source { DECL_SHARED_PTR(Position); } } }

namespace Traceur
{
	namespace Donnees
	{
		namespace Source
		{
			class Position
			{
				public:
					Position() = default;
					void ligne_suivante() { _ligne++; };
					void nouveau_fichier(std::string fichier)
					{
						_nom_fichier = SHARED_PTR(std::string )(new std::string(fichier));
						_ligne=1;
					};
					operator PositionSP ()
					{
						PositionSP position(new Position());
						position->_nom_fichier=_nom_fichier;
						position->_ligne=_ligne;
						return position;
					};
					operator std::string ()
					{
						std::ostringstream oss;
						if(_nom_fichier)
						{
							oss << "File " << *(_nom_fichier) << ", line " << _ligne << " > ";
						}
						return oss.str();
					};
				private:
					SHARED_PTR(std::string ) _nom_fichier;
					size_t _ligne;
					
			};
		}
	}
}
#endif
