#ifndef _DONNEES_TYPES_ATOMIQUE_H_
#define _DONNEES_TYPES_ATOMIQUE_H_


#include <iostream>

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Type { DECL_SHARED_PTR(Atomique); } } }

#include <src/donnees/types/type.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Type
		{
			class Atomique : public Type
			{
				public:
				virtual bool operator<(const Type& type) const;
				virtual bool operator==(const Type& type) const;
				virtual Compatibilite compatible_prototype(const TypeSP& type, const bool compatibilite_exacte = false)
				{
					
					AtomiqueSP atomique = std::dynamic_pointer_cast<Atomique>(type);
					if(not atomique)
						return NonCompatible();

					if(atomique->compatible(this->shared_from_this()))
					{
						if((*this)==(*atomique))
							return Compatible(Compatible::Transtypage::SANS);
						else
							return Compatible(Compatible::Transtypage::AVEC);
					}
					return NonCompatible();
				};
				virtual bool atomique() const { return true; };
				virtual ~Atomique() {};
			};
		}
	}
}

#endif
