#ifndef __DONNEES_TYPES_TYPE_FONCTION_H_
#define __DONNEES_TYPES_TYPE_FONCTION_H_

#include <vector>
#include <string>

#include <src/global/global.h>
namespace Traceur { namespace Donnees { namespace Type { DECL_SHARED_PTR(Fonction); } } }

#include <src/donnees/types/type.h>
#include <src/donnees/fonctions/fonctionidentifiant.h>

namespace Traceur
{
	namespace Donnees
	{
		namespace Fonction { DECL_SHARED_PTR(Prototype); class Parametre; }
		namespace Type
		{
			struct CompatiblePrototypeType;
			class Fonction : public Type
			{
				friend class Traceur::Donnees::Fonction::Parametre;
				friend struct CompatiblePrototypeType;
				public:
					typedef std::vector<TypeSP> ListeParametres;

					Fonction(TypeSP type_retour, ListeParametres parametres_gauche,Traceur::Donnees::Fonction::Identifiant nom_fonction, ListeParametres parametres_droite);
					Fonction(const Traceur::Donnees::Fonction::PrototypeSP& prototype);

					virtual ~Fonction() {};
					virtual bool compatible(const TypeSP& type);
					virtual Compatibilite compatible_prototype(const TypeSP& type, const bool compatibilite_exacte = false);
					virtual void format(std::ostream& os) const;
					virtual bool operator==(const Type& type) const;
					virtual bool operator<(const Type& type) const;
				private:
					TypeSP _type_retour;
					ListeParametres _parametres_gauche;
					Traceur::Donnees::Fonction::Identifiant _nom_fonction; // ici a titre indicatif, et pour indiquer s'il y a des parametres a gauche ou a droite
					ListeParametres _parametres_droite;

					void format(ListeParametres liste_parametres, std::ostream& os) const;
			};
		}
	}
}
#endif
