#ifndef _EXCEPTIONS_H_
#define _EXCEPTIONS_H_
#include <iostream>
#include <string>

#include <src/global/global.h>

#include <src/donnees/sources/position.h>

namespace Traceur
{
	namespace Exception
	{
		class Generique
		{
			public:
				Generique() = default;
				void format(std::ostream& os) const;
			protected:
				Generique(Traceur::Donnees::Source::PositionSP position, std::string message)
					:_position(position),_message(message) {};
				Traceur::Donnees::Source::PositionSP _position;
				std::string _message;
				const std::string message() const
				{
					if(_position)
						return std::string(*_position)+_message;
					return _message; 
				};
		};


		class Compilation : public Generique
		{
			protected:
				Compilation(Traceur::Donnees::Source::PositionSP position, std::string message)
					:Generique(position,std::string("Compilation error: ")+message) {};
		};

		class Execution : public Generique
		{
			public:
				Execution(Traceur::Donnees::Source::PositionSP position,std::string message)
					:Generique(position,std::string("Runtime error: ")+message) {};
		};
	}
}
#endif
