#ifndef _GLOBAL_H_
#define _GLOBAL_H_
#include <memory>
#include <iostream>
#include <fstream>

#define SHARED_PTR(Type) std::shared_ptr< Type >

#define DECL_SHARED_PTR(Type) \
class Type;\
typedef SHARED_PTR(Type) Type##SP


#define WEAK_PTR(Type) std::weak_ptr< Type >

#define DECL_WEAK_PTR(Type) \
class Type;\
typedef WEAK_PTR(Type) Type##WP

namespace Traceur
{
	namespace Global
	{
		template<typename Type>
		struct SPinferieurSP
		{
			bool operator() (SHARED_PTR(Type) gauche, SHARED_PTR(Type) droite)
			{
				return (*gauche)<(*droite);
			};
		};
		template<typename Type>
		struct SPegalSP
		{
			bool operator() (SHARED_PTR(Type) gauche, SHARED_PTR(Type) droite)
			{
				return (*gauche)==(*droite);
			};
		};
	}
}

//#define TRACEUR_DEBUG 1
#define TRACEUR_VALIDE 1
#ifdef TRACEUR_DEBUG
#define TRACEUR_DEBUG_ETAPE 1
#define TRACEUR_VALIDE 1
#endif
template<typename T>
std::ostream& operator<<(std::ostream& flux, SHARED_PTR(T) t)
{
	if(static_cast<bool>(t)) t->format(flux);
	return flux;
}
#define TRACEUR_TRACE std::cerr << __FILE__ << ":" << __LINE__ << "> "
#ifdef TRACEUR_VALIDE
#define TRACEUR_TEST(expr) if(not (expr)) { std::cerr << "TEST FAUX A " << __FILE__ << ":" << __LINE__ << "> " << #expr << std::endl; throw; }
#else
#define TRACEUR_TEST(expr) if(false) {throw expr;}
#endif
#endif
