/* A Bison parser, made by GNU Bison 2.4.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006,
   2009, 2010 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         parseurparse
#define yylex           parseurlex
#define yyerror         parseurerror
#define yylval          parseurlval
#define yychar          parseurchar
#define yydebug         parseurdebug
#define yynerrs         parseurnerrs
#define yylloc          parseurlloc

/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "analyseur.syn.ypp"

#include <cmath>
#include <string>
#include <vector>
#include <iostream>

#include <src/donnees/instructions/instructions.h>
#include <src/donnees/expressions/expressions.h>
#include <src/donnees/fonctions/fonctions.h>
#include <src/exceptions/exceptions.h>
#include <src/donnees/types/types.h>
#include <src/donnees/global/cacheobjets.h>

	extern FILE* parseurin;
	extern int parseurlex();
	int parseurerror(Traceur::Donnees::Instruction::BlocSP, Traceur::Donnees::Global::CacheObjetGenerique& cache, std::string);
namespace Traceur
{
	namespace Exception
	{
		class ErreurDeSyntaxe : public Compilation
		{
			public:
				ErreurDeSyntaxe(Traceur::Donnees::Source::PositionSP position,const std::string& mesg)
					:Compilation(position,mesg) {};
				virtual ~ErreurDeSyntaxe() {};
		};

		class ErreurOptionLigne : public Compilation
		{
			public:
				ErreurOptionLigne(Traceur::Donnees::Source::PositionSP position,const std::string& option)
					:Compilation(position,std::string("Invalid option ")+option+std::string(" for lines.")) {};
				virtual ~ErreurOptionLigne() {};
		};

		class ErreurOptionSurface : public Compilation
		{
			public:
				ErreurOptionSurface(Traceur::Donnees::Source::PositionSP position,const std::string& option)
					:Compilation(position,std::string("Invalid option ")+option+std::string(" for surfaces.")) {};
				virtual ~ErreurOptionSurface() {};
		};
	}
}

#define YYDEBUG 0

#define YYLTYPE Traceur::Donnees::Source::Position
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do \
		if(YYID(N)) \
		{\
			Current = Rhs[1];\
		}\
		else\
		{\
			Current = Rhs[0];\
		}\
	while(YYID(0))


/* Line 189 of yacc.c  */
#line 143 "analyseur.syn.cpp"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOKEN_BOOLEEN_OUEXCL = 258,
     TOKEN_BOOLEEN_OU = 259,
     TOKEN_BOOLEEN_ET = 260,
     TOKEN_BOOLEEN_NON = 261,
     TOKEN_COMP_SUPOUEGAL = 262,
     TOKEN_COMP_INFOUEGAL = 263,
     TOKEN_COMP_SUPERIEUR = 264,
     TOKEN_COMP_INFERIEUR = 265,
     TOKEN_COMP_DIFFERENT = 266,
     TOKEN_COMP_EGAL = 267,
     TOKEN_MAX = 268,
     TOKEN_MIN = 269,
     TOKEN_PPCM = 270,
     TOKEN_PGCD = 271,
     TOKEN_MOINS = 272,
     TOKEN_PLUS = 273,
     TOKEN_RESTE = 274,
     TOKEN_DIV = 275,
     TOKEN_MULT = 276,
     TOKEN_FRAC = 277,
     TOKEN_INT = 278,
     TOKEN_RACINE_CARREE = 279,
     TOKEN_LN = 280,
     TOKEN_EXP = 281,
     TOKEN_ATAN = 282,
     TOKEN_ASIN = 283,
     TOKEN_ACOS = 284,
     TOKEN_TAN = 285,
     TOKEN_SIN = 286,
     TOKEN_COS = 287,
     OPERATEUR_MOINS = 288,
     OPERATEUR_PLUS = 289,
     TOKEN_EXPOSANT = 290,
     TOKEN_PAR_OUVRANTE = 291,
     TOKEN_PAR_FERMANTE = 292,
     TOKEN_RADIANS = 293,
     TOKEN_DEGRES = 294,
     TOKEN_ABSOLUE = 295,
     TOKEN_NOMBRE_ENTIER = 296,
     TOKEN_NOMBRE_REEL = 297,
     TOKEN_CHAINE = 298,
     TOKEN_FORMAT = 299,
     TOKEN_PI = 300,
     TOKEN_ALEATOIRE = 301,
     TOKEN_SEPARATEUR = 302,
     TOKEN_TYPE_VIDE = 303,
     TOKEN_TYPE_NOMBRE = 304,
     TOKEN_TYPE_ENTIER = 305,
     TOKEN_TYPE_REEL = 306,
     TOKEN_TYPE_CHAINE = 307,
     TOKEN_TYPE_BOOLEEN = 308,
     TOKEN_TYPE_OUTIL = 309,
     TOKEN_TYPE_POINT = 310,
     TOKEN_TYPE_VECTEUR = 311,
     TOKEN_TYPE_LIGNE = 312,
     TOKEN_TYPE_TRIANGLE = 313,
     TOKEN_TYPE_RECTANGLE = 314,
     TOKEN_TYPE_CERCLE = 315,
     TOKEN_TYPE_ELLIPSE = 316,
     TOKEN_TYPE_REMPLIR = 317,
     TOKEN_TYPE_SOLIDE = 318,
     TOKEN_TYPE_GOMME = 319,
     TOKEN_TYPE_COULEUR = 320,
     TOKEN_TYPE_IMAGE = 321,
     TOKEN_TYPE_NOYAU = 322,
     TOKEN_CONV_DEBUT = 323,
     TOKEN_CONV_SEPARATEUR = 324,
     TOKEN_CONV_FIN = 325,
     TOKEN_CONV_NOMBRE_ENTIER = 326,
     TOKEN_CONV_NOMBRE_REEL = 327,
     TOKEN_CONV_CHAINE = 328,
     TOKEN_CONV_POINT = 329,
     TOKEN_CONV_VECTEUR = 330,
     TOKEN_CONV_POLAIRE = 331,
     TOKEN_CONV_LIGNE = 332,
     TOKEN_CONV_TRIANGLE = 333,
     TOKEN_CONV_RECTANGLE = 334,
     TOKEN_CONV_CERCLE = 335,
     TOKEN_CONV_ELLIPSE = 336,
     TOKEN_CONV_REMPLIR = 337,
     TOKEN_CONV_SOLIDE = 338,
     TOKEN_CONV_GOMME = 339,
     TOKEN_OPTION_SANSDEBUT = 340,
     TOKEN_OPTION_SANSFIN = 341,
     TOKEN_OPTION_POINTILLES = 342,
     TOKEN_OPTION_TIRETS = 343,
     TOKEN_CONV_COULEUR = 344,
     TOKEN_CONV_HSV = 345,
     TOKEN_CONV_TEINTE = 346,
     TOKEN_CONV_SATURATION = 347,
     TOKEN_CONV_VALEUR = 348,
     TOKEN_CONV_ALPHA = 349,
     TOKEN_CONV_IMAGE = 350,
     TOKEN_IMAGE_GEOMETRIE = 351,
     TOKEN_IMAGE_STANDARD = 352,
     TOKEN_IMAGE_MATHEMATIQUE = 353,
     TOKEN_CONV_NOYAU = 354,
     TOKEN_IMAGE_XMIN = 355,
     TOKEN_IMAGE_XMAX = 356,
     TOKEN_IMAGE_XSCL = 357,
     TOKEN_IMAGE_XSIZ = 358,
     TOKEN_IMAGE_YMIN = 359,
     TOKEN_IMAGE_YMAX = 360,
     TOKEN_IMAGE_YSCL = 361,
     TOKEN_IMAGE_YSIZ = 362,
     TOKEN_IMAGE_AT = 363,
     TOKEN_COULEUR_NOIR = 364,
     TOKEN_COULEUR_GRIS = 365,
     TOKEN_COULEUR_BLANC = 366,
     TOKEN_COULEUR_ROUGE = 367,
     TOKEN_COULEUR_VERT = 368,
     TOKEN_COULEUR_BLEU = 369,
     TOKEN_COULEUR_MAGENTA = 370,
     TOKEN_COULEUR_CYAN = 371,
     TOKEN_COULEUR_JAUNE = 372,
     TOKEN_COULEUR_TRANSPARENT = 373,
     TOKEN_ERREUR = 374,
     TOKEN_CATCH = 375,
     TOKEN_COULEUR_HEXA = 376,
     TOKEN_BOOLEEN_VRAI = 377,
     TOKEN_BOOLEEN_FAUX = 378,
     TOKEN_BOOLEEN_INCERTAIN = 379,
     TOKEN_DECLARATION = 380,
     TOKEN_RECURSION = 381,
     TOKEN_AFFECTATION = 382,
     TOKEN_FONCTION = 383,
     TOKEN_CONTROLE_DISP = 384,
     TOKEN_CONTROLE_DO = 385,
     TOKEN_CONTROLE_END = 386,
     TOKEN_CONTROLE_IF = 387,
     TOKEN_CONTROLE_THEN = 388,
     TOKEN_CONTROLE_ELIF = 389,
     TOKEN_CONTROLE_ELSE = 390,
     TOKEN_CONTROLE_FOR = 391,
     TOKEN_CONTROLE_FROM = 392,
     TOKEN_CONTROLE_TO = 393,
     TOKEN_CONTROLE_BY = 394,
     TOKEN_CONTROLE_WHILE = 395,
     TOKEN_CONTROLE_UNTIL = 396,
     TOKEN_CONTROLE_NEXT = 397,
     TOKEN_CONTROLE_EXIT = 398,
     TOKEN_CONTROLE_RETURN = 399,
     TOKEN_CONTROLE_ERROR = 400,
     TOKEN_CONTROLE_DRAW = 401,
     TOKEN_CONTROLE_CONV = 402,
     TOKEN_CONTROLE_DPT = 403,
     TOKEN_CONTROLE_IDPT = 404,
     TOKEN_CONTROLE_WITH = 405,
     TOKEN_CONTROLE_READ = 406,
     TOKEN_CONTROLE_WRITE = 407,
     TOKEN_CONTROLE_TRY = 408,
     TOKEN_CONTROLE_CATCH = 409,
     TOKEN_CORPS_DEBUT = 410,
     TOKEN_CORPS_FIN = 411,
     TOKEN_IDENTIFIANT = 412
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 71 "analyseur.syn.ypp"

	int Entier;
	double Reel;
	std::string *Chaine;
	Traceur::Donnees::Instruction::Bloc *Bloc;
	Traceur::Donnees::Instruction::Instruction *Instruction;
	Traceur::Donnees::Instruction::Do *Controle_Do;
	Traceur::Donnees::Instruction::Disp *Controle_Disp;
	Traceur::Donnees::Instruction::Draw *Controle_Draw;
	Traceur::Donnees::Instruction::DrawAt *Controle_DrawAt;
	Traceur::Donnees::Instruction::Conv *Controle_Conv;
	Traceur::Donnees::Instruction::Dpt *Controle_Dpt;
	Traceur::Donnees::Instruction::Idpt *Controle_Idpt;
	Traceur::Donnees::Instruction::With *Controle_With;
	Traceur::Donnees::Instruction::Write *Controle_Write;
	Traceur::Donnees::Instruction::Read *Controle_Read;
	Traceur::Donnees::Instruction::Return *Controle_Return;
	Traceur::Donnees::Instruction::Error *Controle_Error;
	Traceur::Donnees::Instruction::Let *Controle_Let;
	Traceur::Donnees::Type::Type *Type;
	Traceur::Donnees::Fonction::Prototype *Prototype;
	Traceur::Donnees::Fonction::Prototype::ListeParametres *PrototypeListeParametres;
	Traceur::Donnees::Fonction::FonctionImaginaire *FonctionImaginaire;
	Traceur::Donnees::Expression::AppelFonctionUtilisateur::ListeParametres *AppelFonctionListeParametres;
	Traceur::Donnees::Instruction::If *Controle_If;
	Traceur::Donnees::Instruction::If::ClauseVraie *Clause_Vraie;
	Traceur::Donnees::Instruction::If::ClausesVraies *Clauses_Vraies;
	Traceur::Donnees::Instruction::Try *Controle_Try;
	Traceur::Donnees::Instruction::Try::ClausesCatch *Clauses_Catch;
	Traceur::Donnees::Instruction::Try::ClauseCatch *Clause_Catch;
	Traceur::Donnees::Instruction::Try::ListeErreur *Liste_Erreur;
	Traceur::Donnees::Instruction::Next *Controle_Next;
	Traceur::Donnees::Instruction::Exit *Controle_Exit;
	Traceur::Donnees::Instruction::While *Controle_While;
	Traceur::Donnees::Instruction::Until *Controle_Until;
	Traceur::Donnees::Instruction::For *Controle_For;
	Traceur::Donnees::Expression::Expression *Expression;
	Traceur::Donnees::Expression::SystemeCoordonnees *SystemeCoordonnees;
	Traceur::Donnees::Expression::OptionLigneSimple *OptionLigneSimple;
	Traceur::Donnees::Expression::OptionsLigne *OptionsLigne;
	Traceur::Donnees::Expression::OptionSurfaceSimple *OptionSurfaceSimple;
	Traceur::Donnees::Expression::OptionsSurface *OptionsSurface;



/* Line 214 of yacc.c  */
#line 382 "analyseur.syn.cpp"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 407 "analyseur.syn.cpp"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3733

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  158
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  54
/* YYNRULES -- Number of rules.  */
#define YYNRULES  240
/* YYNRULES -- Number of states.  */
#define YYNSTATES  506

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   412

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,     9,    11,    13,    15,    17,
      19,    21,    23,    25,    27,    29,    31,    33,    35,    37,
      39,    41,    43,    45,    47,    49,    51,    53,    55,    57,
      60,    63,    68,    73,    75,    82,    89,    96,   103,   108,
     113,   118,   120,   122,   124,   128,   131,   134,   137,   140,
     143,   146,   149,   152,   155,   159,   162,   165,   169,   173,
     177,   181,   185,   189,   192,   195,   199,   203,   207,   211,
     214,   218,   222,   226,   230,   234,   238,   242,   246,   250,
     258,   266,   276,   284,   294,   304,   310,   315,   320,   322,
     333,   344,   351,   356,   361,   366,   371,   376,   381,   386,
     391,   396,   408,   419,   421,   423,   425,   427,   429,   431,
     433,   435,   444,   451,   456,   459,   464,   470,   472,   474,
     475,   477,   479,   486,   497,   498,   500,   501,   505,   507,
     511,   513,   515,   517,   519,   521,   523,   525,   527,   529,
     531,   533,   535,   537,   539,   541,   543,   545,   547,   549,
     551,   552,   555,   557,   561,   563,   565,   567,   569,   571,
     576,   583,   585,   586,   589,   591,   595,   597,   599,   601,
     603,   605,   607,   612,   619,   622,   628,   629,   632,   635,
     638,   644,   649,   655,   661,   666,   668,   672,   673,   677,
     679,   683,   685,   687,   689,   691,   693,   696,   699,   701,
     704,   706,   710,   716,   720,   721,   725,   726,   729,   740,
     741,   744,   750,   756,   758,   761,   763,   766,   769,   774,
     776,   778,   781,   787,   789,   793,   796,   798,   800,   802,
     804,   806,   808,   810,   812,   814,   816,   818,   822,   827,
     829
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     159,     0,    -1,   160,    -1,   160,   161,    -1,    -1,   176,
      -1,   177,    -1,   179,    -1,   210,    -1,   211,    -1,   181,
      -1,   180,    -1,   208,    -1,   209,    -1,   189,    -1,   190,
      -1,   191,    -1,   195,    -1,   197,    -1,   198,    -1,   199,
      -1,   200,    -1,   188,    -1,   201,    -1,   202,    -1,    41,
      -1,    42,    -1,    45,    -1,    46,    -1,   162,    39,    -1,
     162,    38,    -1,    71,    68,   162,    70,    -1,    72,    68,
     162,    70,    -1,    43,    -1,    73,    68,   162,    69,    44,
      70,    -1,    74,    68,   162,    69,   162,    70,    -1,    75,
      68,   162,    69,   162,    70,    -1,    76,    68,   162,    69,
     162,    70,    -1,    74,    68,   162,    70,    -1,    75,    68,
     162,    70,    -1,    76,    68,   162,    70,    -1,   122,    -1,
     123,    -1,   124,    -1,    36,   162,    37,    -1,    32,   162,
      -1,    31,   162,    -1,    30,   162,    -1,    29,   162,    -1,
      28,   162,    -1,    27,   162,    -1,    26,   162,    -1,    25,
     162,    -1,    24,   162,    -1,    40,   162,    40,    -1,    23,
     162,    -1,    22,   162,    -1,   162,    18,   162,    -1,   162,
      17,   162,    -1,   162,    21,   162,    -1,   162,    20,   162,
      -1,   162,    19,   162,    -1,   162,    35,   162,    -1,    18,
     162,    -1,    17,   162,    -1,   162,    14,   162,    -1,   162,
      13,   162,    -1,   162,    16,   162,    -1,   162,    15,   162,
      -1,     6,   162,    -1,   162,     5,   162,    -1,   162,     4,
     162,    -1,   162,     3,   162,    -1,   162,    12,   162,    -1,
     162,    11,   162,    -1,   162,    10,   162,    -1,   162,     8,
     162,    -1,   162,     9,   162,    -1,   162,     7,   162,    -1,
      77,    68,   162,    69,   162,   170,    70,    -1,    80,    68,
     162,    69,   162,   173,    70,    -1,    78,    68,   162,    69,
     162,    69,   162,   173,    70,    -1,    79,    68,   162,    69,
     162,   173,    70,    -1,    79,    68,   162,    69,   162,    69,
     162,   173,    70,    -1,    81,    68,   162,    69,   162,    69,
     162,   173,    70,    -1,    82,    68,   162,   173,    70,    -1,
      83,    68,   162,    70,    -1,    84,    68,   162,    70,    -1,
     207,    -1,    89,    68,   162,    69,   162,    69,   162,    69,
     162,    70,    -1,    90,    68,   162,    69,   162,    69,   162,
      69,   162,    70,    -1,    89,    68,   162,    69,   162,    70,
      -1,    89,    68,   162,    70,    -1,    90,    68,   162,    70,
      -1,   112,    68,   162,    70,    -1,   113,    68,   162,    70,
      -1,   114,    68,   162,    70,    -1,    94,    68,   162,    70,
      -1,    91,    68,   162,    70,    -1,    92,    68,   162,    70,
      -1,    93,    68,   162,    70,    -1,    95,    68,   162,    69,
     162,    70,   165,   166,   155,   160,   156,    -1,    99,    68,
     162,    69,   162,    70,   165,   155,   160,   156,    -1,   100,
      -1,   101,    -1,   102,    -1,   103,    -1,   104,    -1,   105,
      -1,   106,    -1,   107,    -1,   120,    68,   162,    69,   157,
      69,   162,    70,    -1,   120,    68,   162,    69,   162,    70,
      -1,   183,   167,   157,   167,    -1,   128,   182,    -1,   128,
     182,   127,   186,    -1,   128,   126,   182,   127,   186,    -1,
     163,    -1,   162,    -1,    -1,    96,    -1,    97,    -1,    98,
      68,   162,    69,   162,    70,    -1,    98,    68,   162,    69,
     162,    69,   162,    69,   162,    70,    -1,    -1,   162,    -1,
      -1,    36,   168,    37,    -1,   164,    -1,   168,    47,   164,
      -1,    48,    -1,    49,    -1,    50,    -1,    51,    -1,    52,
      -1,    53,    -1,    55,    -1,    56,    -1,    54,    -1,    57,
      -1,    58,    -1,    59,    -1,    60,    -1,    61,    -1,    62,
      -1,    63,    -1,    64,    -1,    65,    -1,    66,    -1,    67,
      -1,    -1,    69,   171,    -1,   172,    -1,   171,    47,   172,
      -1,    85,    -1,    86,    -1,    83,    -1,    84,    -1,    87,
      -1,    88,    68,   162,    70,    -1,    88,    68,   162,    69,
     162,    70,    -1,    82,    -1,    -1,    69,   174,    -1,   175,
      -1,   174,    47,   175,    -1,    82,    -1,    83,    -1,    84,
      -1,    85,    -1,    86,    -1,    87,    -1,    88,    68,   162,
      70,    -1,    88,    68,   162,    69,   162,    70,    -1,   146,
     162,    -1,   146,   162,   108,   162,   178,    -1,    -1,   139,
     162,    -1,   147,   162,    -1,   150,   162,    -1,   150,   162,
     155,   160,   156,    -1,   125,   182,   127,   186,    -1,   125,
     126,   182,   127,   161,    -1,   125,   128,   182,   127,   187,
      -1,   183,   184,   157,   184,    -1,   169,    -1,    68,   182,
      70,    -1,    -1,    36,   185,    37,    -1,   182,    -1,   185,
      47,   182,    -1,   161,    -1,   162,    -1,   161,    -1,   162,
      -1,   163,    -1,   144,   162,    -1,   144,   163,    -1,   144,
      -1,   129,   162,    -1,   129,    -1,   130,   160,   131,    -1,
     132,   192,   193,   194,   131,    -1,   162,   133,   160,    -1,
      -1,   193,   134,   192,    -1,    -1,   135,   160,    -1,   136,
     182,   137,   162,   138,   162,   196,   130,   160,   131,    -1,
      -1,   139,   162,    -1,   140,   162,   130,   160,   131,    -1,
     130,   160,   141,   162,   131,    -1,   142,    -1,   142,    41,
      -1,   143,    -1,   143,    41,    -1,   145,   157,    -1,   153,
     160,   203,   131,    -1,   206,    -1,   204,    -1,   204,   203,
      -1,   154,    36,   205,    37,   160,    -1,   157,    -1,   205,
      47,   157,    -1,   154,   160,    -1,   121,    -1,   109,    -1,
     110,    -1,   111,    -1,   112,    -1,   113,    -1,   114,    -1,
     115,    -1,   116,    -1,   117,    -1,   118,    -1,   151,   137,
     162,    -1,   152,   162,   138,   162,    -1,   148,    -1,   149,
      -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   232,   232,   239,   249,   253,   255,   257,   259,   261,
     263,   265,   267,   269,   271,   273,   275,   277,   279,   281,
     283,   285,   287,   289,   291,   294,   298,   302,   306,   310,
     316,   322,   328,   334,   339,   346,   353,   360,   367,   373,
     379,   385,   389,   393,   397,   401,   407,   413,   419,   425,
     431,   437,   443,   449,   455,   461,   467,   473,   480,   487,
     494,   501,   508,   515,   521,   527,   534,   541,   548,   555,
     561,   568,   575,   582,   589,   596,   603,   610,   617,   624,
     632,   640,   649,   657,   666,   675,   682,   688,   694,   698,
     707,   716,   723,   729,   735,   741,   747,   753,   759,   765,
     771,   777,   787,   796,   800,   804,   808,   812,   816,   820,
     824,   828,   837,   844,   854,   860,   868,   877,   882,   888,
     891,   895,   899,   905,   915,   918,   924,   927,   932,   938,
     945,   949,   953,   957,   961,   965,   969,   973,   977,   981,
     985,   989,   993,   997,  1001,  1005,  1009,  1013,  1017,  1021,
    1027,  1030,  1035,  1043,  1051,  1055,  1059,  1063,  1067,  1071,
    1076,  1082,  1090,  1093,  1098,  1106,  1114,  1118,  1122,  1126,
    1132,  1138,  1144,  1151,  1160,  1167,  1177,  1180,  1185,  1192,
    1198,  1206,  1214,  1222,  1230,  1239,  1243,  1250,  1253,  1258,
    1264,  1271,  1275,  1282,  1286,  1292,  1299,  1305,  1311,  1317,
    1323,  1329,  1337,  1347,  1355,  1358,  1366,  1369,  1375,  1387,
    1390,  1395,  1403,  1411,  1416,  1422,  1427,  1433,  1440,  1448,
    1454,  1460,  1467,  1474,  1480,  1487,  1493,  1498,  1502,  1506,
    1510,  1514,  1518,  1522,  1526,  1530,  1534,  1539,  1545,  1553,
    1559
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOKEN_BOOLEEN_OUEXCL",
  "TOKEN_BOOLEEN_OU", "TOKEN_BOOLEEN_ET", "TOKEN_BOOLEEN_NON",
  "TOKEN_COMP_SUPOUEGAL", "TOKEN_COMP_INFOUEGAL", "TOKEN_COMP_SUPERIEUR",
  "TOKEN_COMP_INFERIEUR", "TOKEN_COMP_DIFFERENT", "TOKEN_COMP_EGAL",
  "TOKEN_MAX", "TOKEN_MIN", "TOKEN_PPCM", "TOKEN_PGCD", "TOKEN_MOINS",
  "TOKEN_PLUS", "TOKEN_RESTE", "TOKEN_DIV", "TOKEN_MULT", "TOKEN_FRAC",
  "TOKEN_INT", "TOKEN_RACINE_CARREE", "TOKEN_LN", "TOKEN_EXP",
  "TOKEN_ATAN", "TOKEN_ASIN", "TOKEN_ACOS", "TOKEN_TAN", "TOKEN_SIN",
  "TOKEN_COS", "OPERATEUR_MOINS", "OPERATEUR_PLUS", "TOKEN_EXPOSANT",
  "TOKEN_PAR_OUVRANTE", "TOKEN_PAR_FERMANTE", "TOKEN_RADIANS",
  "TOKEN_DEGRES", "TOKEN_ABSOLUE", "TOKEN_NOMBRE_ENTIER",
  "TOKEN_NOMBRE_REEL", "TOKEN_CHAINE", "TOKEN_FORMAT", "TOKEN_PI",
  "TOKEN_ALEATOIRE", "TOKEN_SEPARATEUR", "TOKEN_TYPE_VIDE",
  "TOKEN_TYPE_NOMBRE", "TOKEN_TYPE_ENTIER", "TOKEN_TYPE_REEL",
  "TOKEN_TYPE_CHAINE", "TOKEN_TYPE_BOOLEEN", "TOKEN_TYPE_OUTIL",
  "TOKEN_TYPE_POINT", "TOKEN_TYPE_VECTEUR", "TOKEN_TYPE_LIGNE",
  "TOKEN_TYPE_TRIANGLE", "TOKEN_TYPE_RECTANGLE", "TOKEN_TYPE_CERCLE",
  "TOKEN_TYPE_ELLIPSE", "TOKEN_TYPE_REMPLIR", "TOKEN_TYPE_SOLIDE",
  "TOKEN_TYPE_GOMME", "TOKEN_TYPE_COULEUR", "TOKEN_TYPE_IMAGE",
  "TOKEN_TYPE_NOYAU", "TOKEN_CONV_DEBUT", "TOKEN_CONV_SEPARATEUR",
  "TOKEN_CONV_FIN", "TOKEN_CONV_NOMBRE_ENTIER", "TOKEN_CONV_NOMBRE_REEL",
  "TOKEN_CONV_CHAINE", "TOKEN_CONV_POINT", "TOKEN_CONV_VECTEUR",
  "TOKEN_CONV_POLAIRE", "TOKEN_CONV_LIGNE", "TOKEN_CONV_TRIANGLE",
  "TOKEN_CONV_RECTANGLE", "TOKEN_CONV_CERCLE", "TOKEN_CONV_ELLIPSE",
  "TOKEN_CONV_REMPLIR", "TOKEN_CONV_SOLIDE", "TOKEN_CONV_GOMME",
  "TOKEN_OPTION_SANSDEBUT", "TOKEN_OPTION_SANSFIN",
  "TOKEN_OPTION_POINTILLES", "TOKEN_OPTION_TIRETS", "TOKEN_CONV_COULEUR",
  "TOKEN_CONV_HSV", "TOKEN_CONV_TEINTE", "TOKEN_CONV_SATURATION",
  "TOKEN_CONV_VALEUR", "TOKEN_CONV_ALPHA", "TOKEN_CONV_IMAGE",
  "TOKEN_IMAGE_GEOMETRIE", "TOKEN_IMAGE_STANDARD",
  "TOKEN_IMAGE_MATHEMATIQUE", "TOKEN_CONV_NOYAU", "TOKEN_IMAGE_XMIN",
  "TOKEN_IMAGE_XMAX", "TOKEN_IMAGE_XSCL", "TOKEN_IMAGE_XSIZ",
  "TOKEN_IMAGE_YMIN", "TOKEN_IMAGE_YMAX", "TOKEN_IMAGE_YSCL",
  "TOKEN_IMAGE_YSIZ", "TOKEN_IMAGE_AT", "TOKEN_COULEUR_NOIR",
  "TOKEN_COULEUR_GRIS", "TOKEN_COULEUR_BLANC", "TOKEN_COULEUR_ROUGE",
  "TOKEN_COULEUR_VERT", "TOKEN_COULEUR_BLEU", "TOKEN_COULEUR_MAGENTA",
  "TOKEN_COULEUR_CYAN", "TOKEN_COULEUR_JAUNE", "TOKEN_COULEUR_TRANSPARENT",
  "TOKEN_ERREUR", "TOKEN_CATCH", "TOKEN_COULEUR_HEXA",
  "TOKEN_BOOLEEN_VRAI", "TOKEN_BOOLEEN_FAUX", "TOKEN_BOOLEEN_INCERTAIN",
  "TOKEN_DECLARATION", "TOKEN_RECURSION", "TOKEN_AFFECTATION",
  "TOKEN_FONCTION", "TOKEN_CONTROLE_DISP", "TOKEN_CONTROLE_DO",
  "TOKEN_CONTROLE_END", "TOKEN_CONTROLE_IF", "TOKEN_CONTROLE_THEN",
  "TOKEN_CONTROLE_ELIF", "TOKEN_CONTROLE_ELSE", "TOKEN_CONTROLE_FOR",
  "TOKEN_CONTROLE_FROM", "TOKEN_CONTROLE_TO", "TOKEN_CONTROLE_BY",
  "TOKEN_CONTROLE_WHILE", "TOKEN_CONTROLE_UNTIL", "TOKEN_CONTROLE_NEXT",
  "TOKEN_CONTROLE_EXIT", "TOKEN_CONTROLE_RETURN", "TOKEN_CONTROLE_ERROR",
  "TOKEN_CONTROLE_DRAW", "TOKEN_CONTROLE_CONV", "TOKEN_CONTROLE_DPT",
  "TOKEN_CONTROLE_IDPT", "TOKEN_CONTROLE_WITH", "TOKEN_CONTROLE_READ",
  "TOKEN_CONTROLE_WRITE", "TOKEN_CONTROLE_TRY", "TOKEN_CONTROLE_CATCH",
  "TOKEN_CORPS_DEBUT", "TOKEN_CORPS_FIN", "TOKEN_IDENTIFIANT", "$accept",
  "entree", "bloc", "instruction", "expression", "fonction",
  "fonction_ou_expression", "image_mode", "image_couleur_fond",
  "liste_parametres", "liste_expression", "nom_type", "options_ligne",
  "liste_options_ligne", "option_ligne", "options_surface",
  "liste_options_surface", "option_surface", "controle_draw",
  "controle_draw_at", "draw_at_by", "controle_conv", "controle_with",
  "controle_let", "prototype", "type", "liste_definition_parametres",
  "liste_definition", "instruction_ou_expression",
  "instruction_ou_expression_ou_fonction", "controle_return",
  "controle_disp", "controle_do", "controle_if", "clause_then",
  "clauses_elif", "clause_else", "controle_for", "clause_by",
  "controle_while", "controle_until", "controle_next", "controle_exit",
  "controle_error", "controle_try", "clauses_catch", "clause_catch",
  "liste_erreurs", "catch_total", "couleur_constante", "controle_read",
  "controle_write", "controle_dpt", "controle_idpt", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   158,   159,   160,   160,   161,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   163,   163,   163,   164,   164,   165,
     165,   165,   165,   165,   166,   166,   167,   167,   168,   168,
     169,   169,   169,   169,   169,   169,   169,   169,   169,   169,
     169,   169,   169,   169,   169,   169,   169,   169,   169,   169,
     170,   170,   171,   171,   172,   172,   172,   172,   172,   172,
     172,   172,   173,   173,   174,   174,   175,   175,   175,   175,
     175,   175,   175,   175,   176,   177,   178,   178,   179,   180,
     180,   181,   181,   181,   182,   183,   183,   184,   184,   185,
     185,   186,   186,   187,   187,   187,   188,   188,   188,   189,
     189,   190,   191,   192,   193,   193,   194,   194,   195,   196,
     196,   197,   198,   199,   199,   200,   200,   201,   202,   203,
     203,   203,   204,   205,   205,   206,   207,   207,   207,   207,
     207,   207,   207,   207,   207,   207,   207,   208,   209,   210,
     211
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     4,     4,     1,     6,     6,     6,     6,     4,     4,
       4,     1,     1,     1,     3,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     3,     2,     2,     3,     3,     3,
       3,     3,     3,     2,     2,     3,     3,     3,     3,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     7,
       7,     9,     7,     9,     9,     5,     4,     4,     1,    10,
      10,     6,     4,     4,     4,     4,     4,     4,     4,     4,
       4,    11,    10,     1,     1,     1,     1,     1,     1,     1,
       1,     8,     6,     4,     2,     4,     5,     1,     1,     0,
       1,     1,     6,    10,     0,     1,     0,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     2,     1,     3,     1,     1,     1,     1,     1,     4,
       6,     1,     0,     2,     1,     3,     1,     1,     1,     1,
       1,     1,     4,     6,     2,     5,     0,     2,     2,     2,
       5,     4,     5,     5,     4,     1,     3,     0,     3,     1,
       3,     1,     1,     1,     1,     1,     2,     2,     1,     2,
       1,     3,     5,     3,     0,     3,     0,     2,    10,     0,
       2,     5,     5,     1,     2,     1,     2,     2,     4,     1,
       1,     2,     5,     1,     3,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     4,     1,
       1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       4,     0,     2,     1,     0,   200,     4,     0,     0,     0,
     213,   215,   198,     0,     0,     0,   239,   240,     0,     0,
       0,     4,     3,     5,     6,     7,    11,    10,    22,    14,
      15,    16,    17,    18,    19,    20,    21,    23,    24,    12,
      13,     8,     9,   130,   131,   132,   133,   134,   135,   138,
     136,   137,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,     0,     0,     0,   185,     0,   187,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    25,    26,    33,    27,    28,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   103,   104,   105,   106,   107,   108,   109,   110,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
       0,   226,    41,    42,    43,   199,   126,    88,     0,     0,
     204,     0,     0,   214,   216,     0,   196,   197,   217,   174,
     178,   179,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    69,    64,    63,    56,    55,    53,    52,    51,    50,
      49,    48,    47,    46,    45,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    30,    29,     0,     0,   201,     0,     4,   206,
       0,     4,     0,   114,     0,     4,   237,     0,     4,     0,
     220,   219,   186,     0,     0,   191,   192,   181,   189,     0,
     187,    44,    54,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   162,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    72,
      71,    70,    78,    76,    77,    75,    74,    73,    66,    65,
      68,    67,    58,    57,    61,    60,    59,    62,   118,   117,
     128,     0,   126,     0,   203,     0,     4,     0,     0,     0,
       0,     0,   176,     0,   238,     0,   225,   218,   221,   182,
     193,   194,   195,   183,   188,     0,   184,    31,    32,     0,
       0,    38,     0,    39,     0,    40,     0,     0,     0,     0,
       0,     0,     0,    86,    87,     0,    92,     0,    93,    98,
      99,   100,    97,     0,     0,    94,    95,    96,     0,   127,
       0,   113,   212,   205,   207,   202,     0,   211,     0,   115,
       0,   175,   180,   223,     0,   190,     0,     0,     0,     0,
     150,     0,   162,   162,     0,   166,   167,   168,   169,   170,
     171,     0,   163,   164,    85,     0,     0,     0,     0,     0,
       0,   129,   209,   116,   177,     4,     0,    34,    35,    36,
      37,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    91,     0,   119,   119,     0,   112,     0,     0,   222,
     224,   161,   156,   157,   154,   155,   158,     0,   151,   152,
      79,   162,   166,   167,   168,   162,    82,    80,   162,     0,
     165,     0,     0,   120,   121,     0,   124,     0,     0,   210,
       4,     0,     0,     0,     0,     0,     0,   172,     0,     0,
       0,   125,     0,     4,   111,     0,     0,   153,    81,    83,
      84,     0,     0,     0,     0,     4,     0,   208,     0,   159,
     173,    89,    90,     0,     0,   102,     0,     0,   101,   160,
       0,   122,     0,     0,     0,   123
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,    22,   246,   299,   300,   456,   472,   225,
     301,    66,   412,   438,   439,   342,   392,   393,    23,    24,
     371,    25,    26,    27,    67,   136,   160,   249,   247,   323,
      28,    29,    30,    31,   140,   229,   307,    32,   428,    33,
      34,    35,    36,    37,    38,   239,   240,   374,   241,   137,
      39,    40,    41,    42
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -328
static const yytype_int16 yypact[] =
{
    -328,    45,  3536,  -328,   332,  1288,  -328,  1288,  3665,  1288,
     -27,     5,  1062,  -109,  1288,  1288,  -328,  -328,  1288,   -87,
    1288,  -328,  -328,  -328,  -328,  -328,  -328,  -328,  -328,  -328,
    -328,  -328,  -328,  -328,  -328,  -328,  -328,  -328,  -328,  -328,
    -328,  -328,  -328,  -328,  -328,  -328,  -328,  -328,  -328,  -328,
    -328,  -328,  -328,  -328,  -328,  -328,  -328,  -328,  -328,  -328,
    -328,  -328,  -328,  3665,  3665,  3665,  -328,   -76,    18,  1288,
    1288,  1288,  1288,  1288,  1288,  1288,  1288,  1288,  1288,  1288,
    1288,  1288,  1288,  1288,  1288,  -328,  -328,  -328,  -328,  -328,
      -9,    15,    20,    22,    24,    30,    51,    52,    54,    55,
      56,    57,    58,    60,    61,    74,    75,    83,    85,    86,
      89,    90,  -328,  -328,  -328,  -328,  -328,  -328,  -328,  -328,
    -328,  -328,  -328,    91,    94,    95,  -328,  -328,  -328,  -328,
      97,  -328,  -328,  -328,  -328,  3393,    27,  -328,  3449,   928,
    -328,   -50,  1002,  -328,  -328,  1365,  3393,  -328,  -328,  1039,
    3393,    14,  1288,   276,  3419,    96,    33,    43,   740,  3665,
      63,  3461,    47,    47,    47,    47,    47,    47,    47,    47,
      47,    47,    47,    47,    47,  3356,  3318,  1288,  1288,  1288,
    1288,  1288,  1288,  1288,  1288,  1288,  1288,  1288,  1288,  1288,
    1288,  1288,  1288,  1288,  1288,  1288,  1288,  1288,  1288,  1288,
    1288,  1288,  1288,  1288,  1288,  1288,  1288,  1288,  1288,  1288,
    1288,  1288,  1288,  1288,  1288,  1288,  1288,  1288,  1288,  1288,
    1288,  1288,  -328,  -328,  1062,    66,  -328,  1288,  -328,  -123,
    1288,  -328,  3665,   101,  1288,  -328,  3393,  1288,   135,    93,
      82,  -328,  -328,  3536,   592,  -328,  3393,  -328,  -328,   -31,
      18,  -328,  -328,  1764,  1801,  2615,  1431,  1468,  1505,  2652,
    2689,  2726,  2763,  2800,  2837,  1838,  1875,  1542,  1579,  1912,
    1949,  1986,  2023,  2874,  2911,  2060,  2097,  2134,  2948,  3428,
    3428,  3461,    23,    23,    23,    23,    23,    23,   117,   117,
    3673,  3673,   129,   129,    47,    47,    47,    47,  3393,  -328,
    -328,    10,    27,   965,  3536,  1288,  -328,   107,   891,  3478,
     140,   740,    92,   294,  3393,    87,  3536,  -328,  -328,  -328,
    -328,  3393,  -328,  -328,  -328,  3665,  -328,  -328,  -328,   173,
    1288,  -328,  1288,  -328,  1288,  -328,  1288,  1288,  1288,  1288,
    1288,   178,   198,  -328,  -328,  1288,  -328,  1288,  -328,  -328,
    -328,  -328,  -328,  1288,  1288,  -328,  -328,  -328,   479,  -328,
    1062,  -328,  -328,  -328,  3536,  -328,  1288,  -328,   740,  -328,
    1288,  -328,  -328,  -328,    44,  -328,   199,  2171,  2208,  2245,
    2985,  3022,  3059,  2837,  3096,  -328,  -328,  -328,  -328,  -328,
    -328,   202,   224,  -328,  -328,  1616,  3133,  2282,  2319,   203,
    2356,  -328,   238,  -328,  3393,  -328,   118,  -328,  -328,  -328,
    -328,   234,   204,  1288,  1175,   208,   212,  1288,  1288,   178,
    1288,  -328,  1288,    19,    19,  1288,  -328,  1288,   168,  3536,
    -328,  -328,  -328,  -328,  -328,  -328,  -328,   231,   254,  -328,
    -328,  2837,    57,    58,    60,  2837,  -328,  -328,  2837,  1653,
    -328,  3170,  3207,  -328,  -328,   235,  1288,   147,  2393,  3393,
    -328,  1288,   234,   236,   237,   239,  1288,  -328,  1288,  1288,
    1288,  3393,   149,  -328,  -328,  3507,  1690,  -328,  -328,  -328,
    -328,  2430,  2467,  2504,  3244,  -328,  3361,  -328,  1288,  -328,
    -328,  -328,  -328,  1288,  3390,  -328,  2541,  1727,  -328,  -328,
    1288,  -328,  3281,  1288,  2578,  -328
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -328,  -328,    -1,  -150,    -5,   -11,   -48,  -114,  -328,    21,
    -328,  -328,  -328,  -328,  -138,  -327,  -328,   -93,  -328,  -328,
    -328,  -328,  -328,  -328,    81,    76,    78,  -328,  -308,  -328,
    -328,  -328,  -328,  -328,    25,  -328,  -328,  -328,  -328,  -328,
    -328,  -328,  -328,  -328,  -328,    98,  -328,  -328,  -328,  -328,
    -328,  -328,  -328,  -328
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint16 yytable[] =
{
     135,   147,   139,   369,   142,   138,   324,   146,   245,   149,
     150,   305,   306,   151,   143,   153,   325,   203,   204,   205,
     154,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   212,   213,   214,   215,
     216,   217,   218,   219,   220,     3,   144,   359,   148,   221,
     152,   158,   222,   223,   159,   415,   416,   360,   221,   177,
     403,   222,   223,   224,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
      68,   405,   221,   178,    68,   222,   223,   230,   179,   141,
     180,   406,   181,   319,   320,   203,   204,   205,   182,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   463,   453,   454,   455,   464,   183,
     184,   465,   185,   186,   187,   188,   189,   221,   190,   191,
     222,   223,   214,   215,   216,   217,   218,   219,   220,    68,
      68,    68,   192,   193,   155,   156,   157,   236,   218,   219,
     220,   194,   221,   195,   196,   222,   223,   197,   198,   199,
     243,   245,   200,   201,   221,   202,   242,   222,   223,   235,
     244,   315,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   376,   245,   298,
     250,    68,   303,   302,   317,   308,   233,   304,   311,   312,
     309,   370,   314,   322,   313,    68,   238,   316,   365,   321,
     248,   203,   204,   205,   373,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     385,   386,   387,   388,   389,   390,   391,   368,   394,   407,
     418,   419,   425,   221,   440,   430,   222,   223,   446,   203,
     204,   205,   447,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   460,   461,
     139,   462,   473,   470,   485,   364,   478,   479,    68,   480,
     457,   221,   401,   310,   222,   223,   431,   432,   433,   434,
     435,   436,   437,   361,   477,   377,   450,   378,   326,   379,
     363,   380,   381,   382,   383,   384,     0,     0,   318,     0,
     395,     0,   396,     0,     0,     0,     0,     0,   397,   398,
       0,     0,     0,   400,     0,   298,     0,     0,     0,     0,
       0,   402,     0,     0,     0,   404,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   427,     0,     0,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    68,     0,     0,   429,     0,   375,     0,   441,   445,
       0,     0,   448,   449,   237,   451,     0,   452,     0,     4,
     458,     0,   459,     5,     6,     0,     7,     0,     0,     0,
       8,     0,     0,     0,     9,     0,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,     0,     0,
     372,   471,     0,     0,     0,     0,   476,     0,    64,   475,
      65,   481,     0,   482,   483,   484,     0,     0,     0,     0,
       0,     0,   486,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   496,   494,    69,     0,     0,   497,     0,
       0,     0,     0,     0,     0,   502,    70,    71,   504,     0,
       0,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,     0,     0,     0,    83,     0,     0,     0,    84,
      85,    86,    87,     0,    88,    89,     0,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,     0,     0,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,     0,     0,     0,   111,   112,
     113,   114,   115,   116,   117,   118,   119,     0,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,    69,   130,
     131,   132,   133,   134,     0,     0,     0,     0,     0,    70,
      71,     0,     0,     0,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,     0,     0,     0,    83,     0,
       0,     0,    84,    85,    86,    87,   399,    88,    89,     0,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,     0,     0,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,     0,     0,
       0,   111,   112,   113,   114,   115,   116,   117,   118,   119,
       0,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,     0,   130,   131,   132,   133,   134,     4,     0,     0,
     145,     5,     6,     0,     7,     0,     0,     0,     8,     0,
       0,     0,     9,     0,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    69,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    70,    71,     0,
       0,     0,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,     0,     0,     0,    83,     0,     0,     0,
      84,    85,    86,    87,     0,    88,    89,     0,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,     0,
       0,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,     0,     0,     0,   111,
     112,   113,   114,   115,   116,   117,   118,   119,     0,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,     0,
     130,   131,   132,   133,   134,     4,     0,     0,     0,     5,
       6,     0,     7,     0,     0,     0,     8,     0,     0,     0,
       9,     0,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,   203,   204,   205,     0,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   221,     0,     0,   222,
     223,   203,   204,   205,     0,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   221,     0,     0,   222,   223,   203,   204,
     205,     0,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     221,     0,     0,   222,   223,   203,   204,   205,     0,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,     0,     0,     0,     0,     0,   366,
       0,     0,     0,     0,     0,     0,     0,   221,     0,     0,
     222,   223,   203,   204,   205,     0,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   228,     0,     0,     0,     0,     0,     0,    69,     0,
       0,     0,     0,     0,   221,     0,     0,   222,   223,    70,
      71,     0,     0,     0,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,     0,   362,     0,    83,     0,
       0,     0,    84,    85,    86,    87,     0,    88,    89,     0,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,     0,   231,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   234,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,     0,     0,
       0,   111,   112,   113,   114,   115,   116,   117,   118,   119,
       0,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,    69,   130,   131,   132,   133,   134,     0,     0,     0,
     145,     0,    70,    71,     0,     0,     0,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,     0,     0,
       0,    83,     0,     0,     0,    84,    85,    86,    87,     0,
      88,    89,     0,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,     0,     0,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   442,   443,   444,
     388,   389,   390,   391,   104,   105,   106,   107,   108,   109,
     110,     0,     0,     0,   111,   112,   113,   114,   115,   116,
     117,   118,   119,     0,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,    69,   130,   131,   132,   133,   134,
       0,     0,     0,     0,     0,    70,    71,     0,     0,     0,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,     0,     0,     0,    83,     0,     0,     0,    84,    85,
      86,    87,     0,    88,    89,     0,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,     0,     0,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,     0,     0,     0,   111,   112,   113,
     114,   115,   116,   117,   118,   119,     0,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,     0,   130,   131,
     132,   133,   134,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,   203,   204,   205,     0,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   221,     0,     0,   222,
     223,   203,   204,   205,     0,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
       0,   232,     0,     0,     0,     0,     0,     0,     0,     0,
     330,   331,     0,   221,     0,     0,   222,   223,   203,   204,
     205,     0,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   332,   333,     0,
     221,     0,     0,   222,   223,   203,   204,   205,     0,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   334,   335,     0,   221,     0,     0,
     222,   223,   203,   204,   205,     0,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   345,   346,     0,   221,     0,     0,   222,   223,   203,
     204,   205,     0,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   347,   348,
       0,   221,     0,     0,   222,   223,   203,   204,   205,     0,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   420,   421,     0,   221,     0,
       0,   222,   223,   203,   204,   205,     0,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,     0,   221,     0,     0,   222,   223,
     203,   204,   205,     0,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   488,
     489,     0,   221,     0,     0,   222,   223,   203,   204,   205,
       0,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   500,   501,     0,   221,
       0,     0,   222,   223,   203,   204,   205,     0,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   327,     0,   221,     0,     0,   222,
     223,   203,   204,   205,     0,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   328,     0,   221,     0,     0,   222,   223,   203,   204,
     205,     0,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   343,     0,
     221,     0,     0,   222,   223,   203,   204,   205,     0,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   344,     0,   221,     0,     0,
     222,   223,   203,   204,   205,     0,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   349,     0,   221,     0,     0,   222,   223,   203,
     204,   205,     0,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   350,
       0,   221,     0,     0,   222,   223,   203,   204,   205,     0,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   351,     0,   221,     0,
       0,   222,   223,   203,   204,   205,     0,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   352,     0,   221,     0,     0,   222,   223,
     203,   204,   205,     0,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     355,     0,   221,     0,     0,   222,   223,   203,   204,   205,
       0,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   356,     0,   221,
       0,     0,   222,   223,   203,   204,   205,     0,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   357,     0,   221,     0,     0,   222,
     223,   203,   204,   205,     0,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   408,     0,   221,     0,     0,   222,   223,   203,   204,
     205,     0,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   409,     0,
     221,     0,     0,   222,   223,   203,   204,   205,     0,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   410,     0,   221,     0,     0,
     222,   223,   203,   204,   205,     0,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   423,     0,   221,     0,     0,   222,   223,   203,
     204,   205,     0,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   424,
       0,   221,     0,     0,   222,   223,   203,   204,   205,     0,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   426,     0,   221,     0,
       0,   222,   223,   203,   204,   205,     0,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   474,     0,   221,     0,     0,   222,   223,
     203,   204,   205,     0,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     490,     0,   221,     0,     0,   222,   223,   203,   204,   205,
       0,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   491,     0,   221,
       0,     0,   222,   223,   203,   204,   205,     0,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   492,     0,   221,     0,     0,   222,
     223,   203,   204,   205,     0,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   499,     0,   221,     0,     0,   222,   223,   203,   204,
     205,     0,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   505,     0,
     221,     0,     0,   222,   223,   203,   204,   205,     0,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   329,     0,     0,   221,     0,     0,
     222,   223,   203,   204,   205,     0,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   336,     0,     0,   221,     0,     0,   222,   223,   203,
     204,   205,     0,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   337,     0,
       0,   221,     0,     0,   222,   223,   203,   204,   205,     0,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   338,     0,     0,   221,     0,
       0,   222,   223,   203,   204,   205,     0,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   339,     0,     0,   221,     0,     0,   222,   223,
     203,   204,   205,     0,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   340,
       0,     0,   221,     0,     0,   222,   223,   203,   204,   205,
       0,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   341,     0,     0,   221,
       0,     0,   222,   223,   203,   204,   205,     0,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   353,     0,     0,   221,     0,     0,   222,
     223,   203,   204,   205,     0,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     354,     0,     0,   221,     0,     0,   222,   223,   203,   204,
     205,     0,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   358,     0,     0,
     221,     0,     0,   222,   223,   203,   204,   205,     0,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   411,     0,     0,   221,     0,     0,
     222,   223,   203,   204,   205,     0,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   413,     0,     0,   221,     0,     0,   222,   223,   203,
     204,   205,     0,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   414,     0,
       0,   221,     0,     0,   222,   223,   203,   204,   205,     0,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   417,     0,     0,   221,     0,
       0,   222,   223,   203,   204,   205,     0,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   422,     0,     0,   221,     0,     0,   222,   223,
     203,   204,   205,     0,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   468,
       0,     0,   221,     0,     0,   222,   223,   203,   204,   205,
       0,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   469,     0,     0,   221,
       0,     0,   222,   223,   203,   204,   205,     0,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   493,     0,     0,   221,     0,     0,   222,
     223,   203,   204,   205,     0,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     503,     0,     0,   221,     0,     0,   222,   223,   252,   203,
     204,   205,     0,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   221,     0,   251,   222,   223,   203,   204,   205,     0,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   221,     0,
       0,   222,   223,   205,     0,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   221,     0,     0,   222,   223,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,     0,     0,     0,     4,     0,     0,     0,
       5,     6,     0,     7,     0,     0,   221,     8,     0,   222,
     223,     9,     0,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,     4,     0,   495,     0,     5,
       6,     0,     7,     0,     0,     0,     8,     0,     0,     0,
       9,     0,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,     4,     0,   498,     0,     5,     6,
       0,     7,     0,     0,     0,     8,     0,     0,     0,     9,
       0,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,   238,     4,     0,     0,     0,     5,     6,
     226,     7,     0,     0,     0,     8,     0,     0,     0,     9,
     227,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,     4,     0,     0,     0,     5,     6,   367,
       7,     0,     0,     0,     8,     0,     0,     0,     9,     0,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,     4,     0,     0,     0,     5,     6,   487,     7,
       0,     0,     0,     8,     0,     0,     0,     9,     0,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,     4,     0,     0,     0,     5,     6,     0,     7,     0,
       0,     0,     8,     0,     0,     0,     9,     0,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
     216,   217,   218,   219,   220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   221,     0,
       0,   222,   223,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63
};

static const yytype_int16 yycheck[] =
{
       5,    12,     7,   311,     9,     6,    37,    12,   158,    14,
      15,   134,   135,    18,    41,    20,    47,     3,     4,     5,
      21,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    13,    14,    15,    16,
      17,    18,    19,    20,    21,     0,    41,    37,   157,    35,
     137,   127,    38,    39,    36,   382,   383,    47,    35,    68,
     368,    38,    39,    36,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
       4,    37,    35,    68,     8,    38,    39,   137,    68,     8,
      68,    47,    68,   243,   244,     3,     4,     5,    68,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,   441,    96,    97,    98,   445,    68,
      68,   448,    68,    68,    68,    68,    68,    35,    68,    68,
      38,    39,    15,    16,    17,    18,    19,    20,    21,    63,
      64,    65,    68,    68,    63,    64,    65,   152,    19,    20,
      21,    68,    35,    68,    68,    38,    39,    68,    68,    68,
     127,   311,    68,    68,    35,    68,    70,    38,    39,   155,
     127,    36,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,    44,   368,   224,
     157,   145,   227,   157,   131,   230,   145,   228,   127,   234,
     231,   139,   237,   244,   235,   159,   154,   238,   131,   244,
     159,     3,     4,     5,   157,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      82,    83,    84,    85,    86,    87,    88,   127,    70,    70,
      68,    47,    69,    35,    70,   157,    38,    39,    70,     3,
       4,     5,    70,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,   130,    68,
     305,    47,   155,    68,   155,   306,    70,    70,   232,    70,
     424,    35,   360,   232,    38,    39,    82,    83,    84,    85,
      86,    87,    88,   302,   462,   330,   419,   332,   250,   334,
     305,   336,   337,   338,   339,   340,    -1,    -1,   240,    -1,
     345,    -1,   347,    -1,    -1,    -1,    -1,    -1,   353,   354,
      -1,    -1,    -1,   358,    -1,   360,    -1,    -1,    -1,    -1,
      -1,   366,    -1,    -1,    -1,   370,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,   325,    -1,    -1,   405,    -1,   325,    -1,   413,   414,
      -1,    -1,   417,   418,   138,   420,    -1,   422,    -1,   125,
     425,    -1,   427,   129,   130,    -1,   132,    -1,    -1,    -1,
     136,    -1,    -1,    -1,   140,    -1,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,    -1,
     156,   456,    -1,    -1,    -1,    -1,   461,    -1,   126,   460,
     128,   466,    -1,   468,   469,   470,    -1,    -1,    -1,    -1,
      -1,    -1,   473,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   488,   485,     6,    -1,    -1,   493,    -1,
      -1,    -1,    -1,    -1,    -1,   500,    17,    18,   503,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    36,    -1,    -1,    -1,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    -1,    -1,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    -1,    -1,    -1,    -1,    89,    90,
      91,    92,    93,    94,    95,    -1,    -1,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,     6,   120,
     121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,    17,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    36,    -1,
      -1,    -1,    40,    41,    42,    43,   157,    45,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    -1,    -1,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    -1,    -1,    -1,
      -1,    89,    90,    91,    92,    93,    94,    95,    -1,    -1,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,    -1,    -1,
     128,   129,   130,    -1,   132,    -1,    -1,    -1,   136,    -1,
      -1,    -1,   140,    -1,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    -1,
      -1,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    -1,    -1,    -1,    -1,    89,
      90,    91,    92,    93,    94,    95,    -1,    -1,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,   121,   122,   123,   124,   125,    -1,    -1,    -1,   129,
     130,    -1,   132,    -1,    -1,    -1,   136,    -1,    -1,    -1,
     140,    -1,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,     3,     4,     5,    -1,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    38,
      39,     3,     4,     5,    -1,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    35,    -1,    -1,    38,    39,     3,     4,
       5,    -1,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    -1,    -1,    38,    39,     3,     4,     5,    -1,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,   138,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,
      38,    39,     3,     4,     5,    -1,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,   133,    -1,    -1,    -1,    -1,    -1,    -1,     6,    -1,
      -1,    -1,    -1,    -1,    35,    -1,    -1,    38,    39,    17,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,   131,    -1,    36,    -1,
      -1,    -1,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    -1,   130,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,   108,    -1,    -1,
      -1,    89,    90,    91,    92,    93,    94,    95,    -1,    -1,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,     6,   120,   121,   122,   123,   124,    -1,    -1,    -1,
     128,    -1,    17,    18,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    -1,    -1,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    -1,    -1,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,     6,   120,   121,   122,   123,   124,
      -1,    -1,    -1,    -1,    -1,    17,    18,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    36,    -1,    -1,    -1,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    -1,    -1,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    -1,    -1,    -1,    -1,    89,    90,    91,
      92,    93,    94,    95,    -1,    -1,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,   121,
     122,   123,   124,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,     3,     4,     5,    -1,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    38,
      39,     3,     4,     5,    -1,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      69,    70,    -1,    35,    -1,    -1,    38,    39,     3,     4,
       5,    -1,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    70,    -1,
      35,    -1,    -1,    38,    39,     3,     4,     5,    -1,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    70,    -1,    35,    -1,    -1,
      38,    39,     3,     4,     5,    -1,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    69,    70,    -1,    35,    -1,    -1,    38,    39,     3,
       4,     5,    -1,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    70,
      -1,    35,    -1,    -1,    38,    39,     3,     4,     5,    -1,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    70,    -1,    35,    -1,
      -1,    38,    39,     3,     4,     5,    -1,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    70,    -1,    35,    -1,    -1,    38,    39,
       3,     4,     5,    -1,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,
      70,    -1,    35,    -1,    -1,    38,    39,     3,     4,     5,
      -1,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    69,    70,    -1,    35,
      -1,    -1,    38,    39,     3,     4,     5,    -1,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    -1,    35,    -1,    -1,    38,
      39,     3,     4,     5,    -1,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    35,    -1,    -1,    38,    39,     3,     4,
       5,    -1,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      35,    -1,    -1,    38,    39,     3,     4,     5,    -1,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    -1,    35,    -1,    -1,
      38,    39,     3,     4,     5,    -1,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    35,    -1,    -1,    38,    39,     3,
       4,     5,    -1,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      -1,    35,    -1,    -1,    38,    39,     3,     4,     5,    -1,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    35,    -1,
      -1,    38,    39,     3,     4,     5,    -1,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    35,    -1,    -1,    38,    39,
       3,     4,     5,    -1,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    -1,    35,    -1,    -1,    38,    39,     3,     4,     5,
      -1,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    35,
      -1,    -1,    38,    39,     3,     4,     5,    -1,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    -1,    35,    -1,    -1,    38,
      39,     3,     4,     5,    -1,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    35,    -1,    -1,    38,    39,     3,     4,
       5,    -1,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      35,    -1,    -1,    38,    39,     3,     4,     5,    -1,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    -1,    35,    -1,    -1,
      38,    39,     3,     4,     5,    -1,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    35,    -1,    -1,    38,    39,     3,
       4,     5,    -1,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      -1,    35,    -1,    -1,    38,    39,     3,     4,     5,    -1,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    35,    -1,
      -1,    38,    39,     3,     4,     5,    -1,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    35,    -1,    -1,    38,    39,
       3,     4,     5,    -1,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    -1,    35,    -1,    -1,    38,    39,     3,     4,     5,
      -1,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    35,
      -1,    -1,    38,    39,     3,     4,     5,    -1,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    -1,    35,    -1,    -1,    38,
      39,     3,     4,     5,    -1,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    35,    -1,    -1,    38,    39,     3,     4,
       5,    -1,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      35,    -1,    -1,    38,    39,     3,     4,     5,    -1,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    -1,    -1,    35,    -1,    -1,
      38,    39,     3,     4,     5,    -1,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    69,    -1,    -1,    35,    -1,    -1,    38,    39,     3,
       4,     5,    -1,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    -1,
      -1,    35,    -1,    -1,    38,    39,     3,     4,     5,    -1,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    -1,    -1,    35,    -1,
      -1,    38,    39,     3,     4,     5,    -1,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    -1,    -1,    35,    -1,    -1,    38,    39,
       3,     4,     5,    -1,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,
      -1,    -1,    35,    -1,    -1,    38,    39,     3,     4,     5,
      -1,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    69,    -1,    -1,    35,
      -1,    -1,    38,    39,     3,     4,     5,    -1,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    69,    -1,    -1,    35,    -1,    -1,    38,
      39,     3,     4,     5,    -1,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      69,    -1,    -1,    35,    -1,    -1,    38,    39,     3,     4,
       5,    -1,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    -1,    -1,
      35,    -1,    -1,    38,    39,     3,     4,     5,    -1,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    -1,    -1,    35,    -1,    -1,
      38,    39,     3,     4,     5,    -1,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    69,    -1,    -1,    35,    -1,    -1,    38,    39,     3,
       4,     5,    -1,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    -1,
      -1,    35,    -1,    -1,    38,    39,     3,     4,     5,    -1,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    -1,    -1,    35,    -1,
      -1,    38,    39,     3,     4,     5,    -1,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    -1,    -1,    35,    -1,    -1,    38,    39,
       3,     4,     5,    -1,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,
      -1,    -1,    35,    -1,    -1,    38,    39,     3,     4,     5,
      -1,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    69,    -1,    -1,    35,
      -1,    -1,    38,    39,     3,     4,     5,    -1,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    69,    -1,    -1,    35,    -1,    -1,    38,
      39,     3,     4,     5,    -1,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      69,    -1,    -1,    35,    -1,    -1,    38,    39,    40,     3,
       4,     5,    -1,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    37,    38,    39,     3,     4,     5,    -1,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    38,    39,     5,    -1,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    35,    -1,    -1,    38,    39,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    -1,    -1,   125,    -1,    -1,    -1,
     129,   130,    -1,   132,    -1,    -1,    35,   136,    -1,    38,
      39,   140,    -1,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   125,    -1,   156,    -1,   129,
     130,    -1,   132,    -1,    -1,    -1,   136,    -1,    -1,    -1,
     140,    -1,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   125,    -1,   156,    -1,   129,   130,
      -1,   132,    -1,    -1,    -1,   136,    -1,    -1,    -1,   140,
      -1,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   125,    -1,    -1,    -1,   129,   130,
     131,   132,    -1,    -1,    -1,   136,    -1,    -1,    -1,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   125,    -1,    -1,    -1,   129,   130,   131,
     132,    -1,    -1,    -1,   136,    -1,    -1,    -1,   140,    -1,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   125,    -1,    -1,    -1,   129,   130,   131,   132,
      -1,    -1,    -1,   136,    -1,    -1,    -1,   140,    -1,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   125,    -1,    -1,    -1,   129,   130,    -1,   132,    -1,
      -1,    -1,   136,    -1,    -1,    -1,   140,    -1,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    38,    39,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   159,   160,     0,   125,   129,   130,   132,   136,   140,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   161,   176,   177,   179,   180,   181,   188,   189,
     190,   191,   195,   197,   198,   199,   200,   201,   202,   208,
     209,   210,   211,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,   126,   128,   169,   182,   183,     6,
      17,    18,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    36,    40,    41,    42,    43,    45,    46,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    89,    90,    91,    92,    93,    94,
      95,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     120,   121,   122,   123,   124,   162,   183,   207,   160,   162,
     192,   182,   162,    41,    41,   128,   162,   163,   157,   162,
     162,   162,   137,   162,   160,   182,   182,   182,   127,    36,
     184,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,    68,    68,    68,
      68,    68,    68,    68,    68,    68,    68,    68,    68,    68,
      68,    68,    68,    68,    68,    68,    68,    68,    68,    68,
      68,    68,    68,     3,     4,     5,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    35,    38,    39,    36,   167,   131,   141,   133,   193,
     137,   130,   126,   182,   108,   155,   162,   138,   154,   203,
     204,   206,    70,   127,   127,   161,   162,   186,   182,   185,
     157,    37,    40,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   163,
     164,   168,   157,   162,   160,   134,   135,   194,   162,   160,
     182,   127,   162,   160,   162,    36,   160,   131,   203,   161,
     161,   162,   163,   187,    37,    47,   184,    70,    70,    69,
      69,    70,    69,    70,    69,    70,    69,    69,    69,    69,
      69,    69,   173,    70,    70,    69,    70,    69,    70,    70,
      70,    70,    70,    69,    69,    70,    70,    70,    69,    37,
      47,   167,   131,   192,   160,   131,   138,   131,   127,   186,
     139,   178,   156,   157,   205,   182,    44,   162,   162,   162,
     162,   162,   162,   162,   162,    82,    83,    84,    85,    86,
      87,    88,   174,   175,    70,   162,   162,   162,   162,   157,
     162,   164,   162,   186,   162,    37,    47,    70,    70,    70,
      70,    69,   170,    69,    69,   173,   173,    69,    68,    47,
      69,    70,    69,    70,    70,    69,    70,   139,   196,   160,
     157,    82,    83,    84,    85,    86,    87,    88,   171,   172,
      70,   162,    82,    83,    84,   162,    70,    70,   162,   162,
     175,   162,   162,    96,    97,    98,   165,   165,   162,   162,
     130,    68,    47,   173,   173,   173,    69,    70,    69,    69,
      68,   162,   166,   155,    70,   160,   162,   172,    70,    70,
      70,   162,   162,   162,   162,   155,   160,   131,    69,    70,
      70,    70,    70,    69,   160,   156,   162,   162,   156,    70,
      69,    70,   162,    69,   162,    70
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (bloc_principal, cache_objets, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, bloc_principal, cache_objets); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Traceur::Donnees::Instruction::BlocSP& bloc_principal, Traceur::Donnees::Global::CacheObjetGenerique& cache_objets)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, bloc_principal, cache_objets)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    Traceur::Donnees::Instruction::BlocSP& bloc_principal;
    Traceur::Donnees::Global::CacheObjetGenerique& cache_objets;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (bloc_principal);
  YYUSE (cache_objets);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Traceur::Donnees::Instruction::BlocSP& bloc_principal, Traceur::Donnees::Global::CacheObjetGenerique& cache_objets)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, bloc_principal, cache_objets)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    Traceur::Donnees::Instruction::BlocSP& bloc_principal;
    Traceur::Donnees::Global::CacheObjetGenerique& cache_objets;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, bloc_principal, cache_objets);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, Traceur::Donnees::Instruction::BlocSP& bloc_principal, Traceur::Donnees::Global::CacheObjetGenerique& cache_objets)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, bloc_principal, cache_objets)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    Traceur::Donnees::Instruction::BlocSP& bloc_principal;
    Traceur::Donnees::Global::CacheObjetGenerique& cache_objets;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , bloc_principal, cache_objets);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, bloc_principal, cache_objets); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, Traceur::Donnees::Instruction::BlocSP& bloc_principal, Traceur::Donnees::Global::CacheObjetGenerique& cache_objets)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, bloc_principal, cache_objets)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    Traceur::Donnees::Instruction::BlocSP& bloc_principal;
    Traceur::Donnees::Global::CacheObjetGenerique& cache_objets;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (bloc_principal);
  YYUSE (cache_objets);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {
      case 41: /* "TOKEN_NOMBRE_ENTIER" */

/* Line 1009 of yacc.c  */
#line 115 "analyseur.syn.ypp"
	{ };

/* Line 1009 of yacc.c  */
#line 2498 "analyseur.syn.cpp"
	break;
      case 42: /* "TOKEN_NOMBRE_REEL" */

/* Line 1009 of yacc.c  */
#line 116 "analyseur.syn.ypp"
	{ };

/* Line 1009 of yacc.c  */
#line 2507 "analyseur.syn.cpp"
	break;
      case 43: /* "TOKEN_CHAINE" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Chaine); };

/* Line 1009 of yacc.c  */
#line 2516 "analyseur.syn.cpp"
	break;
      case 44: /* "TOKEN_FORMAT" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Chaine); };

/* Line 1009 of yacc.c  */
#line 2525 "analyseur.syn.cpp"
	break;
      case 121: /* "TOKEN_COULEUR_HEXA" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Chaine); };

/* Line 1009 of yacc.c  */
#line 2534 "analyseur.syn.cpp"
	break;
      case 157: /* "TOKEN_IDENTIFIANT" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Chaine); };

/* Line 1009 of yacc.c  */
#line 2543 "analyseur.syn.cpp"
	break;
      case 160: /* "bloc" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Bloc); };

/* Line 1009 of yacc.c  */
#line 2552 "analyseur.syn.cpp"
	break;
      case 161: /* "instruction" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Instruction); };

/* Line 1009 of yacc.c  */
#line 2561 "analyseur.syn.cpp"
	break;
      case 162: /* "expression" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Expression); };

/* Line 1009 of yacc.c  */
#line 2570 "analyseur.syn.cpp"
	break;
      case 163: /* "fonction" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->FonctionImaginaire); };

/* Line 1009 of yacc.c  */
#line 2579 "analyseur.syn.cpp"
	break;
      case 164: /* "fonction_ou_expression" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Expression); };

/* Line 1009 of yacc.c  */
#line 2588 "analyseur.syn.cpp"
	break;
      case 165: /* "image_mode" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->SystemeCoordonnees); };

/* Line 1009 of yacc.c  */
#line 2597 "analyseur.syn.cpp"
	break;
      case 166: /* "image_couleur_fond" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Expression); };

/* Line 1009 of yacc.c  */
#line 2606 "analyseur.syn.cpp"
	break;
      case 167: /* "liste_parametres" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->AppelFonctionListeParametres); };

/* Line 1009 of yacc.c  */
#line 2615 "analyseur.syn.cpp"
	break;
      case 168: /* "liste_expression" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->AppelFonctionListeParametres); };

/* Line 1009 of yacc.c  */
#line 2624 "analyseur.syn.cpp"
	break;
      case 169: /* "nom_type" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Type); };

/* Line 1009 of yacc.c  */
#line 2633 "analyseur.syn.cpp"
	break;
      case 170: /* "options_ligne" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->OptionsLigne); };

/* Line 1009 of yacc.c  */
#line 2642 "analyseur.syn.cpp"
	break;
      case 171: /* "liste_options_ligne" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->OptionsLigne); };

/* Line 1009 of yacc.c  */
#line 2651 "analyseur.syn.cpp"
	break;
      case 172: /* "option_ligne" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->OptionLigneSimple); };

/* Line 1009 of yacc.c  */
#line 2660 "analyseur.syn.cpp"
	break;
      case 173: /* "options_surface" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->OptionsSurface); };

/* Line 1009 of yacc.c  */
#line 2669 "analyseur.syn.cpp"
	break;
      case 174: /* "liste_options_surface" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->OptionsSurface); };

/* Line 1009 of yacc.c  */
#line 2678 "analyseur.syn.cpp"
	break;
      case 175: /* "option_surface" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->OptionSurfaceSimple); };

/* Line 1009 of yacc.c  */
#line 2687 "analyseur.syn.cpp"
	break;
      case 176: /* "controle_draw" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_Draw); };

/* Line 1009 of yacc.c  */
#line 2696 "analyseur.syn.cpp"
	break;
      case 177: /* "controle_draw_at" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_DrawAt); };

/* Line 1009 of yacc.c  */
#line 2705 "analyseur.syn.cpp"
	break;
      case 178: /* "draw_at_by" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Expression); };

/* Line 1009 of yacc.c  */
#line 2714 "analyseur.syn.cpp"
	break;
      case 179: /* "controle_conv" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_Conv); };

/* Line 1009 of yacc.c  */
#line 2723 "analyseur.syn.cpp"
	break;
      case 180: /* "controle_with" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_With); };

/* Line 1009 of yacc.c  */
#line 2732 "analyseur.syn.cpp"
	break;
      case 181: /* "controle_let" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_Let); };

/* Line 1009 of yacc.c  */
#line 2741 "analyseur.syn.cpp"
	break;
      case 182: /* "prototype" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Prototype); };

/* Line 1009 of yacc.c  */
#line 2750 "analyseur.syn.cpp"
	break;
      case 183: /* "type" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Type); };

/* Line 1009 of yacc.c  */
#line 2759 "analyseur.syn.cpp"
	break;
      case 184: /* "liste_definition_parametres" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->PrototypeListeParametres); };

/* Line 1009 of yacc.c  */
#line 2768 "analyseur.syn.cpp"
	break;
      case 185: /* "liste_definition" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->PrototypeListeParametres); };

/* Line 1009 of yacc.c  */
#line 2777 "analyseur.syn.cpp"
	break;
      case 186: /* "instruction_ou_expression" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Instruction); };

/* Line 1009 of yacc.c  */
#line 2786 "analyseur.syn.cpp"
	break;
      case 187: /* "instruction_ou_expression_ou_fonction" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Instruction); };

/* Line 1009 of yacc.c  */
#line 2795 "analyseur.syn.cpp"
	break;
      case 188: /* "controle_return" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_Return); };

/* Line 1009 of yacc.c  */
#line 2804 "analyseur.syn.cpp"
	break;
      case 189: /* "controle_disp" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_Disp); };

/* Line 1009 of yacc.c  */
#line 2813 "analyseur.syn.cpp"
	break;
      case 190: /* "controle_do" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_Do); };

/* Line 1009 of yacc.c  */
#line 2822 "analyseur.syn.cpp"
	break;
      case 191: /* "controle_if" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_If); };

/* Line 1009 of yacc.c  */
#line 2831 "analyseur.syn.cpp"
	break;
      case 192: /* "clause_then" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Clause_Vraie); };

/* Line 1009 of yacc.c  */
#line 2840 "analyseur.syn.cpp"
	break;
      case 193: /* "clauses_elif" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Clauses_Vraies); };

/* Line 1009 of yacc.c  */
#line 2849 "analyseur.syn.cpp"
	break;
      case 194: /* "clause_else" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Bloc); };

/* Line 1009 of yacc.c  */
#line 2858 "analyseur.syn.cpp"
	break;
      case 195: /* "controle_for" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_For); };

/* Line 1009 of yacc.c  */
#line 2867 "analyseur.syn.cpp"
	break;
      case 196: /* "clause_by" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Expression); };

/* Line 1009 of yacc.c  */
#line 2876 "analyseur.syn.cpp"
	break;
      case 197: /* "controle_while" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_While); };

/* Line 1009 of yacc.c  */
#line 2885 "analyseur.syn.cpp"
	break;
      case 198: /* "controle_until" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_Until); };

/* Line 1009 of yacc.c  */
#line 2894 "analyseur.syn.cpp"
	break;
      case 199: /* "controle_next" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_Next); };

/* Line 1009 of yacc.c  */
#line 2903 "analyseur.syn.cpp"
	break;
      case 200: /* "controle_exit" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_Exit); };

/* Line 1009 of yacc.c  */
#line 2912 "analyseur.syn.cpp"
	break;
      case 201: /* "controle_error" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_Error); };

/* Line 1009 of yacc.c  */
#line 2921 "analyseur.syn.cpp"
	break;
      case 202: /* "controle_try" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_Try); };

/* Line 1009 of yacc.c  */
#line 2930 "analyseur.syn.cpp"
	break;
      case 203: /* "clauses_catch" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Clauses_Catch); };

/* Line 1009 of yacc.c  */
#line 2939 "analyseur.syn.cpp"
	break;
      case 204: /* "clause_catch" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Clause_Catch); };

/* Line 1009 of yacc.c  */
#line 2948 "analyseur.syn.cpp"
	break;
      case 205: /* "liste_erreurs" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Liste_Erreur); };

/* Line 1009 of yacc.c  */
#line 2957 "analyseur.syn.cpp"
	break;
      case 206: /* "catch_total" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Clause_Catch); };

/* Line 1009 of yacc.c  */
#line 2966 "analyseur.syn.cpp"
	break;
      case 207: /* "couleur_constante" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Expression); };

/* Line 1009 of yacc.c  */
#line 2975 "analyseur.syn.cpp"
	break;
      case 208: /* "controle_read" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_Read); };

/* Line 1009 of yacc.c  */
#line 2984 "analyseur.syn.cpp"
	break;
      case 209: /* "controle_write" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_Write); };

/* Line 1009 of yacc.c  */
#line 2993 "analyseur.syn.cpp"
	break;
      case 210: /* "controle_dpt" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_Dpt); };

/* Line 1009 of yacc.c  */
#line 3002 "analyseur.syn.cpp"
	break;
      case 211: /* "controle_idpt" */

/* Line 1009 of yacc.c  */
#line 117 "analyseur.syn.ypp"
	{ delete (yyvaluep->Controle_Idpt); };

/* Line 1009 of yacc.c  */
#line 3011 "analyseur.syn.cpp"
	break;

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (Traceur::Donnees::Instruction::BlocSP& bloc_principal, Traceur::Donnees::Global::CacheObjetGenerique& cache_objets);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (Traceur::Donnees::Instruction::BlocSP& bloc_principal, Traceur::Donnees::Global::CacheObjetGenerique& cache_objets)
#else
int
yyparse (bloc_principal, cache_objets)
    Traceur::Donnees::Instruction::BlocSP& bloc_principal;
    Traceur::Donnees::Global::CacheObjetGenerique& cache_objets;
#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

/* User initialization code.  */

/* Line 1251 of yacc.c  */
#line 67 "analyseur.syn.ypp"
{ 
//	parseurdebug=0;
}

/* Line 1251 of yacc.c  */
#line 3168 "analyseur.syn.cpp"

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1464 of yacc.c  */
#line 233 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Instruction::BlocSP bloc((yyvsp[(1) - (1)].Bloc));
	bloc->mode_isole();
	bloc_principal = bloc;
;}
    break;

  case 3:

/* Line 1464 of yacc.c  */
#line 240 "analyseur.syn.ypp"
    {
	if((yyvsp[(2) - (2)].Instruction)!=0) // pour le temps de l'implementation
	{
		Traceur::Donnees::Instruction::InstructionSP instruction((yyvsp[(2) - (2)].Instruction));
		(yyvsp[(1) - (2)].Bloc)->ajoute(instruction);
	}
	(yyval.Bloc) = (yyvsp[(1) - (2)].Bloc);
;}
    break;

  case 4:

/* Line 1464 of yacc.c  */
#line 249 "analyseur.syn.ypp"
    {
	(yyval.Bloc)=new Traceur::Donnees::Instruction::Bloc();
;}
    break;

  case 5:

/* Line 1464 of yacc.c  */
#line 254 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_Draw); ;}
    break;

  case 6:

/* Line 1464 of yacc.c  */
#line 256 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_DrawAt); ;}
    break;

  case 7:

/* Line 1464 of yacc.c  */
#line 258 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_Conv); ;}
    break;

  case 8:

/* Line 1464 of yacc.c  */
#line 260 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_Dpt); ;}
    break;

  case 9:

/* Line 1464 of yacc.c  */
#line 262 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_Idpt); ;}
    break;

  case 10:

/* Line 1464 of yacc.c  */
#line 264 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_Let); ;}
    break;

  case 11:

/* Line 1464 of yacc.c  */
#line 266 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_With); ;}
    break;

  case 12:

/* Line 1464 of yacc.c  */
#line 268 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_Read); ;}
    break;

  case 13:

/* Line 1464 of yacc.c  */
#line 270 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_Write); ;}
    break;

  case 14:

/* Line 1464 of yacc.c  */
#line 272 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_Disp); ;}
    break;

  case 15:

/* Line 1464 of yacc.c  */
#line 274 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_Do); ;}
    break;

  case 16:

/* Line 1464 of yacc.c  */
#line 276 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_If); ;}
    break;

  case 17:

/* Line 1464 of yacc.c  */
#line 278 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_For); ;}
    break;

  case 18:

/* Line 1464 of yacc.c  */
#line 280 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_While); ;}
    break;

  case 19:

/* Line 1464 of yacc.c  */
#line 282 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_Until); ;}
    break;

  case 20:

/* Line 1464 of yacc.c  */
#line 284 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_Next); ;}
    break;

  case 21:

/* Line 1464 of yacc.c  */
#line 286 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_Exit); ;}
    break;

  case 22:

/* Line 1464 of yacc.c  */
#line 288 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_Return); ;}
    break;

  case 23:

/* Line 1464 of yacc.c  */
#line 290 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_Error); ;}
    break;

  case 24:

/* Line 1464 of yacc.c  */
#line 292 "analyseur.syn.ypp"
    { (yyval.Instruction)= (yyvsp[(1) - (1)].Controle_Try); ;}
    break;

  case 25:

/* Line 1464 of yacc.c  */
#line 295 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Entier((yyvsp[(1) - (1)].Entier));
;}
    break;

  case 26:

/* Line 1464 of yacc.c  */
#line 299 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Reel((yyvsp[(1) - (1)].Reel));
;}
    break;

  case 27:

/* Line 1464 of yacc.c  */
#line 303 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Pi();
;}
    break;

  case 28:

/* Line 1464 of yacc.c  */
#line 307 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Aleatoire();
;}
    break;

  case 29:

/* Line 1464 of yacc.c  */
#line 311 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(1) - (2)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Degres(valeur,position);
;}
    break;

  case 30:

/* Line 1464 of yacc.c  */
#line 317 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(1) - (2)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Radians(valeur,position);
;}
    break;

  case 31:

/* Line 1464 of yacc.c  */
#line 323 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (4)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::ConversionEntier(valeur,position);
;}
    break;

  case 32:

/* Line 1464 of yacc.c  */
#line 329 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (4)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::ConversionReel(valeur,position);
;}
    break;

  case 33:

/* Line 1464 of yacc.c  */
#line 335 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Chaine(*((yyvsp[(1) - (1)].Chaine)));
	delete (yyvsp[(1) - (1)].Chaine);
;}
    break;

  case 34:

/* Line 1464 of yacc.c  */
#line 340 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (6)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::ConversionChaine(valeur,*((yyvsp[(5) - (6)].Chaine)),position);
	delete (yyvsp[(5) - (6)].Chaine);
;}
    break;

  case 35:

/* Line 1464 of yacc.c  */
#line 347 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(3) - (6)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(5) - (6)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Point(gauche,droite,position);
;}
    break;

  case 36:

/* Line 1464 of yacc.c  */
#line 354 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(3) - (6)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(5) - (6)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Vecteur(gauche,droite,position);
;}
    break;

  case 37:

/* Line 1464 of yacc.c  */
#line 361 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(3) - (6)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(5) - (6)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::VecteurPolaire(gauche,droite,position);
;}
    break;

  case 38:

/* Line 1464 of yacc.c  */
#line 368 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (4)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::ConversionPoint(valeur,position);
;}
    break;

  case 39:

/* Line 1464 of yacc.c  */
#line 374 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (4)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::ConversionVecteur(valeur,position);
;}
    break;

  case 40:

/* Line 1464 of yacc.c  */
#line 380 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (4)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::ConversionVecteurPolaire(valeur,position);
;}
    break;

  case 41:

/* Line 1464 of yacc.c  */
#line 386 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::BooleenVrai();
;}
    break;

  case 42:

/* Line 1464 of yacc.c  */
#line 390 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::BooleenFaux();
;}
    break;

  case 43:

/* Line 1464 of yacc.c  */
#line 394 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::BooleenPeutetre();
;}
    break;

  case 44:

/* Line 1464 of yacc.c  */
#line 398 "analyseur.syn.ypp"
    {
	(yyval.Expression)= (yyvsp[(2) - (3)].Expression);
;}
    break;

  case 45:

/* Line 1464 of yacc.c  */
#line 402 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Cosinus(valeur,position);
;}
    break;

  case 46:

/* Line 1464 of yacc.c  */
#line 408 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Sinus(valeur,position);
;}
    break;

  case 47:

/* Line 1464 of yacc.c  */
#line 414 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Tangente(valeur,position);
;}
    break;

  case 48:

/* Line 1464 of yacc.c  */
#line 420 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Arccosinus(valeur,position);
;}
    break;

  case 49:

/* Line 1464 of yacc.c  */
#line 426 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Arcsinus(valeur,position);
;}
    break;

  case 50:

/* Line 1464 of yacc.c  */
#line 432 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Arctangente(valeur,position);
;}
    break;

  case 51:

/* Line 1464 of yacc.c  */
#line 438 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Exponentielle(valeur,position);
;}
    break;

  case 52:

/* Line 1464 of yacc.c  */
#line 444 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::LogarithmeNaturel(valeur,position);
;}
    break;

  case 53:

/* Line 1464 of yacc.c  */
#line 450 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::RacineCarree(valeur,position);
;}
    break;

  case 54:

/* Line 1464 of yacc.c  */
#line 456 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::ValeurAbsolue(valeur,position);
;}
    break;

  case 55:

/* Line 1464 of yacc.c  */
#line 462 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::PartieEntiere(valeur,position);
;}
    break;

  case 56:

/* Line 1464 of yacc.c  */
#line 468 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::PartieDecimale(valeur,position);
;}
    break;

  case 57:

/* Line 1464 of yacc.c  */
#line 474 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Addition(gauche,droite,position);
;}
    break;

  case 58:

/* Line 1464 of yacc.c  */
#line 481 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Soustraction(gauche,droite,position);
;}
    break;

  case 59:

/* Line 1464 of yacc.c  */
#line 488 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Multiplication(gauche,droite,position);
;}
    break;

  case 60:

/* Line 1464 of yacc.c  */
#line 495 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Division(gauche,droite,position);
;}
    break;

  case 61:

/* Line 1464 of yacc.c  */
#line 502 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Reste(gauche,droite,position);
;}
    break;

  case 62:

/* Line 1464 of yacc.c  */
#line 509 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Exposant(gauche,droite,position);
;}
    break;

  case 63:

/* Line 1464 of yacc.c  */
#line 516 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Identite(valeur,position);
;}
    break;

  case 64:

/* Line 1464 of yacc.c  */
#line 522 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Negation(valeur,position);
;}
    break;

  case 65:

/* Line 1464 of yacc.c  */
#line 528 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Minimum(gauche,droite,position);
;}
    break;

  case 66:

/* Line 1464 of yacc.c  */
#line 535 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Maximum(gauche,droite,position);
;}
    break;

  case 67:

/* Line 1464 of yacc.c  */
#line 542 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Pgcd(gauche,droite,position);
;}
    break;

  case 68:

/* Line 1464 of yacc.c  */
#line 549 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Ppcm(gauche,droite,position);
;}
    break;

  case 69:

/* Line 1464 of yacc.c  */
#line 556 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::NonLogique(droite,position);
;}
    break;

  case 70:

/* Line 1464 of yacc.c  */
#line 562 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::EtLogique(gauche,droite,position);
;}
    break;

  case 71:

/* Line 1464 of yacc.c  */
#line 569 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::OuLogique(gauche,droite,position);
;}
    break;

  case 72:

/* Line 1464 of yacc.c  */
#line 576 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::OuExclusifLogique(gauche,droite,position);
;}
    break;

  case 73:

/* Line 1464 of yacc.c  */
#line 583 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Egalite(gauche,droite,position);
;}
    break;

  case 74:

/* Line 1464 of yacc.c  */
#line 590 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Difference(gauche,droite,position);
;}
    break;

  case 75:

/* Line 1464 of yacc.c  */
#line 597 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Inferieur(gauche,droite,position);
;}
    break;

  case 76:

/* Line 1464 of yacc.c  */
#line 604 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::InferieurOuEgal(gauche,droite,position);
;}
    break;

  case 77:

/* Line 1464 of yacc.c  */
#line 611 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Superieur(gauche,droite,position);
;}
    break;

  case 78:

/* Line 1464 of yacc.c  */
#line 618 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::SuperieurOuEgal(gauche,droite,position);
;}
    break;

  case 79:

/* Line 1464 of yacc.c  */
#line 625 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP gauche(cache_objets((yyvsp[(3) - (7)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP droite(cache_objets((yyvsp[(5) - (7)].Expression)));
	Traceur::Donnees::Expression::OptionsLigneSP options((yyvsp[(6) - (7)].OptionsLigne));
	(yyval.Expression) = new Traceur::Donnees::Expression::Ligne(gauche,droite,options,position);
;}
    break;

  case 80:

/* Line 1464 of yacc.c  */
#line 633 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP centre(cache_objets((yyvsp[(3) - (7)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP rayon(cache_objets((yyvsp[(5) - (7)].Expression)));
	Traceur::Donnees::Expression::OptionsSurfaceSP options((yyvsp[(6) - (7)].OptionsSurface));
	(yyval.Expression) = new Traceur::Donnees::Expression::Cercle(centre,rayon,options,position);
;}
    break;

  case 81:

/* Line 1464 of yacc.c  */
#line 641 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP sommet1(cache_objets((yyvsp[(3) - (9)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP sommet2(cache_objets((yyvsp[(5) - (9)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP sommet3(cache_objets((yyvsp[(7) - (9)].Expression)));
	Traceur::Donnees::Expression::OptionsSurfaceSP options((yyvsp[(8) - (9)].OptionsSurface));
	(yyval.Expression) = new Traceur::Donnees::Expression::Triangle(sommet1,sommet2,sommet3,options,position);
;}
    break;

  case 82:

/* Line 1464 of yacc.c  */
#line 650 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP sommet1(cache_objets((yyvsp[(3) - (7)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP sommet2(cache_objets((yyvsp[(5) - (7)].Expression)));
	Traceur::Donnees::Expression::OptionsSurfaceSP options((yyvsp[(6) - (7)].OptionsSurface));
	(yyval.Expression) = new Traceur::Donnees::Expression::Rectangle(sommet1,sommet2,options,position);
;}
    break;

  case 83:

/* Line 1464 of yacc.c  */
#line 658 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP sommet1(cache_objets((yyvsp[(3) - (9)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP sommet2(cache_objets((yyvsp[(5) - (9)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP sommet3(cache_objets((yyvsp[(7) - (9)].Expression)));
	Traceur::Donnees::Expression::OptionsSurfaceSP options((yyvsp[(8) - (9)].OptionsSurface));
	(yyval.Expression) = new Traceur::Donnees::Expression::Rectangle(sommet1,sommet2,sommet3,options,position);
;}
    break;

  case 84:

/* Line 1464 of yacc.c  */
#line 667 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP centre(cache_objets((yyvsp[(3) - (9)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP axe_horizontal(cache_objets((yyvsp[(5) - (9)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP axe_vertical(cache_objets((yyvsp[(7) - (9)].Expression)));
	Traceur::Donnees::Expression::OptionsSurfaceSP options((yyvsp[(8) - (9)].OptionsSurface));
	(yyval.Expression) = new Traceur::Donnees::Expression::Ellipse(centre,axe_horizontal,axe_vertical,options,position);
;}
    break;

  case 85:

/* Line 1464 of yacc.c  */
#line 676 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (5)].Expression)));
	Traceur::Donnees::Expression::OptionsSurfaceSP options((yyvsp[(4) - (5)].OptionsSurface));
	(yyval.Expression) = new Traceur::Donnees::Expression::Remplissage(valeur,options,position);
;}
    break;

  case 86:

/* Line 1464 of yacc.c  */
#line 683 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (4)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Solide(valeur,position);
;}
    break;

  case 87:

/* Line 1464 of yacc.c  */
#line 689 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (4)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Gomme(valeur,position);
;}
    break;

  case 88:

/* Line 1464 of yacc.c  */
#line 695 "analyseur.syn.ypp"
    {
	(yyval.Expression) = (yyvsp[(1) - (1)].Expression);
;}
    break;

  case 89:

/* Line 1464 of yacc.c  */
#line 699 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP rouge(cache_objets((yyvsp[(3) - (10)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP vert(cache_objets((yyvsp[(5) - (10)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP bleu(cache_objets((yyvsp[(7) - (10)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP alpha(cache_objets((yyvsp[(9) - (10)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::CouleurRVBA(rouge,vert,bleu,alpha,position);
;}
    break;

  case 90:

/* Line 1464 of yacc.c  */
#line 708 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP teinte(cache_objets((yyvsp[(3) - (10)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP saturation(cache_objets((yyvsp[(5) - (10)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(7) - (10)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP alpha(cache_objets((yyvsp[(9) - (10)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::CouleurHSVA(teinte,saturation,valeur,alpha,position);
;}
    break;

  case 91:

/* Line 1464 of yacc.c  */
#line 717 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP couleur(cache_objets((yyvsp[(3) - (6)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP alpha(cache_objets((yyvsp[(5) - (6)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::ConversionCouleurAlpha(couleur,alpha,position);
;}
    break;

  case 92:

/* Line 1464 of yacc.c  */
#line 724 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (4)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::ConversionCouleur(valeur,position);
;}
    break;

  case 93:

/* Line 1464 of yacc.c  */
#line 730 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (4)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::ConversionHSV(valeur,position);
;}
    break;

  case 94:

/* Line 1464 of yacc.c  */
#line 736 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (4)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::ConversionRouge(valeur,position);
;}
    break;

  case 95:

/* Line 1464 of yacc.c  */
#line 742 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (4)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::ConversionVert(valeur,position);
;}
    break;

  case 96:

/* Line 1464 of yacc.c  */
#line 748 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (4)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::ConversionBleu(valeur,position);
;}
    break;

  case 97:

/* Line 1464 of yacc.c  */
#line 754 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (4)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::ConversionAlpha(valeur,position);
;}
    break;

  case 98:

/* Line 1464 of yacc.c  */
#line 760 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (4)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::ConversionTeinte(valeur,position);
;}
    break;

  case 99:

/* Line 1464 of yacc.c  */
#line 766 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (4)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::ConversionSaturation(valeur,position);
;}
    break;

  case 100:

/* Line 1464 of yacc.c  */
#line 772 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(3) - (4)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::ConversionValeur(valeur,position);
;}
    break;

  case 101:

/* Line 1464 of yacc.c  */
#line 778 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP taille_x(cache_objets((yyvsp[(3) - (11)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP taille_y(cache_objets((yyvsp[(5) - (11)].Expression)));
	Traceur::Donnees::Expression::SystemeCoordonneesSP coordonnees((yyvsp[(7) - (11)].SystemeCoordonnees));
	Traceur::Donnees::Expression::ExpressionSP couleur_fond(cache_objets((yyvsp[(8) - (11)].Expression)));
	Traceur::Donnees::Instruction::BlocSP contenu((yyvsp[(10) - (11)].Bloc));
	(yyval.Expression) = new Traceur::Donnees::Expression::Image(taille_x,taille_y,coordonnees,couleur_fond,contenu,position);
;}
    break;

  case 102:

/* Line 1464 of yacc.c  */
#line 788 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP taille_x(cache_objets((yyvsp[(3) - (10)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP taille_y(cache_objets((yyvsp[(5) - (10)].Expression)));
	Traceur::Donnees::Expression::SystemeCoordonneesSP coordonnees((yyvsp[(7) - (10)].SystemeCoordonnees));
	Traceur::Donnees::Instruction::BlocSP contenu((yyvsp[(9) - (10)].Bloc));
	(yyval.Expression) = new Traceur::Donnees::Expression::Noyau(taille_x,taille_y,coordonnees,contenu,position);
;}
    break;

  case 103:

/* Line 1464 of yacc.c  */
#line 797 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Xmin();
;}
    break;

  case 104:

/* Line 1464 of yacc.c  */
#line 801 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Xmax();
;}
    break;

  case 105:

/* Line 1464 of yacc.c  */
#line 805 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Xscl();
;}
    break;

  case 106:

/* Line 1464 of yacc.c  */
#line 809 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Xsiz();
;}
    break;

  case 107:

/* Line 1464 of yacc.c  */
#line 813 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Ymin();
;}
    break;

  case 108:

/* Line 1464 of yacc.c  */
#line 817 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Ymax();
;}
    break;

  case 109:

/* Line 1464 of yacc.c  */
#line 821 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Yscl();
;}
    break;

  case 110:

/* Line 1464 of yacc.c  */
#line 825 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Ysiz();
;}
    break;

  case 111:

/* Line 1464 of yacc.c  */
#line 829 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP essai(cache_objets((yyvsp[(3) - (8)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP clause_catch(cache_objets((yyvsp[(7) - (8)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Catch(essai,*((yyvsp[(5) - (8)].Chaine)),clause_catch,position);
	delete (yyvsp[(5) - (8)].Chaine);
	
;}
    break;

  case 112:

/* Line 1464 of yacc.c  */
#line 838 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP essai(cache_objets((yyvsp[(3) - (6)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP clause_catch(cache_objets((yyvsp[(5) - (6)].Expression)));
	(yyval.Expression) = new Traceur::Donnees::Expression::Catch(essai,clause_catch,position);
;}
    break;

  case 113:

/* Line 1464 of yacc.c  */
#line 845 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Type::TypeSP type((yyvsp[(1) - (4)].Type));
	(yyval.Expression) = new Traceur::Donnees::Expression::AppelFonctionUtilisateur(type,*((yyvsp[(2) - (4)].AppelFonctionListeParametres)),*((yyvsp[(3) - (4)].Chaine)),*((yyvsp[(4) - (4)].AppelFonctionListeParametres)),position);
	delete (yyvsp[(2) - (4)].AppelFonctionListeParametres);
	delete (yyvsp[(3) - (4)].Chaine);
	delete (yyvsp[(4) - (4)].AppelFonctionListeParametres);
;}
    break;

  case 114:

/* Line 1464 of yacc.c  */
#line 855 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Fonction::PrototypeSP prototype((yyvsp[(2) - (2)].Prototype));
	(yyval.FonctionImaginaire) = new Traceur::Donnees::Fonction::FonctionImaginaire(prototype,position);
;}
    break;

  case 115:

/* Line 1464 of yacc.c  */
#line 861 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Fonction::PrototypeSP prototype((yyvsp[(2) - (4)].Prototype));
	Traceur::Donnees::Instruction::InstructionSP instruction((yyvsp[(4) - (4)].Instruction));
	Traceur::Donnees::Fonction::FonctionSP fonction(new Traceur::Donnees::Fonction::FonctionReelle(prototype,instruction,position));
	(yyval.FonctionImaginaire) = new Traceur::Donnees::Fonction::FonctionImaginaire(prototype,fonction,position);
;}
    break;

  case 116:

/* Line 1464 of yacc.c  */
#line 869 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Fonction::PrototypeSP prototype((yyvsp[(3) - (5)].Prototype));
	Traceur::Donnees::Instruction::InstructionSP instruction((yyvsp[(5) - (5)].Instruction));
	Traceur::Donnees::Fonction::FonctionSP fonction(new Traceur::Donnees::Fonction::FonctionReelleRecursive(prototype,instruction,position));
	(yyval.FonctionImaginaire) = new Traceur::Donnees::Fonction::FonctionImaginaire(prototype,fonction,position);
;}
    break;

  case 117:

/* Line 1464 of yacc.c  */
#line 878 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Fonction::FonctionImaginaireSP fonction((yyvsp[(1) - (1)].FonctionImaginaire));
	(yyval.Expression) = new Traceur::Donnees::Expression::FonctionImaginaire(fonction);
;}
    break;

  case 118:

/* Line 1464 of yacc.c  */
#line 883 "analyseur.syn.ypp"
    {
	(yyval.Expression) = (yyvsp[(1) - (1)].Expression);
;}
    break;

  case 119:

/* Line 1464 of yacc.c  */
#line 888 "analyseur.syn.ypp"
    {
	(yyval.SystemeCoordonnees) = 0;
;}
    break;

  case 120:

/* Line 1464 of yacc.c  */
#line 892 "analyseur.syn.ypp"
    {
	(yyval.SystemeCoordonnees) = new Traceur::Donnees::Expression::SystemeGeometrique();
;}
    break;

  case 121:

/* Line 1464 of yacc.c  */
#line 896 "analyseur.syn.ypp"
    {
	(yyval.SystemeCoordonnees) = new Traceur::Donnees::Expression::SystemeStandard();
;}
    break;

  case 122:

/* Line 1464 of yacc.c  */
#line 900 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Expression::ExpressionSP min(cache_objets((yyvsp[(3) - (6)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP max(cache_objets((yyvsp[(5) - (6)].Expression)));
	(yyval.SystemeCoordonnees) = new Traceur::Donnees::Expression::SystemeMathematique(min,max);
;}
    break;

  case 123:

/* Line 1464 of yacc.c  */
#line 906 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Expression::ExpressionSP xmin(cache_objets((yyvsp[(3) - (10)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP xmax(cache_objets((yyvsp[(5) - (10)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP ymin(cache_objets((yyvsp[(7) - (10)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP ymax(cache_objets((yyvsp[(9) - (10)].Expression)));
	(yyval.SystemeCoordonnees) = new Traceur::Donnees::Expression::SystemeMathematique(xmin,ymin,xmax,ymax);
;}
    break;

  case 124:

/* Line 1464 of yacc.c  */
#line 915 "analyseur.syn.ypp"
    {
	(yyval.Expression) = 0;
;}
    break;

  case 125:

/* Line 1464 of yacc.c  */
#line 919 "analyseur.syn.ypp"
    {
	(yyval.Expression) = (yyvsp[(1) - (1)].Expression);
;}
    break;

  case 126:

/* Line 1464 of yacc.c  */
#line 924 "analyseur.syn.ypp"
    {
	(yyval.AppelFonctionListeParametres) = new Traceur::Donnees::Expression::AppelFonctionUtilisateur::ListeParametres()
;}
    break;

  case 127:

/* Line 1464 of yacc.c  */
#line 928 "analyseur.syn.ypp"
    {
	(yyval.AppelFonctionListeParametres) = (yyvsp[(2) - (3)].AppelFonctionListeParametres);
;}
    break;

  case 128:

/* Line 1464 of yacc.c  */
#line 933 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Expression::ExpressionSP expression(cache_objets((yyvsp[(1) - (1)].Expression)));
	(yyval.AppelFonctionListeParametres) = new Traceur::Donnees::Expression::AppelFonctionUtilisateur::ListeParametres();
	(yyval.AppelFonctionListeParametres)->push_back(expression);
;}
    break;

  case 129:

/* Line 1464 of yacc.c  */
#line 939 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Expression::ExpressionSP expression(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyvsp[(1) - (3)].AppelFonctionListeParametres)->push_back(expression);
	(yyval.AppelFonctionListeParametres) = (yyvsp[(1) - (3)].AppelFonctionListeParametres);
;}
    break;

  case 130:

/* Line 1464 of yacc.c  */
#line 946 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Void();
;}
    break;

  case 131:

/* Line 1464 of yacc.c  */
#line 950 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Number();
;}
    break;

  case 132:

/* Line 1464 of yacc.c  */
#line 954 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Integer();
;}
    break;

  case 133:

/* Line 1464 of yacc.c  */
#line 958 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Real();
;}
    break;

  case 134:

/* Line 1464 of yacc.c  */
#line 962 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::String();
;}
    break;

  case 135:

/* Line 1464 of yacc.c  */
#line 966 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Boolean();
;}
    break;

  case 136:

/* Line 1464 of yacc.c  */
#line 970 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Point();
;}
    break;

  case 137:

/* Line 1464 of yacc.c  */
#line 974 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Vector();
;}
    break;

  case 138:

/* Line 1464 of yacc.c  */
#line 978 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Tool();
;}
    break;

  case 139:

/* Line 1464 of yacc.c  */
#line 982 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Line();
;}
    break;

  case 140:

/* Line 1464 of yacc.c  */
#line 986 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Triangle();
;}
    break;

  case 141:

/* Line 1464 of yacc.c  */
#line 990 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Rectangle();
;}
    break;

  case 142:

/* Line 1464 of yacc.c  */
#line 994 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Circle();
;}
    break;

  case 143:

/* Line 1464 of yacc.c  */
#line 998 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Ellipse();
;}
    break;

  case 144:

/* Line 1464 of yacc.c  */
#line 1002 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Fill();
;}
    break;

  case 145:

/* Line 1464 of yacc.c  */
#line 1006 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Solid();
;}
    break;

  case 146:

/* Line 1464 of yacc.c  */
#line 1010 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Eraser();
;}
    break;

  case 147:

/* Line 1464 of yacc.c  */
#line 1014 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Color();
;}
    break;

  case 148:

/* Line 1464 of yacc.c  */
#line 1018 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Image();
;}
    break;

  case 149:

/* Line 1464 of yacc.c  */
#line 1022 "analyseur.syn.ypp"
    {
	(yyval.Type) = new Traceur::Donnees::Type::Kernel();
;}
    break;

  case 150:

/* Line 1464 of yacc.c  */
#line 1027 "analyseur.syn.ypp"
    {
	(yyval.OptionsLigne) = new Traceur::Donnees::Expression::OptionsLigne();
;}
    break;

  case 151:

/* Line 1464 of yacc.c  */
#line 1031 "analyseur.syn.ypp"
    {
	(yyval.OptionsLigne) = (yyvsp[(2) - (2)].OptionsLigne);
;}
    break;

  case 152:

/* Line 1464 of yacc.c  */
#line 1036 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::OptionsLigne *options = new Traceur::Donnees::Expression::OptionsLigne();
	(yyvsp[(1) - (1)].OptionLigneSimple)->option(options,position);
	(yyval.OptionsLigne) = options;
	delete (yyvsp[(1) - (1)].OptionLigneSimple);
;}
    break;

  case 153:

/* Line 1464 of yacc.c  */
#line 1044 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yylsp[(3) - (3)]));
	(yyvsp[(3) - (3)].OptionLigneSimple)->option((yyvsp[(1) - (3)].OptionsLigne),position);
	(yyval.OptionsLigne) = (yyvsp[(1) - (3)].OptionsLigne);
	delete (yyvsp[(3) - (3)].OptionLigneSimple);
;}
    break;

  case 154:

/* Line 1464 of yacc.c  */
#line 1052 "analyseur.syn.ypp"
    {
	(yyval.OptionLigneSimple) = new Traceur::Donnees::Expression::OptionLigneSansDebut();
;}
    break;

  case 155:

/* Line 1464 of yacc.c  */
#line 1056 "analyseur.syn.ypp"
    {
	(yyval.OptionLigneSimple) = new Traceur::Donnees::Expression::OptionLigneSansFin();
;}
    break;

  case 156:

/* Line 1464 of yacc.c  */
#line 1060 "analyseur.syn.ypp"
    {
	(yyval.OptionLigneSimple) = new Traceur::Donnees::Expression::OptionLigneSolide();
;}
    break;

  case 157:

/* Line 1464 of yacc.c  */
#line 1064 "analyseur.syn.ypp"
    {
	(yyval.OptionLigneSimple) = new Traceur::Donnees::Expression::OptionLigneGomme();
;}
    break;

  case 158:

/* Line 1464 of yacc.c  */
#line 1068 "analyseur.syn.ypp"
    {
	(yyval.OptionLigneSimple) = new Traceur::Donnees::Expression::OptionLignePointilles();
;}
    break;

  case 159:

/* Line 1464 of yacc.c  */
#line 1072 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Expression::ExpressionSP ecart(cache_objets((yyvsp[(3) - (4)].Expression)));
	(yyval.OptionLigneSimple) = new Traceur::Donnees::Expression::OptionLigneTirets(ecart);
;}
    break;

  case 160:

/* Line 1464 of yacc.c  */
#line 1077 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Expression::ExpressionSP ecart_trace(cache_objets((yyvsp[(3) - (6)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP ecart_non_trace(cache_objets((yyvsp[(5) - (6)].Expression)));
	(yyval.OptionLigneSimple) = new Traceur::Donnees::Expression::OptionLigneTirets(ecart_trace,ecart_non_trace);
;}
    break;

  case 161:

/* Line 1464 of yacc.c  */
#line 1083 "analyseur.syn.ypp"
    {
	(yyval.OptionLigneSimple) = 0;
	Traceur::Donnees::Source::PositionSP position((yyloc));
	throw Traceur::Exception::ErreurOptionLigne(position,"FILL");
;}
    break;

  case 162:

/* Line 1464 of yacc.c  */
#line 1090 "analyseur.syn.ypp"
    {
	(yyval.OptionsSurface) = new Traceur::Donnees::Expression::OptionsSurface();
;}
    break;

  case 163:

/* Line 1464 of yacc.c  */
#line 1094 "analyseur.syn.ypp"
    {
	(yyval.OptionsSurface) = (yyvsp[(2) - (2)].OptionsSurface);
;}
    break;

  case 164:

/* Line 1464 of yacc.c  */
#line 1099 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::OptionsSurface *options = new Traceur::Donnees::Expression::OptionsSurface();
	(yyvsp[(1) - (1)].OptionSurfaceSimple)->option(options,position);
	(yyval.OptionsSurface) = options;
	delete (yyvsp[(1) - (1)].OptionSurfaceSimple);
;}
    break;

  case 165:

/* Line 1464 of yacc.c  */
#line 1107 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yylsp[(3) - (3)]));
	(yyvsp[(3) - (3)].OptionSurfaceSimple)->option((yyvsp[(1) - (3)].OptionsSurface),position);
	(yyval.OptionsSurface) = (yyvsp[(1) - (3)].OptionsSurface);
	delete (yyvsp[(3) - (3)].OptionSurfaceSimple);
;}
    break;

  case 166:

/* Line 1464 of yacc.c  */
#line 1115 "analyseur.syn.ypp"
    {
	(yyval.OptionSurfaceSimple) = new Traceur::Donnees::Expression::OptionSurfaceRemplissage();
;}
    break;

  case 167:

/* Line 1464 of yacc.c  */
#line 1119 "analyseur.syn.ypp"
    {
	(yyval.OptionSurfaceSimple) = new Traceur::Donnees::Expression::OptionSurfaceSolide();
;}
    break;

  case 168:

/* Line 1464 of yacc.c  */
#line 1123 "analyseur.syn.ypp"
    {
	(yyval.OptionSurfaceSimple) = new Traceur::Donnees::Expression::OptionSurfaceGomme();
;}
    break;

  case 169:

/* Line 1464 of yacc.c  */
#line 1127 "analyseur.syn.ypp"
    {
	(yyval.OptionSurfaceSimple) = 0;
	Traceur::Donnees::Source::PositionSP position((yyloc));
	throw Traceur::Exception::ErreurOptionSurface(position,"NOSTART");
;}
    break;

  case 170:

/* Line 1464 of yacc.c  */
#line 1133 "analyseur.syn.ypp"
    {
	(yyval.OptionSurfaceSimple) = 0;
	Traceur::Donnees::Source::PositionSP position((yyloc));
	throw Traceur::Exception::ErreurOptionSurface(position,"NOEND");
;}
    break;

  case 171:

/* Line 1464 of yacc.c  */
#line 1139 "analyseur.syn.ypp"
    {
	(yyval.OptionSurfaceSimple) = 0;
	Traceur::Donnees::Source::PositionSP position((yyloc));
	throw Traceur::Exception::ErreurOptionSurface(position,"DOTTED");
;}
    break;

  case 172:

/* Line 1464 of yacc.c  */
#line 1145 "analyseur.syn.ypp"
    {
	(yyval.OptionSurfaceSimple) = 0;
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP ecart(cache_objets((yyvsp[(3) - (4)].Expression)));
	throw Traceur::Exception::ErreurOptionSurface(position,"DASHED[]");
;}
    break;

  case 173:

/* Line 1464 of yacc.c  */
#line 1152 "analyseur.syn.ypp"
    {
	(yyval.OptionSurfaceSimple) = 0;
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP ecart_trace(cache_objets((yyvsp[(3) - (6)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP ecart_non_trace(cache_objets((yyvsp[(5) - (6)].Expression)));
	throw Traceur::Exception::ErreurOptionSurface(position,"DASHED[;]");
;}
    break;

  case 174:

/* Line 1464 of yacc.c  */
#line 1161 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Controle_Draw) = new Traceur::Donnees::Instruction::Draw(valeur,position);
;}
    break;

  case 175:

/* Line 1464 of yacc.c  */
#line 1168 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP image(cache_objets((yyvsp[(2) - (5)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP point(cache_objets((yyvsp[(4) - (5)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP by(cache_objets((yyvsp[(5) - (5)].Expression)));
	(yyval.Controle_DrawAt) = new Traceur::Donnees::Instruction::DrawAt(image,point,by,position);
;}
    break;

  case 176:

/* Line 1464 of yacc.c  */
#line 1177 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Entier(255);
;}
    break;

  case 177:

/* Line 1464 of yacc.c  */
#line 1181 "analyseur.syn.ypp"
    {
	(yyval.Expression) = (yyvsp[(2) - (2)].Expression);
;}
    break;

  case 178:

/* Line 1464 of yacc.c  */
#line 1186 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Controle_Conv) = new Traceur::Donnees::Instruction::Conv(valeur,position);
;}
    break;

  case 179:

/* Line 1464 of yacc.c  */
#line 1193 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Controle_With) = new Traceur::Donnees::Instruction::With(valeur,position);
;}
    break;

  case 180:

/* Line 1464 of yacc.c  */
#line 1199 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP valeur(cache_objets((yyvsp[(2) - (5)].Expression)));
	Traceur::Donnees::Instruction::BlocSP bloc((yyvsp[(4) - (5)].Bloc));
	(yyval.Controle_With) = new Traceur::Donnees::Instruction::With(valeur,bloc,position);
;}
    break;

  case 181:

/* Line 1464 of yacc.c  */
#line 1207 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Fonction::PrototypeSP prototype((yyvsp[(2) - (4)].Prototype));
	Traceur::Donnees::Instruction::InstructionSP instruction((yyvsp[(4) - (4)].Instruction));
	Traceur::Donnees::Fonction::FonctionSP fonction(new Traceur::Donnees::Fonction::FonctionReelle(prototype,instruction,position));
	(yyval.Controle_Let) = new Traceur::Donnees::Instruction::Let(prototype,fonction,position);
;}
    break;

  case 182:

/* Line 1464 of yacc.c  */
#line 1215 "analyseur.syn.ypp"
    { 
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Fonction::PrototypeSP prototype((yyvsp[(3) - (5)].Prototype));
	Traceur::Donnees::Instruction::InstructionSP instruction((yyvsp[(5) - (5)].Instruction));
	Traceur::Donnees::Fonction::FonctionSP fonction(new Traceur::Donnees::Fonction::FonctionReelleRecursive(prototype,instruction,position));
	(yyval.Controle_Let) = new Traceur::Donnees::Instruction::Let(prototype,fonction,position);
;}
    break;

  case 183:

/* Line 1464 of yacc.c  */
#line 1223 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Fonction::PrototypeSP prototype((yyvsp[(3) - (5)].Prototype));
	Traceur::Donnees::Instruction::InstructionSP instruction((yyvsp[(5) - (5)].Instruction));
	(yyval.Controle_Let) = new Traceur::Donnees::Instruction::LetFunc(prototype,instruction,position);
;}
    break;

  case 184:

/* Line 1464 of yacc.c  */
#line 1231 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Type::TypeSP type((yyvsp[(1) - (4)].Type));
	(yyval.Prototype) = new Traceur::Donnees::Fonction::Prototype(type,*((yyvsp[(2) - (4)].PrototypeListeParametres)),*((yyvsp[(3) - (4)].Chaine)),*((yyvsp[(4) - (4)].PrototypeListeParametres)));
	delete (yyvsp[(2) - (4)].PrototypeListeParametres);
	delete (yyvsp[(3) - (4)].Chaine);
	delete (yyvsp[(4) - (4)].PrototypeListeParametres);
;}
    break;

  case 185:

/* Line 1464 of yacc.c  */
#line 1240 "analyseur.syn.ypp"
    {
	(yyval.Type) = (yyvsp[(1) - (1)].Type);
;}
    break;

  case 186:

/* Line 1464 of yacc.c  */
#line 1244 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Fonction::PrototypeSP prototype((yyvsp[(2) - (3)].Prototype));
	(yyval.Type) = new Traceur::Donnees::Type::Fonction(prototype);
;}
    break;

  case 187:

/* Line 1464 of yacc.c  */
#line 1250 "analyseur.syn.ypp"
    {
	(yyval.PrototypeListeParametres) = new Traceur::Donnees::Fonction::Prototype::ListeParametres();
;}
    break;

  case 188:

/* Line 1464 of yacc.c  */
#line 1254 "analyseur.syn.ypp"
    {
	(yyval.PrototypeListeParametres) = (yyvsp[(2) - (3)].PrototypeListeParametres);
;}
    break;

  case 189:

/* Line 1464 of yacc.c  */
#line 1259 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Fonction::PrototypeSP prototype((yyvsp[(1) - (1)].Prototype));
	(yyval.PrototypeListeParametres) = new Traceur::Donnees::Fonction::Prototype::ListeParametres();
	(yyval.PrototypeListeParametres)->push_back(prototype);
;}
    break;

  case 190:

/* Line 1464 of yacc.c  */
#line 1265 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Fonction::PrototypeSP prototype((yyvsp[(3) - (3)].Prototype));
	(yyvsp[(1) - (3)].PrototypeListeParametres)->push_back(prototype);
	(yyval.PrototypeListeParametres) = (yyvsp[(1) - (3)].PrototypeListeParametres);
;}
    break;

  case 191:

/* Line 1464 of yacc.c  */
#line 1272 "analyseur.syn.ypp"
    {
	(yyval.Instruction)=(yyvsp[(1) - (1)].Instruction);
;}
    break;

  case 192:

/* Line 1464 of yacc.c  */
#line 1276 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP expression(cache_objets((yyvsp[(1) - (1)].Expression)));
	(yyval.Instruction) = new Traceur::Donnees::Instruction::Return(expression,position);
;}
    break;

  case 193:

/* Line 1464 of yacc.c  */
#line 1283 "analyseur.syn.ypp"
    {
	(yyval.Instruction)=(yyvsp[(1) - (1)].Instruction);
;}
    break;

  case 194:

/* Line 1464 of yacc.c  */
#line 1287 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP expression(cache_objets((yyvsp[(1) - (1)].Expression)));
	(yyval.Instruction) = new Traceur::Donnees::Instruction::Return(expression,position);
;}
    break;

  case 195:

/* Line 1464 of yacc.c  */
#line 1293 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Fonction::FonctionImaginaireSP fonction((yyvsp[(1) - (1)].FonctionImaginaire));
	(yyval.Instruction) = new Traceur::Donnees::Instruction::Return(fonction,position);
;}
    break;

  case 196:

/* Line 1464 of yacc.c  */
#line 1300 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP expression(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Controle_Return) = new Traceur::Donnees::Instruction::Return(expression,position);
;}
    break;

  case 197:

/* Line 1464 of yacc.c  */
#line 1306 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Fonction::FonctionImaginaireSP fonction((yyvsp[(2) - (2)].FonctionImaginaire));
	(yyval.Controle_Return) = new Traceur::Donnees::Instruction::Return(fonction,position);
;}
    break;

  case 198:

/* Line 1464 of yacc.c  */
#line 1312 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	(yyval.Controle_Return) = new Traceur::Donnees::Instruction::Return(position);
;}
    break;

  case 199:

/* Line 1464 of yacc.c  */
#line 1318 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP expression(cache_objets((yyvsp[(2) - (2)].Expression)));
	(yyval.Controle_Disp) = new Traceur::Donnees::Instruction::Disp(expression,position);
;}
    break;

  case 200:

/* Line 1464 of yacc.c  */
#line 1324 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	(yyval.Controle_Disp) = new Traceur::Donnees::Instruction::Disp(position);
;}
    break;

  case 201:

/* Line 1464 of yacc.c  */
#line 1330 "analyseur.syn.ypp"
    {
	(yyvsp[(2) - (3)].Bloc)->mode_restreint();
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Instruction::BlocSP bloc((yyvsp[(2) - (3)].Bloc));
	(yyval.Controle_Do)=new Traceur::Donnees::Instruction::Do(bloc,position);
;}
    break;

  case 202:

/* Line 1464 of yacc.c  */
#line 1338 "analyseur.syn.ypp"
    {
	(yyvsp[(3) - (5)].Clauses_Vraies)->push_front(*((yyvsp[(2) - (5)].Clause_Vraie)));
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Instruction::BlocSP bloc((yyvsp[(4) - (5)].Bloc));
	(yyval.Controle_If) = new Traceur::Donnees::Instruction::If(*((yyvsp[(3) - (5)].Clauses_Vraies)),bloc,position);
	delete (yyvsp[(2) - (5)].Clause_Vraie);
	delete (yyvsp[(3) - (5)].Clauses_Vraies);
;}
    break;

  case 203:

/* Line 1464 of yacc.c  */
#line 1348 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Expression::ExpressionSP expression(cache_objets((yyvsp[(1) - (3)].Expression)));
	Traceur::Donnees::Instruction::BlocSP bloc((yyvsp[(3) - (3)].Bloc));
	(yyval.Clause_Vraie) = new Traceur::Donnees::Instruction::If::ClauseVraie(expression,bloc);
;}
    break;

  case 204:

/* Line 1464 of yacc.c  */
#line 1355 "analyseur.syn.ypp"
    {
	(yyval.Clauses_Vraies) = new Traceur::Donnees::Instruction::If::ClausesVraies();
;}
    break;

  case 205:

/* Line 1464 of yacc.c  */
#line 1359 "analyseur.syn.ypp"
    {
	(yyvsp[(1) - (3)].Clauses_Vraies)->push_back(*((yyvsp[(3) - (3)].Clause_Vraie)));
	(yyval.Clauses_Vraies) = (yyvsp[(1) - (3)].Clauses_Vraies);
	delete (yyvsp[(3) - (3)].Clause_Vraie);
;}
    break;

  case 206:

/* Line 1464 of yacc.c  */
#line 1366 "analyseur.syn.ypp"
    {
	(yyval.Bloc) = new Traceur::Donnees::Instruction::Bloc();
;}
    break;

  case 207:

/* Line 1464 of yacc.c  */
#line 1370 "analyseur.syn.ypp"
    {
	(yyval.Bloc) = (yyvsp[(2) - (2)].Bloc);
;}
    break;

  case 208:

/* Line 1464 of yacc.c  */
#line 1376 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Fonction::PrototypeSP prototype((yyvsp[(2) - (10)].Prototype));
	Traceur::Donnees::Expression::ExpressionSP debut(cache_objets((yyvsp[(4) - (10)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP fin(cache_objets((yyvsp[(6) - (10)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP pas(cache_objets((yyvsp[(7) - (10)].Expression)));
	Traceur::Donnees::Instruction::BlocSP bloc((yyvsp[(9) - (10)].Bloc));
	(yyval.Controle_For) = new Traceur::Donnees::Instruction::For(prototype,debut,fin,pas,bloc,position);
;}
    break;

  case 209:

/* Line 1464 of yacc.c  */
#line 1387 "analyseur.syn.ypp"
    {
	(yyval.Expression)=0;
;}
    break;

  case 210:

/* Line 1464 of yacc.c  */
#line 1391 "analyseur.syn.ypp"
    {
	(yyval.Expression) = (yyvsp[(2) - (2)].Expression);
;}
    break;

  case 211:

/* Line 1464 of yacc.c  */
#line 1396 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP condition(cache_objets((yyvsp[(2) - (5)].Expression)));
	Traceur::Donnees::Instruction::BlocSP bloc((yyvsp[(4) - (5)].Bloc));
	(yyval.Controle_While) = new Traceur::Donnees::Instruction::While(condition,bloc,position);
;}
    break;

  case 212:

/* Line 1464 of yacc.c  */
#line 1404 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Instruction::BlocSP bloc((yyvsp[(2) - (5)].Bloc));
	Traceur::Donnees::Expression::ExpressionSP condition(cache_objets((yyvsp[(4) - (5)].Expression)));
	(yyval.Controle_Until) = new Traceur::Donnees::Instruction::Until(bloc,condition,position);
;}
    break;

  case 213:

/* Line 1464 of yacc.c  */
#line 1412 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	(yyval.Controle_Next) = new Traceur::Donnees::Instruction::Next(position);
;}
    break;

  case 214:

/* Line 1464 of yacc.c  */
#line 1417 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	(yyval.Controle_Next) = new Traceur::Donnees::Instruction::Next((yyvsp[(2) - (2)].Entier),position);
;}
    break;

  case 215:

/* Line 1464 of yacc.c  */
#line 1423 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	(yyval.Controle_Exit) = new Traceur::Donnees::Instruction::Exit(position);
;}
    break;

  case 216:

/* Line 1464 of yacc.c  */
#line 1428 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	(yyval.Controle_Exit) = new Traceur::Donnees::Instruction::Exit((yyvsp[(2) - (2)].Entier),position);
;}
    break;

  case 217:

/* Line 1464 of yacc.c  */
#line 1434 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	(yyval.Controle_Error) = new Traceur::Donnees::Instruction::Error(*((yyvsp[(2) - (2)].Chaine)),position);
	delete (yyvsp[(2) - (2)].Chaine);
;}
    break;

  case 218:

/* Line 1464 of yacc.c  */
#line 1441 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Instruction::BlocSP bloc((yyvsp[(2) - (4)].Bloc));
	(yyval.Controle_Try) = new Traceur::Donnees::Instruction::Try(bloc,*((yyvsp[(3) - (4)].Clauses_Catch)),position);
	delete (yyvsp[(3) - (4)].Clauses_Catch);
;}
    break;

  case 219:

/* Line 1464 of yacc.c  */
#line 1449 "analyseur.syn.ypp"
    {
	(yyval.Clauses_Catch)=new Traceur::Donnees::Instruction::Try::ClausesCatch();
	(yyval.Clauses_Catch)->push_back(*((yyvsp[(1) - (1)].Clause_Catch)));
	delete (yyvsp[(1) - (1)].Clause_Catch);
;}
    break;

  case 220:

/* Line 1464 of yacc.c  */
#line 1455 "analyseur.syn.ypp"
    {
	(yyval.Clauses_Catch)=new Traceur::Donnees::Instruction::Try::ClausesCatch();
	(yyval.Clauses_Catch)->push_back(*((yyvsp[(1) - (1)].Clause_Catch)));
	delete (yyvsp[(1) - (1)].Clause_Catch);
;}
    break;

  case 221:

/* Line 1464 of yacc.c  */
#line 1461 "analyseur.syn.ypp"
    {
	(yyval.Clauses_Catch) = (yyvsp[(2) - (2)].Clauses_Catch);
	(yyval.Clauses_Catch)->push_front(*((yyvsp[(1) - (2)].Clause_Catch)));
	delete (yyvsp[(1) - (2)].Clause_Catch);
;}
    break;

  case 222:

/* Line 1464 of yacc.c  */
#line 1468 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Instruction::BlocSP bloc((yyvsp[(5) - (5)].Bloc));
	(yyval.Clause_Catch) = new Traceur::Donnees::Instruction::Try::ClauseCatch(*((yyvsp[(3) - (5)].Liste_Erreur)),bloc);
	delete (yyvsp[(3) - (5)].Liste_Erreur);
;}
    break;

  case 223:

/* Line 1464 of yacc.c  */
#line 1475 "analyseur.syn.ypp"
    {
	(yyval.Liste_Erreur) = new Traceur::Donnees::Instruction::Try::ListeErreur();
	(yyval.Liste_Erreur)->push_back(*((yyvsp[(1) - (1)].Chaine)));
	delete (yyvsp[(1) - (1)].Chaine);
;}
    break;

  case 224:

/* Line 1464 of yacc.c  */
#line 1481 "analyseur.syn.ypp"
    {
	(yyval.Liste_Erreur) = (yyvsp[(1) - (3)].Liste_Erreur);
	(yyval.Liste_Erreur)->push_back(*((yyvsp[(3) - (3)].Chaine)));
	delete (yyvsp[(3) - (3)].Chaine);
;}
    break;

  case 225:

/* Line 1464 of yacc.c  */
#line 1488 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Instruction::BlocSP bloc((yyvsp[(2) - (2)].Bloc));
	(yyval.Clause_Catch) = new Traceur::Donnees::Instruction::Try::ClauseCatch(Traceur::Donnees::Instruction::Try::ListeErreur(),bloc);
;}
    break;

  case 226:

/* Line 1464 of yacc.c  */
#line 1494 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Couleur::Hexa(*((yyvsp[(1) - (1)].Chaine)));
	delete (yyvsp[(1) - (1)].Chaine);
;}
    break;

  case 227:

/* Line 1464 of yacc.c  */
#line 1499 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Couleur::Noir();
;}
    break;

  case 228:

/* Line 1464 of yacc.c  */
#line 1503 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Couleur::Gris();
;}
    break;

  case 229:

/* Line 1464 of yacc.c  */
#line 1507 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Couleur::Blanc();
;}
    break;

  case 230:

/* Line 1464 of yacc.c  */
#line 1511 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Couleur::Rouge();
;}
    break;

  case 231:

/* Line 1464 of yacc.c  */
#line 1515 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Couleur::Vert();
;}
    break;

  case 232:

/* Line 1464 of yacc.c  */
#line 1519 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Couleur::Bleu();
;}
    break;

  case 233:

/* Line 1464 of yacc.c  */
#line 1523 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Couleur::Magenta();
;}
    break;

  case 234:

/* Line 1464 of yacc.c  */
#line 1527 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Couleur::Cyan();
;}
    break;

  case 235:

/* Line 1464 of yacc.c  */
#line 1531 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Couleur::Jaune();
;}
    break;

  case 236:

/* Line 1464 of yacc.c  */
#line 1535 "analyseur.syn.ypp"
    {
	(yyval.Expression) = new Traceur::Donnees::Expression::Couleur::Transparent();
;}
    break;

  case 237:

/* Line 1464 of yacc.c  */
#line 1540 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP nom_fichier(cache_objets((yyvsp[(3) - (3)].Expression)));
	(yyval.Controle_Read) = new Traceur::Donnees::Instruction::Read(nom_fichier,position);
;}
    break;

  case 238:

/* Line 1464 of yacc.c  */
#line 1546 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	Traceur::Donnees::Expression::ExpressionSP image(cache_objets((yyvsp[(2) - (4)].Expression)));
	Traceur::Donnees::Expression::ExpressionSP nom_fichier(cache_objets((yyvsp[(4) - (4)].Expression)));
	(yyval.Controle_Write) = new Traceur::Donnees::Instruction::Write(image,nom_fichier,position);
;}
    break;

  case 239:

/* Line 1464 of yacc.c  */
#line 1554 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	(yyval.Controle_Dpt) = new Traceur::Donnees::Instruction::Dpt(position);
;}
    break;

  case 240:

/* Line 1464 of yacc.c  */
#line 1560 "analyseur.syn.ypp"
    {
	Traceur::Donnees::Source::PositionSP position((yyloc));
	(yyval.Controle_Idpt) = new Traceur::Donnees::Instruction::Idpt(position);
;}
    break;



/* Line 1464 of yacc.c  */
#line 5830 "analyseur.syn.cpp"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (bloc_principal, cache_objets, YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (bloc_principal, cache_objets, yymsg);
	  }
	else
	  {
	    yyerror (bloc_principal, cache_objets, YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, bloc_principal, cache_objets);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, bloc_principal, cache_objets);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (bloc_principal, cache_objets, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc, bloc_principal, cache_objets);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, bloc_principal, cache_objets);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1684 of yacc.c  */
#line 1564 "analyseur.syn.ypp"


int parseurlex_destroy();

int parseurerror(Traceur::Donnees::Instruction::BlocSP bloc, Traceur::Donnees::Global::CacheObjetGenerique& cache, std::string mesg)
{
	std::ostringstream oss;
	oss << mesg << "." ;
	throw Traceur::Exception::ErreurDeSyntaxe(parseurlloc,oss.str());
}


